#include "bits/stdc++.h"

using namespace std;

struct flex {
    set<pair<int, int>> st;
    map<int, array<int, 2>> d;
    int cnt = 0;

    void add(int x, int y) {
        cnt -= max(d[x][0], d[x][1]);
        if (st.find({x, y}) == st.end()) {
            st.insert({x, y});
            d[x][y % 2]++;
        }
        cnt += max(d[x][0], d[x][1]);
    }

    int get() {
        return cnt;
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q;
    cin >> q;
    flex a, b, c, d;
    while (q--) {
        int x, y;
        cin >> x >> y;
        if (x % 2 == 0) {
            a.add(x, y);
        } else {
            b.add(x, y);
        }
        if (y % 2 == 0) {
            c.add(y, x);
        } else {
            d.add(y, x);
        }
        cout << max({a.get(), b.get(), c.get(), d.get()}) << '\n';
    }
}