#include<bits/stdc++.h>

#define sz(v) (int)v.size()

using namespace std;

const int inf = (int)1e9 + 7;
const int N = (int)1e3 + 7;
const int MOD = (int)1e9 + 7;

int sum(int x, int y) {
    x += y;
    if(x >= MOD) {
        x -= MOD;
    }
    return x;
}

int mult(int x, int y) {
    return 1ll*x*y%MOD;
}

int n, a[N][N];
long long c[N], d[N];

int main() {
    ios_base::sync_with_stdio(NULL);
    cin.tie(0);
    cin >> n;
    long long o = 0;
    for(int i = 1; i <= n; ++i) {
        for(int j = 1; j <= n; ++j) {
            cin >> a[i][j];
            c[i] += a[i][j];
        }
        o += c[i];
    }
    for(int j = 1; j <= n; ++j) {
        for(int i = 1; i <= n; ++i) {
            d[j] += a[i][j];
        }
    }
    assert(o % n == 0);
    long long need = o/n;
    vector<int> v1, v2;
    for(int i = 1; i <= n; ++i) {
        if(c[i] != need) {
            v1.push_back(i);
        }
    }
    for(int i = 1; i <= n; ++i) {
        if(d[i] != need) {
            v2.push_back(i);
        }
    }
    assert(sz(v1) <= 2);
    assert(sz(v2) <= 2);
    if(sz(v1) == 2 && sz(v2) == 2) {
        cout << v1[0] << ' ' << v2[0] << "\n";
        cout << v1[1] << ' ' << v2[1] << "\n";
    } else if(sz(v1) == 0) {
        assert(sz(v2) == 2);
        for(int x1 = 1; x1 <= n; ++x1) {
            int y1 = v2[0], y2 = v2[1];
            if(d[y1] - a[x1][y1] + a[x1][y2] == need && d[y2] - a[x1][y2] + a[x1][y1] == need) {
                cout << x1 << ' ' << y1 << "\n";
                cout << x1 << ' ' << y2 << "\n";
                return 0;
            }
        }
    } else if(sz(v2) == 0) {
        assert(sz(v1) == 2);
        for(int y1 = 1; y1 <= n; ++y1) {
            int x1 = v1[0], x2 = v1[1];
            if(c[x1] - a[x1][y1] + a[x2][y1] == need && c[x2] - a[x2][y1] + a[x1][y1] == need) {
                cout << x1 << ' ' << y1 << "\n";
                cout << x2 << ' ' << y1 << "\n";
                return 0;
            }
        }
    }
    return 0;
}
