#include <bits/stdc++.h>

#define ll long long
#define int ll
#define sz(s) (int)s.size()
#define all(x) x.begin(), x.end()
#define pb push_back

using namespace std;

int a[1001][1001], n;

bool check(){
    set<int> q;
    for(int i=1; i<=n; i++){
        ll sum1=0, sum2=0;
        for(int j=1; j<=n; j++){
            sum1 += a[i][j];
            sum2 += a[j][i];
        }
        q.insert(sum1);
        q.insert(sum2);
    }
    if(q.size() == 1) return 1;
    return 0;
}

void solve(){
    cin>>n;
    for(int i=1; i<=n; i++){
        for(int j=1; j<=n; j++){
            cin>>a[i][j];
        }
    }
    if(n <= 10){
        for(int i=1; i<=n; i++){
            for(int j=1; j<=n; j++){
                for(int x=1; x<=n; x++){
                    for(int y=1; y<=n; y++){
                        swap(a[i][j], a[x][y]);
                        if(check()){
                            cout<<i<<' '<<j<<'\n';
                            cout<<x<<' '<<y;
                            return;
                        }
                        swap(a[i][j], a[x][y]);
                    }
                }
            }
        }
        return;
    }
    map<int, int> q;
    for(int i=1; i<=n; i++){
        ll sum1=0, sum2=0;
        for(int j=1; j<=n; j++){
            sum1 += a[i][j];
            sum2 += a[j][i];
        }
        q[sum2] ++;
        q[sum1] ++;
    }
    vector<int> x, y;
    int nx, ny, ns;
    for(int i=1; i<=n; i++){
        ll sum1=0, sum2=0;
        for(int j=1; j<=n; j++){
            sum1 += a[i][j];
            sum2 += a[j][i];
        }
        if(q[sum1] != n) x.pb(i);
        else ns = sum1;
        if(q[sum2] != n) y.pb(i);
    }
    if(x.size() == 2 and y.size() == 2){
        sort(all(x));
        sort(all(y));
        swap(a[x[0]][y[0]], a[x[1]][y[1]]);
        if(check()){
            cout<<x[0]<<' '<<y[0]<<'\n';
            cout<<x[1]<<' '<<y[1]<<'\n';
            return;
        }
        swap(a[x[0]][y[0]], a[x[1]][y[1]]);

        swap(a[x[1]][y[0]], a[x[0]][y[1]]);
        if(check()){
            cout<<x[1]<<' '<<y[0]<<'\n';
            cout<<x[0]<<' '<<y[1]<<'\n';
            return;
        }
        swap(a[x[1]][y[0]], a[x[0]][y[1]]);
        return;
    }
    if(x.size() == 2){
        ll sum1 = 0;
        for(int j=1; j<=n; j++){
            sum1 += a[x[0]][j];
        }
        for(int j=1; j<=n; j++){
            if(sum1 - a[x[0]][j] + a[x[1]][j] == ns){
                cout<<x[0]<<' '<<j<<'\n';
                cout<<x[1]<<' '<<j<<'\n';
                return;
            }
        }
        return;
    }
    else{
        ll sum1 = 0;
        for(int i=1; i<=n; i++){
            sum1 += a[i][y[0]];
        }
        for(int i=1; i<=n; i++){
            if(sum1 - a[i][y[0]] + a[i][y[1]] == ns){
                cout<<i<<' '<<y[0]<<'\n';
                cout<<i<<' '<<y[1]<<'\n';
                return;
            }
        }
        return;
    }

}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
    // cin >> t;
    while(tt --){
        solve();
    }
}
