#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>

#if __cplusplus >= 201103L
#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#endif

using namespace std;

#define int long long
#define pii pair<int, int>
#define f first
#define s second
#define pb push_back

struct test
{
    vector<vector<int>> tree;
    vector<multiset<pii>> bad;
    vector<int> minD, D, mxG;
    int res = 1;

    void dfs(int v)
    {
        if (tree[v].size() == 0)
            minD[v] = D[v];
        for (int tov : tree[v])
        {
            D[tov] = D[v] + 1;
            dfs(tov);
            mxG[v] = max(mxG[v], mxG[tov]);
            minD[v] = min(minD[v], minD[tov]);
            // if (bad[tov].size() > bad[v].size())
            //     swap(bad[tov], bad[v]);
            for (pii el : bad[tov])
                bad[v].insert(el);
            // bad[tov].clear();
        }
        if (tree[v].size() > 0)
        {
            while (bad[v].size() && -(bad[v].begin()->f) > minD[v])
            {
                mxG[v] = max(mxG[v], bad[v].begin()->s);
                bad[v].erase(bad[v].begin());
            }
        }
        if (v == 0)
            res = max(res, 1 + mxG[v]);
        bad[v].insert({-D[v], 1 + mxG[v]});
    }

    void solve()
    {
        ios_base::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);

        int n;
        cin >> n;
        tree.resize(n);
        mxG.resize(n);
        bad.resize(n);
        minD.resize(n, 1e9);
        D.resize(n);
        for (int i = 1; i < n; ++i)
        {
            int p;
            cin >> p;
            --p;
            tree[p].pb(i);
        }

        dfs(0);
        cout << res << "\n";
    }
};

main()
{
    test t;
    t.solve();
    return 0;
}