#include <bits/stdc++.h>
using namespace std;
const int maxn = 2e5 + 100;

int n;
int a[maxn];
struct asd{
    vector<vector<int>> dp;
    int sz, f, s;
} d[maxn * 4];

asd f(asd a, asd b){
    if(!a.sz) return b;
    if(!b.sz) return a;
    asd c;
    c.dp = {{0, 0}, {0, 0}};
    c.sz = a.sz + b.sz;
    c.f = a.f; c.s = b.s;
    for(int l = 0; l < 2; l++){
        for(int r = 0; r < 2; r++){
            if(l + r > c.sz) continue;
            if(l <= a.sz && r <= b.sz) c.dp[l][r] |= (a.dp[l][0] & b.dp[0][r]);
            if(l < a.sz && r < b.sz && a.s + b.f == 1) c.dp[l][r] |= (a.dp[l][1] & b.dp[1][r]);
        }
    }
    return c;
}

void build(int v = 1, int tl = 1, int tr = n){
    if(tl == tr){
        char c; cin >> c;
        a[tl] = c - 'a';
        d[v].dp = {{a[tl]^1, 1}, {1, 1}};
        d[v].sz = 1; d[v].f = d[v].s = a[tl];
    } else{
        int mid = (tl + tr) >> 1;
        build(v<<1, tl, mid);
        build(v<<1|1, mid+1, tr);
        d[v] = f(d[v<<1], d[v<<1|1]);
    }
}

void upd(int i, int v = 1, int tl = 1, int tr = n){
    if(tl == tr){
        a[tl] ^= 1;
        d[v].dp = {{a[tl]^1, 1}, {1, 1}};
        d[v].sz = 1; d[v].f = d[v].s = a[tl];
    } else{
        int mid = (tl + tr) >> 1;
        if(i <= mid) upd(i, v<<1, tl, mid);
        else upd(i, v<<1|1, mid+1, tr);
        d[v] = f(d[v<<1], d[v<<1|1]);
    }
}

asd get(int l, int r, int v = 1, int tl = 1, int tr = n){
    if(tr < l || tl > r){
        return {{{}, {}}, 0, 0, 0};
    } if(l <= tl && tr <= r) return d[v];
    int mid = (tl + tr) >> 1;
    return f(get(l, r, v<<1, tl, mid)
    , get(l, r, v<<1|1, mid+1, tr));
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    cin >> n; build();
    int q; cin >> q;
    while(q--){
        int t, l, r;
        cin >> t >> l;
        if(t == 1) upd(l);
        else{ cin >> r;
            if(get(l, r).dp[0][0]) cout << "YES\n";
            else cout << "NO\n";
        }
    }
}
