#include <bits/stdc++.h>
using namespace std;
const int maxn = 1e5 + 100;

int n;
int a[maxn];
struct asd{
    int dp00, dp01, dp10, dp11;
    int sz, f, s;
} d[maxn * 4];

asd f(asd a, asd b){
    if(!a.sz) return b;
    if(!b.sz) return a;
    asd c = {0, 0, 0, 0, a.sz+b.sz, a.f, b.s};
    c.dp00 |= a.dp00 & b.dp00;
    c.dp10 |= a.dp10 & b.dp00;
    c.dp01 |= a.dp00 & b.dp01;
    c.dp11 |= a.dp10 & b.dp01;
    if((a.s ^ b.f)) {
        c.dp00 |= a.dp01 & b.dp10;
        if (a.sz > 1) c.dp10 |= a.dp11 & b.dp10;
        if (b.sz > 1) c.dp01 |= a.dp01 & b.dp11;
        if (a.sz > 1 && b.sz > 1) c.dp11 |= a.dp11 & b.dp11;
    }
    return c;
}

void build(int v = 1, int tl = 1, int tr = n){
    if(tl == tr){
        char c; cin >> c;
        a[tl] = c - 'a';
        d[v] = {a[tl]^1, 1, 1, 1, 1, a[tl], a[tl]};
    } else{
        int mid = (tl + tr) >> 1;
        build(v<<1, tl, mid);
        build(v<<1|1, mid+1, tr);
        d[v] = f(d[v<<1], d[v<<1|1]);
    }
}

void upd(int i, int v = 1, int tl = 1, int tr = n){
    if(tl == tr){
        a[tl] ^= 1;
        d[v] = {a[tl]^1, 1, 1, 1, 1, a[tl], a[tl]};
    } else{
        int mid = (tl + tr) >> 1;
        if(i <= mid) upd(i, v<<1, tl, mid);
        else upd(i, v<<1|1, mid+1, tr);
        d[v] = f(d[v<<1], d[v<<1|1]);
    }
}

asd get(int l, int r, int v = 1, int tl = 1, int tr = n){
    if(tr < l || tl > r){
        return {0, 0, 0, 0, 0, 0, 0};
    } if(l <= tl && tr <= r) return d[v];
    int mid = (tl + tr) >> 1;
    return f(get(l, r, v<<1, tl, mid)
            , get(l, r, v<<1|1, mid+1, tr));
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    cin >> n; build();
    int q; cin >> q;
    while(q--){
        int t, l, r;
        cin >> t >> l;
        if(t == 1) upd(l);
        else{ cin >> r;
            if(get(l, r).dp00) cout << "YES\n";
            else cout << "NO\n";
        }
    }
}