# include <bits/stdc++.h>
# define nl '\n'
# define pb push_back

using namespace std;
using ll = long long;

const ll N = 1e3+5;
const ll inf = (ll)2e18 + 7;
const ll mod = 1e9 + 7;

ll dp[50][1005];
ll pw[1005];
ll fact[1005];

ll binpow (ll x, ll n) {
    ll res = 1;
    while (n > 0) {
        if (n & 1) {
            res = (res * x) % mod;
        }
        x = (x * x) % mod;
        n >>= 1;
    }
    return res;
}

ll q (ll x) {
    return x * (x - 1) / 2;
}

ll f (ll x, ll n) {
    if (n == 0) return dp[x][n] = 1LL;
    if (n < x) return dp[x][n] = pw[n - 1];
    if (dp[x][n] != -1) return dp[x][n];
    ll m = n % x;
    ll k = n / x;
    ll res = pw[x * k + m - 1];
    for (ll i = k - 1; i >= 0; --i) {
        ll cur = f(x, x * i + m);
        res = (res - cur + mod) % mod;
    }
    return dp[x][n] = res;
}

void ma1n () {
    ll n;
    cin >> n;
    pw[0] = 1;
    fact[0] = 1;
    for (ll i = 1; i <= n; ++i) {
        pw[i] = pw[i - 1] * 2LL % mod;
        fact[i] = fact[i - 1] * i % mod;
    }
    memset(dp, -1, sizeof dp);
    ll ans = 0;
    for (ll k = 1; k <= n / 2; ++k) {
        ll cur = fact[n - k - 1] * binpow(fact[k - 1], mod - 2) % mod;
        cur = cur * binpow(fact[n - (k + k)], mod - 2) % mod;
        ans = (ans + cur) % mod;
        //cout << k << ' ' << cur << nl;
    }
    for (ll x = 2; x <= 44; ++x) {
        if (n - q(x) < 0) {
            break;
        }
       // cout << "x " << x << ' ' <<f(x, n - q(x)) << nl;
        ll cur = f(x, n - q(x)) * x % mod;
        ans = (ans + cur) % mod;
    }
    cout << ans << nl;
}

signed main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    ma1n();
    return 0;
}
