#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll mod = 1e9 + 7;

ll add(ll a, ll b) {
    if (a + b >= mod) {
        return a + b - mod;
    } else {
        return a + b;
    }
}

ll proiz(ll a, ll b) {
    return (a * b) % mod;
}

pair<ll, ll> resh(ll a, ll b) {
    if (b == 1) {
        return {0, -1};
    } else if (a == 1) {
        return {1, 0};
    }
    if (a > b) {
        pair<ll, ll> k = resh(a % b, b);
        return {k.first, k.second + ((a / b) * k.first)};
    } else {
        pair<ll, ll> k = resh(a, b % a);
        return {k.first + ((b / a) * k.second) , k.second + (a / b)};
    }
}

ll pwr(ll a, ll p) {
    if (p == 0) {
        return 1;
    }
    if (p % 2) {
        return a * pwr(a, p - 1);
    } else {
        ll t = pwr(a, p / 2);
        return t * t;
    }
}

void solve() {
    ll n, sum = 0;
    cin >> n;
    vector<ll> a(n);
    vector<ll> fact(n+1);
    fact[0] = 1;
    for (ll i = 1; i <= n; ++i) {
        fact[i] = proiz(fact[i-1], i);
    }
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
        sum += a[i];
    }
    if (sum % 3 == 0) {
        cout << 0;
    } else {
        vector<ll> cnt(3);
        for (auto to: a) {
            cnt[to % 3]++;
        }
        ///////////////////////////////////////////////////
        vector<ll> sc = cnt;
        ll last = 1, now = 1, ans = 0;
        sc[1]--;
        while (sc[now] > 0) {
            sc[now]--;
            if (last == 1 && now == 1) {
                now = 2;
            } else if (last == 1) {
                now = 1;
                last = 2;
            } else {
                now = 1;
                last = 1;
            }
        }
        if (sc[1] == 0 && sc[2] == 0) {
            ans = 1;
            for (ll i = 0; i < cnt[0]; ++i) {
                ans = proiz(ans, cnt[1] + cnt[2] + i);
            }
        }
        //////////////////////////////////////////////////////////////
        sc = cnt;
        last = 2, now = 2;
        sc[2]--;
        while (sc[now] > 0) {
            sc[now]--;
            if (now == 2) {
                now = 1;
                last = 2;
            } else if (last == 2) {
                now = 2;
                last = 1;
            }
        }
        if (sc[1] == 0 && sc[2] == 0) {
            if (ans == 0) {
                ans = 1;
            }
            for (ll i = 0; i < cnt[0]; ++i) {
                ans = proiz(ans, cnt[1] + cnt[2] + i);
            }
        }
        ///////////////////////////////////////////
        cout << proiz(ans, proiz(fact[cnt[1]] ,fact[cnt[2]]));
    }
}

void solution() {
    ll kx;
    cin >> kx;
    ll d1 = 0, r = 1000000000000;
    ll k;
    while (r - d1 > 1) {
        ll m = (r + d1) / 2;
        cout << "? " << m << endl;
        cin >> k;
        if (k > kx) {
            r = m;
        } else {
            d1 = m;
        }
    }
    ++d1;
    ll d2 = 0;
    r = 1000000000000000;
    while (r - d2 > 1) {
        ll m = (r + d2) / 2;
        cout << "? " << m << endl;
        cin >> k;
        if (k > kx + 1) {
            r = m;
        } else {
            d2 = m;
        }
    }
    ++d2;
    ll N = d2 - d1;
    ll b = 0;
    for (ll M = 0; M < 2023; ++M) {
        if ((M - 1) * pwr(M, kx) == N) {
            b = M;
        }
    }
    cout << "! " << pwr(b, kx) - d1 << " " << b << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}