#include <iostream>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <iomanip>
#include <cstdint>
#include <cassert>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> ii;
typedef pair<long long, long long> llll;
typedef vector<int> vi;
typedef vector<long long> vll;

const ll MOD = 1e9 + 7;

void solve() {
    int n;
    cin >> n;
    vector<vector<ll>> dp1(n + 1, vector<ll>(n + 1, 0));
    vector<vector<ll>> dps(n + 3, vector<ll>(n + 3, 0));
    vector<vector<ll>> dp2(n + 2, vector<ll>(n + 2, 0));
    for (int i = 0; i <= n; ++i) {
        dp1[i][i] = 1;
    }
    for (int i = 1; i <= n; ++i) {
        dp1[1][i] = 1;
    }
    for (int x = 2; x <= n; ++x) {
        for (int s = x; s <= n; ++s) {
            dp1[x][s] = (dp1[x][s-x] + dp1[x-1][s-x]) % MOD;
        }
    }
    dps[n + 2][0] = 1;
    dps[n + 1][0] = 1;
    dps[0][0] = 1;
    for (int x = n; x >= 1; --x) {
        dps[x][0] = 1;
        dp2[x][x] = 1;
        dps[x][x] = (dps[x + 1][x] + 1) % MOD;
        for (int s = x + 1; s <= n; ++s) {
            dp2[x][s] = dps[x][s - x];
            dps[x][s] = (dps[x + 1][s] + dp2[x][s]) % MOD;
        }
    }
    ll ans = 0;
    for (int x = 1; x <= n + 1; ++x) {
        for (int s = 0; s <= n; ++s) {
            ans = (ans + ((dp1[x - 1][s] * dps[x + 1][n - s]) % MOD) * x) % MOD;
        }
    }
    cout << ans << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#endif
    int tests = 1;
    // cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
}