#include <bits/stdc++.h>
#ifndef Local
#define debug(...) 1337
#define endl '\n'
#endif

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;

#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()

template <typename T, typename U>
bool smin(T& a, U b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template <typename T, typename U>
bool smax(T& a, U b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> dp(n, vector<int> (n + 1));
    const int mod = (int)1e9 + 7;
    int ans = 1;
    dp[0][0] = 1;
    for (int i = 1; i < n; ++i) {
        dp[i][0] = 1;
        dp[i][1] = 1;
        for (int j = 2; j <= n; ++j) {
            dp[i][j] = (dp[i - 1][j - 2] + dp[i - 1][j - 1] + dp[i - 1][j]) % mod;
        }
        ans = ans * dp[i][i + 1] % mod;
    }
    cout << ans << endl;
}

signed main() {
	ios::sync_with_stdio(false), cin.tie(nullptr);

	int tt = 1;
//	cin >> tt;
	while (tt--)
		solve();

	return 0;
}
