#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define fi first
#define se second
#define pb push_back

const ll MOD = 1'000'000'000 + 7;
const ll INF = 1e14;

ll bin_pow(ll n, ll k)
{
    if (k == 1) return n;
    if (k == 0) return 1;

    if (k % 2 == 0) {
        ll ans = bin_pow(n, k / 2);
        if (INF / ans <= ans)
        {
            return -1;
        }
        ans *= ans;
        return ans;
    } else {
        ll ans = n * bin_pow(n, k - 1);
        if (ans >= INF)
        {
            return -1;
        }
        return ans;
    }
}

int req(ll d)
{
    cout << "? " << d << endl;
    int an;
    cin >> an;
    return an;
}

void solve()
{
    int n1;
    cin >> n1;
    ll l = 0, r = 1'000'000'001ll * 2023;
    while (r - l > 1)
    {
        ll m = (r + l) / 2;
        int an = req(m);
        if (an > n1)
        {
            r = m;
        }
        else
        {
            l = m;
        }
    }
    ll d1 = r;
    int n2 = n1 + 1;
    l = 0, r = 2'000'000'001ll * 2023 * 2023;
    while (r - l > 1)
    {
        ll m = (r + l) / 2;
        int an = req(m);
        if (an > n2)
        {
            r = m;
        }
        else
        {
            l = m;
        }
    }
    ll d2 = r;
    for (ll b = 2; b <= 2023; b++)
    {
        if (d2 - d1 == (b - 1) * bin_pow(b, n2 - 1))
        {
            ll x = bin_pow(b, n1) - d1;
            cout << "! " << x << ' ' << b << endl;
            return;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }
    return 0;
}
