#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

#define fi first
#define se second
#define pb push_back

const ll MOD = 1'000'000'000 + 7;

ll bin_pow(ll n, ll k)
{
    if (k == 1) return n;
    if (k == 0) return 1;

    if (k % 2 == 0) {
        ll ans = bin_pow(n, k / 2);
        return ans * ans % MOD;
    } else {
        return n * bin_pow(n, k - 1) % MOD;
    }
}

void solve()
{
    ll n;
    cin >> n;

    ll cnt0 = 0;
    ll cnt1 = 0;
    ll cnt2 = 0;
    for (int i = 0; i < n; i++)
    {
        ll a;
        cin >> a;
        if (a % 3 == 0)
        {
            cnt0++;
        }
        else if (a % 3 == 1)
        {
            cnt1++;
        }
        else
        {
            cnt2++;
        }
    }
    vector <ll> fact(n + 1);
    vector <ll> inv_fact(n + 1, 1);
    fact[0] = 1;
    for (ll i = 1; i <= n; i++)
    {
        fact[i] = fact[i - 1] * i % MOD;
        inv_fact[i] = bin_pow(fact[i], MOD - 2);
    }

    ll an1 = fact[n - 1] * inv_fact[cnt1 + cnt2 - 1] % MOD * inv_fact[n - cnt1 - cnt2] % MOD;
    ll an2 = fact[cnt1] * fact[cnt2] % MOD * fact[cnt0] % MOD;
    ll ans = an1 * an2 % MOD;
    ll t = 0;
    if (abs(cnt1 - 1 - cnt2) <= 1)
    {
        t++;
    }
    if (abs(cnt2 - 1 - cnt1) <= 1)
    {
        t++;
    }
    cout << ans * t % MOD;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
    }
    return 0;
}
