#include <bits/stdc++.h>

using namespace std;
#define int int_fast64_t

mt19937 rnd(23);
const int MOD = 1e9 + 7;
const int INF = 2e18;

vector<vector<int>>gr;
vector<pair<int,int>>minh;
vector<pair<int,int>>maxh;
vector<int>ha;

void hh(int v, int h) {
    ha[v] = h;
    int k = 0;
    for (int i : gr[v]) {
        hh(i,h + 1);
        k++;
        minh[v] = min(minh[v], minh[i]);
        maxh[v] = max(maxh[v], maxh[i]);
    }
    if (k == 0) {
        minh[v] = {h, v};
        maxh[v] = {h,v};
    }
}

vector<int>ans;
vector<int>mx;
void dfs(int v) {
    int k = 0;
    for (int i : gr[v]) {
        k++;
        dfs(i);
    }
    if (k == 0) {
        ans[v] = 1;
        mx[ha[v]] = max(mx[ha[v]], ans[v]);
        return;
    } else {
        int gl = minh[v].first;
        if (maxh[v] == minh[v]) {
            ans[v] = mx[gl];
        } else {
            ans[v] = mx[gl] + 1;
        }
        mx[ha[v]] = max(mx[ha[v]], ans[v]);
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    ans.resize(n);
    ha.resize(n);
    gr.resize(n);
    for (int i = 0; i < n-1; i++) {
        int a;
        cin >> a;
        a--;
        gr[a].push_back(i + 1);
    }
    minh.resize(n,{INF, INF});
    maxh.resize(n,{-INF,-INF});
    mx.resize(n, -INF);
    hh(0,0);
    dfs(0);
    cout << ans[0];
    return 0;
}
