#pragma fastO3
#include <bits/stdc++.h>

using ll = long long;

#define ff first
#define ss second

const int MAXN = 2e5;

std::vector<int>g[MAXN];
int h[MAXN];
int dp[MAXN];
int l[MAXN];
std::vector<int>H[MAXN];
int tin[MAXN];
int tout[MAXN];
int T = 0;

void dfs1(int v) {
    tin[v] = T++;
    H[h[v]].push_back(v);
    for (auto i : g[v]) {
        h[i] = h[v] + 1;
        dfs1(i);
        l[v] = std::min(l[i] + 1, l[v]);
    }
    if (g[v].empty()) {
        l[v] = 0;
    }
    tout[v] = T++;
}

void dfs2(int v) {
    for (auto i : g[v]) {
        dfs2(i);
    }
    if (g[v].empty()) {
        return;
    }
    for (const auto &item: H[h[v] + l[v]]) {
        if (tin[v] < tin[item] && tout[v] > tout[item]) {
            dp[v] = std::max(dp[v], dp[item]);
        }
    }
    dp[v]++;
}

void solve() {
    int n; std::cin >> n;
    for (int i = 0; i < n; ++i) {
        l[i] = n + 1;
    }
    for (int i = 1; i <= n - 1; ++i) {
        int p; std::cin >> p;
        g[p - 1].push_back(i);
    }
    dfs1(0);
    dfs2(0);
    std::cout << dp[0] << '\n';
}

int main() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    int t = 1;

    while (t--) {
        solve();
    }

    return 0;
}