#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int MAXN = 2e5;

vector<int> g[MAXN];
vector<int> dp(MAXN);

void dfs(int v = 0, int p = -1) {
    vector<int> sons;
    for (auto u : g[v]) {
        if (u != p) {
            dfs(u, v);
            sons.emplace_back(u);
        }
    }
    if (sons.empty()) {
        dp[v] = 1;
    } else {
        int cnt_list = 0;
        for (auto u : g[v]) {
            if (g[u].empty()) {
                cnt_list++;
            }
        }
        for (auto u : g[v]) {
            int val = dp[u] + cnt_list;
            if (g[u].empty()) {
                val--;
            }
            dp[v] = max(dp[v], val);
        }
    }
}

void solve() {
    int n;
    cin >> n;
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;
        g[p].emplace_back(i);
    }
    dfs();
    cout << dp[0] << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while(t--) {
        solve();
    }
}