#include <bits/stdc++.h>

using namespace std;
#define int long long
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
const int N = 2e5 + 100;
const int INF = 1e18;
int dp[N];
int dpMnl[N];
vector<int> G[N];
int d[N];
vector<int> D[N];
void dfs(int v, int p) {
    D[d[v]].push_back(v);
    for(auto u : G[v]) {
        if(u == p) {
            continue;
        }
        d[u] = d[v] + 1;
        dfs(u,v);
        dpMnl[v] = min(dpMnl[u] + 1, dpMnl[v]);
    }
}
set<pair<int,int>> S[N];
void add(int v, pair<int,int> x) {
    auto t = S[v].lower_bound({x.first, -INF});
    if(t == S[v].end() || (*t).first != x.first) {
        S[v].insert(x);
    } else {
        S[v].erase(t);
        S[v].insert(x);
    }
}
int get(int v, int d) {
    auto t = S[v].lower_bound({d, -INF});
    if(t == S[v].end() || (*t).first != d) {
        return 0ll;
    } else {
        return (*t).second;
    }
}
void dfs2(int v, int p) {
    for(auto u : G[v]) {
        if(u == p)continue;
        dfs2(u,v);
        if(S[u].size() > S[v].size()) {
            S[u].swap(S[v]);
        }
        for(auto x : S[u]) {
            add(v, x);
        }
        S[u].clear();
    }
    int col = 0;
    for(auto u : G[v]) {
        if(u == p)continue;
        col++;
        dp[v] = max(dp[v], dp[u]);
        int needD = d[v] + dpMnl[v];
        if(needD < N) {
            dp[v] = max(dp[v], 1 + get(v, needD));
        }
    }
    if(col != 0) {
        S[v].insert({d[v], dp[v]});
    }
}
void solve() {
    int n;
    cin >> n;
    for(int i =2; i<= n; i++) {
        int x;
        cin >> x;
        G[i].push_back(x);
        G[x].push_back(i);
    }
    for(int i = 1; i <=n;i++) {
        if(G[i].size() > 1 || i == 1) {
            dpMnl[i] = INF;
        } else {
            dp[i] = 1;
        }
    }
    dfs(1,-1);
    dfs2(1,-1);
    cout << dp[1] << endl;

}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}