#include <bits/stdc++.h>

using namespace std;
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

constexpr int MOD = 1e9 + 7;

int add(int a, int b) {
    if ((a += b) >= MOD) {
        a -= MOD;
    }
    return a;
}

int mul(int a, int b) {
    return 1LL * a * b % MOD;
}

void solve() {
    int n;
    cin >> n;

    constexpr int K = 71;
    vector pre(n + 1, vector(K + 1, vector<int>(n + 1)));
    for (int last = 1; last <= n; last++) {
        pre[0][1][last] = 1;
    }
    for (int sum = 1; sum <= n; sum++) {
        for (int mex = 1; mex <= K; mex++) {
            for (int last = 1; last <= n; last++) {
                if (last + 1 < mex || last == mex) {
                    pre[sum][mex][last] = pre[sum][mex][last - 1];
                    continue;
                }
                if (sum < last) {
                    pre[sum][mex][last] = pre[sum][mex][last - 1];
                    continue;
                }
                if (mex == last + 1) {
                    pre[sum][mex][last] = add(pre[sum][mex][last - 1], add(pre[sum - last][mex][last], pre[sum - last][mex - 1][last]));
                } else {
                    pre[sum][mex][last] = add(pre[sum][mex][last - 1], pre[sum - last][mex][last]);
                }
            }
        }
    }
    int ans = 0;
    for (int mex = 1; mex <= K; mex++) {
        ans = add(ans, mul(mex, pre[n][mex][n]));
    }

    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}