
#include <bits/stdc++.h>
#define int ll

using namespace std;

typedef long long ll;
const int N = 1e5 + 10;
const int mod = 1e9 + 7;

int dp[1002][1002];
int pref[1002][1002];
int lim;

ll get(int i , int j , int l , int r)
{
    ll sum = pref[j][r];
    if(l > r || i > j)
    {
        return 0;
    }
    if(l > 0)
    {
        sum -= pref[j][l - 1];
    }
    if(i > 0)
    {
        sum -= pref[i - 1][r];
    }
    if(l > 0 && i > 0)
    {
        sum += pref[i - 1][l - 1];
    }
    return sum;
}

int solve(int mex)
{
    //cout << mex << endl;
    if(mex * (mex - 1) / 2 > lim)
    {
        return 0;
    }
    int n = lim - (mex - 1) * mex / 2;
    for(int i = 0;i <= n;++ i)
    {
        for(int j = 0;j <= n;++ j)
        {
            dp[i][j] = 0;
            pref[i][j] = 0;
        }
    }
    dp[0][0] = 1;
    pref[0][0] = 1;
    for(int i = 1;i <= n;++ i)
    {
        pref[0][i] = 1;
        pref[i][0] = 1;
    }
    for(int i = 1;i <= n;++ i)
    {
        for(int j = 1;j <= n;++ j)
        {
            pref[i][j] = pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1];
            if(j <= i)
            {
                dp[i][j] += get(max(0ll, i - j) , i - 1 , 0 , j);
                if(i - mex >= 0 && mex <= j)
                {
                    dp[i][j] -= get(i - mex , i - mex , 0 , j);
                }
            }
            pref[i][j] += dp[i][j];
        }
    }
//    for(int i = 0;i <= n;++ i)
//    {
//        for(int j = 0;j <= n;++ j)
//        {
//            cout << pref[i][j] << ' ';
//        }
//        cout << endl;
//    }
//    cout << endl;
    return dp[n][n];
}


int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef LOCAL

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #endif
    int n;
    cin >> n;
    lim = n;
    ll answer = 0;
    for(int i = 0;i <= sqrt(3 * n);++ i)//sqrt(3 * n);++ i)
    {
        //cerr << i + 1 << ' ' << solve(i + 1) << endl;
        answer += (i + 1) * solve(i + 1);

    }


    cout << answer;
    return 0;
}
