#include "bits/stdc++.h"

using namespace std;

using ll = long long;
using ld = long double;
using pi = pair<int, int>;

ll mod = 1e9 + 7;

ll mult(ll a, ll b) {
    return a*b%mod;
}

ll binpow(ll a, int b) {
    if (b == 0) return 1;
    if (b == 1) return a;
    ll aa = binpow(mult(a,a), b/2);
    if (b % 2 == 0)
        return aa;
    return mult(aa, a);
}

ll rev(ll x) {
    return binpow(x, mod-2);
}

vector<ll> fa;
vector<ll> far;


ll cnk(ll n, ll k) {
    return mult(mult(fa[n], far[k]), far[n-k]);
}

ll ggg(ll x, ll a, ll b) {
    ll aa = mult(cnk(x, a), cnk(x-a, b));
    return aa;
}

ll calc(ll x) {
    ll a = 0;
    for (ll t2 = 1;; t2++) {
        ll b1 = x+1-t2*2;
        if (b1 < 0) break;
        a += ggg(x, b1, t2);
//        a = mult(a, cnk(x, b1));
//        a = mult(a, cnk(x-b1, t2));
    }
    return a % mod;
}

int main() {
    ios::sync_with_stdio(false); cin.tie(0);

    fa = {1, 1};
    for (int i = 0; i < 5010; i++)
        fa.emplace_back(mult(fa.back(), fa.size()));
    for (ll i : fa)
        far.emplace_back(rev(i));

    ll ans = 1;
    int n; cin >> n;
    for (int i = 2; i < n; i++)
        ans = mult(ans, calc(i));
    cout << ans;
}
