#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937_64 generator(seed);
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename V>
using table = gp_hash_table<T, V>;

using i128 = __int128;
using ll = long long;
using ld = long double;
const int MAX_N = 2e5+10;
int dp[MAX_N];

const int MOD = (int)1e9+7;
vector<int>graph[MAX_N];
bool is_list[MAX_N];
int h[MAX_N];
int h1[MAX_N];
void dfs(int v){
    if(!graph[v].size()){
        is_list[v] = true;
        dp[v] = 0;
        h[v] = 0;
        return;
    }
    h[v] = 1e9;
    h1[v] = 0;
    bool flag = false;
    int v_h = 0;

    for(auto c:graph[v]){
         dfs(c);
         h[v] = min(h[c]+1,h[v]);
         h1[v] = max(h1[v], h1[c]+1);
         if(is_list[c]) flag=true;
         if(dp[c]>dp[v]){
             v_h = c;
             dp[v] = dp[c];
         }
    }
    for(auto c:graph[v]){
        if(h[c]<h1[v_h]){
            flag = true;
        }
    }
    if(flag) dp[v]++;
}



void solve() {
    int n;
    cin>>n;
    for(int i = 2;i<=n;++i){
        int p;
        cin>>p;
        graph[p].push_back(i);
    }
    dfs(1);
    cout<<dp[1];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(6);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin>>t;
    while (t--) solve();
    //stress();
}