#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

auto seed = chrono::high_resolution_clock::now().time_since_epoch().count();
mt19937_64 generator(seed);
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<typename T, typename V>
using table = gp_hash_table<T, V>;

using i128 = __int128;
using ll = long long;
using ld = long double;
#define int ll
const int MOD = (int)1e9+7;

int fact[100001];

ll bin_pow(int a, int n){
    ll res = 1;
    while(n){
        if(n & 1){
            res *= a;
            res %= MOD;
        }
        a *= a;
        a %= MOD;
        n >>= 1;
    }
    return res;
}

ll divide(int a, int b){
    return (a * bin_pow(b, MOD-2)) % MOD;
}

ll get_a_n_k(int n, int k){
    ll a = fact[n-k];
    a %= MOD;
    return divide(fact[n], a);
}


void solve() {
    int curr = 1;
    fact[0] = 1;
    for(int i = 1; i <= 100001; ++i){
        curr *= i;
        curr %= MOD;
        fact[i] = curr;
    }
    vector<int> cnt(3);
    ll sum = 0;
    int n;
    cin>>n;
    for(int i = 0; i < n; ++i){
        int a;
        cin>>a;
        sum += a;
        cnt[a%3]++;
    }
    if(sum % 3 == 0 || abs(cnt[1]-cnt[2]) > 2) cout << 0;
    else {
        ll ans = get_a_n_k(n-1, cnt[0]);
        ans %= MOD;
        ans *= fact[cnt[1]];
        ans %= MOD;
        ans *= fact[cnt[2]];
        ans %= MOD;
        cout << ans;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(6);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t = 1;
    //cin>>t;
    while (t--) solve();
    //stress();
}