#include <bits/stdc++.h>

using namespace std;

void Fast() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}

bool check(vector<vector<int>> &table) {
    int sm = 0;
    int n = (int) table.size();
    for (int i = 0; i < n; i++) sm += table[0][i];
    for (int i = 0; i < n; i++) {
        int s1 = 0, s2 = 0;
        for (int j = 0; j < n; j++) {
            s1 += table[i][j];
            s2 += table[j][i];
        }
        if (s1 != sm || s2 != sm) return false;
    }
    return true;
}

int main() {
    Fast();
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n;
    cin >> n;
    vector<vector<int>> table(n, vector<int> (n, 0));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> table[i][j];
        }
    }
    if (n < 5) {
        for (int i1 = 0; i1 < n; i1++) {
            for (int j1 = 0; j1 < n; j1++) {
                for (int i2 = 0; i2 < n; i2++) {
                    for (int j2 = 0; j2 < n; j2++) {
                        if (i1 == i2 && j1 == j2) continue;
                        swap(table[i1][j1], table[i2][j2]);
                        if (check(table)) {
                            cout << i1 + 1 << " " << j1 + 1 << '\n' << i2 + 1 << " " << j2  + 1;
                            return 0;
                        }
                        swap(table[i1][j1], table[i2][j2]);
                    }
                }
            }
        }
    }
    map<int, vector<int>> mp1, mp2;
    for (int i = 0; i < n; i++) {
        int sm = 0, sm1= 0;
        for (int j = 0; j < n; j++) {
            sm += table[i][j];
            sm1 += table[j][i];
        }
        mp1[sm].push_back(i);
        mp2[sm1].push_back(i);
    }
    if (mp1.size() == 3 && mp2.size() == 3) {
        int i1 = -1, i2 = -1, j1 = -1, j2 = -1;
        for (auto &i : mp1) {
            if (i.second.size() == 1) {
                if (i1 == -1) i1 = i.second[0];
                else i2 = i.second[0];
            }
        }
        for (auto &i : mp2) {
            if (i.second.size() == 1) {
                if (j1 == -1) j1 = i.second[0];
                else j2 = i.second[0];
            }
        }
        if (i1 > i2) swap(i1, i2);
        if (j1 > j2) swap(j1, j2);
        swap(table[i1][j1], table[i2][j2]);
        if (check(table)) {
            cout << i1 + 1 << " " << j1 + 1 << '\n' << i2 + 1 << " " << j2 + 1;
            return 0;
        }
        cout << i1 + 1 << " " << j2 + 1 << '\n' << i2 + 1 << " " << j1 + 1;
    } else if (mp1.size() == 3) {
        int i1 = -1, i2 = -1;
        int s1 = -1, s2 = -1;
        for (auto &i : mp1) {
            if (i.second.size() == 1) {
                if (i1 == -1) {
                    i1 = i.second[0];
                    s1 = i.first;
                }
                else {
                    i2 = i.second[0];
                    s2 = i.first;
                }
            }
        }
        for (int i = 0; i < n; i++) {
            s1 -= table[i1][i];
            s1 += table[i2][i];
            s2 -= table[i2][i];
            s2 += table[i1][i];
            if (s1 == s2) {
                cout << i1 + 1<< " " << i + 1 << '\n' << i2 + 1 << " " << i + 1;
                return 0;
            }
            s1 += table[i1][i];
            s1 -= table[i2][i];
            s2 += table[i2][i];
            s2 -= table[i1][i];
        }
    } else {
        int j1 = -1, j2 = -1;
        int s1 = -1, s2 = -1;
        for (auto &i : mp2) {
            if (i.second.size() == 1) {
                if (j1 == -1) {
                    j1 = i.second[0];
                    s1 = i.first;
                }
                else {
                    j2 = i.second[0];
                    s2 = i.first;
                }
            }
        }
        for (int i = 0; i < n; i++) {
            s1 -= table[i][j1];
            s1 += table[i][j2];
            s2 -= table[i][j2];
            s2 += table[i][j1];
            if (s1 == s2) {
                cout << i + 1 << " " << j1 + 1 << '\n' << i + 1 << " " << j2 + 1;
                return 0;
            }
            s1 += table[i][j1];
            s1 -= table[i][j2];
            s2 += table[i][j2];
            s2 -= table[i][j1];
        }
    }
}
