#include <bits/stdc++.h>
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define allr(x) x.rbegin(), x.rend()
typedef long long ll;
using namespace std;

const ll MOD = 1e9 + 7;

ll bin_pow(ll x, ll k) {
    if (k == 0) return 1;

    ll y = bin_pow(x, k / 2);
    y = (y * y) % MOD;

    if (k % 2) return (y * x) % MOD;
    return y;
}

void solve() {
    ll n;
    cin >> n;

    ll a = 0, b = 0, c = 0;
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        if (x % 3 == 1) b++;
        else if (x % 3 == 2) c++;
        else a++;
    }
    if (c > b) swap(b, c);


    if (a == n) {
        cout << 0 << endl;
        return;
    }
    if (b == c) {
        cout << 0 << endl;
        return;
    }
    if (b - c > 2) {
        cout << 0 << endl;
        return;
    }

    vector<ll> f(n + 1);
    f[0] = 1;
    for (ll i = 1; i <= n; i++) {
        f[i] = (f[i - 1] * i) % MOD;
    }

    ll ck = ((    (f[n - 1] * bin_pow(f[a], MOD - 2) )    % MOD) * bin_pow(f[b + c - 1], MOD - 2) ) % MOD;

    cout <<  (((  (  (f[a] * f[b]) % MOD) * f[c]) % MOD) * ck) % MOD << endl;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
}

