#include <bits/stdc++.h>
using namespace std;
using ll = long long;
const int Inf = 0x4f4f4f4f;
const ll inf = 1144000000000000000;

const int maxn = 5005;
long long dp[maxn][maxn][2];

const long long mod = 1000000007; 

void solve() {
    for (int i = 0; i < maxn; ++i)
        dp[0][i][1] = 1;
    dp[1][0][1] = 1;
    for (int i = 1; i < maxn; ++i) {
        dp[i][1][0] = i == 1;
        dp[i][1][1] = i == 2;
        for (int j = 2; j < maxn - 1; ++j) {
            dp[i][j][0] += dp[i - 1][j - 1][0] + dp[i - 1][j - 1][1];
            dp[i][j][0] += dp[i][j - 1][0];
            dp[i][j][0] %= mod;

            dp[i][j][1] = dp[i - 1][j][0] - dp[i - 1][j - 1][0] + dp[i][j - 1][1];
            dp[i][j][1] %= mod;
            dp[i][j][1] += mod;
            dp[i][j][1] %= mod;
        } 
    }
    int n;
    long long prod = 1;
    cin >> n;
    for (int i = n; i > 1; --i)
        prod = (prod * (dp[i][i - 1][0] + dp[i][i - 1][1])) % mod;
    cout << prod;
}

signed main() {
    cin.tie(0)->sync_with_stdio(0);
    int Tc = 1;
    // cin >> Tc;
    while (Tc--)
        solve(), cout << '\n';
}