#include <bits/stdc++.h>

#ifndef LOCAL
#pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,strict-overflow")
#pragma GCC target("sse4.2,avx,avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#endif
using namespace std;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;
using pdd = pair<double, double>;
using pii = pair<int, int>;

#define inf 1'000'001'000
#define linf 1'000'000'000'000'001'000ll

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n;
    cin >> n;
    vector<vector<int>> matrix(n, vector<int>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> matrix[i][j];
        }
    }
    pll min_row = {linf, -1};
    pll max_row = {-linf, -1};
    pll min_col = {linf, -1};
    pll max_col = {-linf, -1};
    for (int i = 0; i < n; ++i) {
        ll row_sum = 0;
        for (int j = 0; j < n; ++j) {
            row_sum += matrix[i][j];
        }
        min_row = min(min_row, {row_sum, i});
        max_row = max(max_row, {row_sum, i});
    }
    for (int i = 0; i < n; ++i) {
        ll col_sum = 0;
        for (int j = 0; j < n; ++j) {
            col_sum += matrix[j][i];
        }
        min_col = min(min_col, {col_sum, i});
        max_col = max(max_col, {col_sum, i});
    }
    if (min_row.first == max_row.first && min_col.first == max_col.first) {
        while (true) {}
    }
    if (min_row.first == max_row.first) {
        // Same row
        auto [col1_val, col1_i] = min_col;
        auto [col2_val, col2_i] = max_col;
        ll val_diff = abs(col1_val - col2_val);
        for (int i = 0; i < n; ++i) {
            if (val_diff == abs(matrix[i][col1_i] - matrix[i][col2_i]) * 2) {
                cout << i + 1 << " " << col1_i + 1 << "\n";
                cout << i + 1 << " " << col2_i + 1 << "\n";
                return 0;
            }
        }
        while (true) {}
    }
    if (min_col.first == max_col.first) {
        // Same row
        auto [row1_val, row1_i] = min_row;
        auto [row2_val, row2_i] = max_row;
        ll val_diff = abs(row1_val - row2_val);
        for (int i = 0; i < n; ++i) {
            if (val_diff == abs(matrix[row1_i][i] - matrix[row2_i][i]) * 2) {
                cout << row1_i + 1 << " " << i + 1 << "\n";
                cout << row2_i + 1 << " " << i + 1 << "\n";
                return 0;
            }
        }
        while (true) {}
    }
    cout << min_row.second + 1 << " " << min_col.second + 1 << "\n";
    cout << max_row.second + 1 << " " << max_col.second + 1 << "\n";
}
