#include <iostream>
#include <iomanip>
#include <vector>
#include <cmath>
#include <algorithm>
#include <map>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll MOD = 1e9 + 7;

map<pair<int, int>, ll> mp;

ll rec(int n, int d) {
    if (mp.find({n, d}) != mp.end())
        return mp[{n, d}];
    if (n == 0)
        return 1ll;
    ll res = 0;
    for (int i = 1; i <= min(n, 1000); i++) {
        if (i != d) {
            res += rec(n - i, d);
            res %= MOD;
        }
    }
    mp[{n, d}] = res;
    return res;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n; cin >> n;
    int cnt = 0;
    int i = 1;
    ll ans = 0;
    while (cnt <= n) {
        ans += rec(n - cnt, i) * i;
        ans %= MOD;
        cnt += i;
        i++;
    }
    cout << ans << "\n";
    return 0;

}
