#include <iostream>
#include <iomanip>
#include <vector>
#include <cmath>
#include <algorithm>
#include <map>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll MOD = 1000000007;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n; cin >> n;
    ll cnt = 0;
    ll i = 1;
    ll ans = 0;
    while (cnt <= n) {
        vector<vector<ll>> dp(1001, vector<ll> (1001, 0));
        dp[0][0] = 1;
        for (int k = 1; k <= 1000; k++) {
            dp[k][0] = 1;
            for (int j = 1; j <= 1000; j++) {
                if (k != i && j >= k)
                    dp[k][j] = (dp[k][j] + dp[k][j - k]) % MOD;
                dp[k][j] = (dp[k][j] + dp[k - 1][j]) % MOD;
            }
        }
        ans += (dp[1000][n - cnt] * i) % MOD;
        ans %= MOD;
        cnt += i;
        i++;
    }
    cout << ans << "\n";
    return 0;

}
