#include <iostream>
#include <vector>
#include <map>

using namespace std;

using ll = long long;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	string s;
	cin >> s;

	vector<int> countWrite(26, 0);
	map<char, int> cycle;

	int n;
	cin >> n;

	for (int i = 0; i < n; ++i) {
		char c;
		int cl;
		cin >> c >> cl;

		cycle[c] = cl - 1;
	}

	int cnt = 0;
	for (int i = 0; i < s.size(); ++i) {
		char c = s[i];
		if (!cycle.count(c)) {
			cnt++;
		}
		else {
			if (countWrite[c - 'a'] == 0) {
				countWrite[c - 'a'] = cycle[c];
				cnt++;
			}
			countWrite[c - 'a']--;
			cnt++;
		}
	}

	cout << cnt;

	return 0;
}