#include <bits/stdc++.h>

using namespace std;


const int maxn = 100001;

set<int> pa;
set<int> pb;
set<int> lr[maxn];
int segTree[4*maxn];
set<int> ll[maxn];
int n;

string s;

void modify(int i,int x,int l,int r,int indV)
{
   // cout << i << ' ' << x << ' ' << l << ' ' << r << ' ' << indV << "\n";
    if(l > i || r < i)
        return ;
    else if(l == r)
    {
        segTree[indV] = x;
        return ;
    }
    int m = (l+r)/2;
    modify(i,x,l,m,indV*2+1);
    modify(i,x,m+1,r,indV*2+2);
    segTree[indV] = min(segTree[indV*2+1],segTree[indV*2+2]);
    return ;
}
int get(int lx,int rx,int l,int r,int indV)
{
    if(l > rx || r < lx)
        return maxn;
    else if(l >= lx && r <= rx)
        return segTree[indV];
    int m = (l+r)/2;
    int sl = get(lx,rx,l,m,indV*2+1);
    int sr = get(lx,rx,m+1,r,indV*2+2);
    return min(sl,sr);
}

void ins(int l,int r)
{
    if(l > maxn || r > maxn)
        return ;
    //cout << l << ' ' << r << "\n";
    lr[l].insert(r);
    ll[l].insert(r);
    ll[r].insert(l);
  //  cout << l <<' ' << *lr[l].begin() << ' ';
    modify(l,*lr[l].begin(),0,n-1,0);
}
void rem(int l,int r)
{
    if(l > maxn || r > maxn)
        return ;
  //  cout << "!" << l << ' ' << r << "\n";
    lr[l].erase(r);
    ll[l].erase(r);
    ll[r].erase(l);
   // cout << l << ' ' << r << "\n";
   //cout << l << ' '
    modify(l,(lr[l].size() == 0 ? maxn : (*lr[l].begin())),0,n-1,0);
}
void chz(int ind)
{
    if(ind >= maxn)
        return ;
    int cb = *pb.upper_bound(ind);
    int ca = *pa.upper_bound(ind);
   // cout << ind << ' ' << ca << ' ' << cb << "\n";
   // cout << ind << ' ' << ca << ' ' << cb << "\n";
    if(ca > cb)
    {
       // cout << ind << ' ' << cb << "\n";
       // cout << ind << ' ' << ca << ' ' << cb << "\n";
        ins(ind,cb);
    }
    else
    {
     //   cout << ind << ' ' << cb << "\n";
        rem(ind,cb);
    }
}

void rec(int ck)
{
    auto it = pb.lower_bound(ck);
    if(pb.size() == 0)
        return;
    if(it == pb.end())
        it--;
    for(int i =0;i < 1;++i)
    {
        chz(*it);
        if(it == pb.begin())
            break;
        it--;
    }
    it = pb.lower_bound(ck);
    if(it == pb.end())
        it--;
    for(int i = 0;i < 1;++i)
    {
        if(it == pb.end())
            break;
        chz(*it);
        it++;
    }
    return ;

}
void sw(int i)
{
    if(s[i] == 'a')
    {
        if(i > 0 && s[i-1] == 'a')
        {
            pa.erase(i);
            rec(i);
        }
        if(i < n-1 && s[i+1] == 'a')
        {
            pa.erase(i+1);
            rec(i+1);
        }
        if(i > 0 && s[i-1] == 'b')
        {
            pb.insert(i);
            rec(i);
        }
        if(i < n-1 && s[i+1] == 'b')
        {
            pb.insert(i+1);
            rec(i+1);
        }
        s[i] = 'b';
    }
    else
    {
        if(i > 0 && s[i-1] == 'b')
        {
            pb.erase(i);
            rec(i);
            for(auto c:ll[i])
            {
                rem(min(i,c),max(i,c));
            }
            ll[i].clear();
        }
        if(i < n-1 && s[i+1] == 'b')
        {
            pb.erase(i+1);
            rec(i+1);
            for(auto c:ll[i+1])
            {
                rem(min(i,c),max(i,c));
            }
            ll[i+1].clear();
        }
        if(i > 0 && s[i-1] == 'a')
        {
            pa.insert(i);
            rec(i);
        }
        if(i < n-1 && s[i+1] == 'a')
        {
            pa.insert(i+1);
            rec(i+1);
        }
        s[i] = 'a';
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    //int n;
    cin >> n;
    //string s;
    cin >> s;
    for(int i = 0;i < s.size();++i)
    {
        modify(i,maxn,0,n-1,0);
    }
    for(int i = 1;i < s.size();++i)
    {
        if(s[i] == 'a' && s[i-1] == 'a')
        {
            pa.insert(i);
        }
        if(s[i] == 'b' && s[i-1] == 'b')
        {
            pb.insert(i);
        }
    }
    pa.insert(maxn + 100);
    pb.insert(maxn + 101);
  //  cout << get(0,n-1,0,n-1,0) << "\n";
    for(int i = 0;i < n;++i)
    {
        rec(i);
    }
    int q;
    cin >> q;
    while(q--)
    {
        int t;
        cin >> t;
        if(t == 1)
        {
            int i;
            cin >> i;
            i--;
            sw(i);
        }
        else
        {
            int l,r;
            cin >> l >> r;
            l--;
            r--;
            int y1 = 0,y2 = 0;
            if(pb.find(l) != pb.end())
                y1 = 1;
            if(pb.find(r+1) != pb.end())
            {
                y2 = 1;
            }
            if(s[l] == 'b' && !y1)
            {
               // cout << "!";
                pb.insert(l);
                rec(l);
            }
            if(s[r] == 'b' && !y2)
            {
               // cout << "!";
                pb.insert(r+1);
                rec(r+1);
            }
           // cout << get(l,r,0,n-1,0) << "\n";
            cout << (get(l,r,0,n-1,0) <= r+1 ? "NO\n" : "YES\n");
            if(s[l] == 'b' && !y1)
            {
                //if()
                pb.erase(l);
                rec(l);
                for(auto c:ll[l])
                {
                    rem(min(l,c),max(l,c));
                }
                ll[l].clear();
            }
            if(s[r] == 'b' && !y2)
            {
                pb.erase(r+1);
                rec(r+1);
                for(auto c:ll[r+1])
                {
                    rem(min(r+1,c),max(r+1,c));
                }
                ll[r+1].clear();
            }
        }
    }
}

