#include <bits/stdc++.h>

using namespace std;


const int maxn = 100001;

struct ct
{
    ct(char _ls,char _rs,int _bl,int _br,int _al,int _ar,bool _xs,int _sz){ls = _ls;rs = _rs;bl = _bl;br = _br;al = _al;ar = _ar;xs = _xs;sz = _sz;};
    ct(){ls = 0;rs = 0;bl = 0;br =0;xs = 0;al = 0;ar = 0;xs =0;sz = 0;};
    char ls;
    char rs;
    int bl;
    int br;
    int al;
    int ar;
    bool xs;
    int sz;
};

ct segTree[4*maxn];
int n;

string s;


ct ca = ct('a','a',maxn+1,-maxn-1,maxn+1,-maxn-1,1,1);
ct cb = ct('b','b',maxn+1,-maxn-1,maxn+1,-maxn-1,1,1);

ct mrg(ct a,ct b)
{
    if(a.sz == -1)
    {
        return b;
    }
    else if(b.sz == -1)
    {
        return a;
    }
    ct ans;
    ans.ls = a.ls;
    ans.rs = b.rs;
    ans.sz = a.sz + b.sz;
    ans.bl = min({a.bl,b.bl+a.sz,(a.rs == 'b' && b.ls == 'b' ? a.sz-1 : maxn+1)});
    ans.br = max({a.br,b.br+a.sz,(a.rs == 'b' && b.ls == 'b' ? a.sz-1 : -maxn-1)});
    ans.al = min({a.al,b.al+a.sz,(a.rs == 'a' && b.ls == 'a' ? a.sz-1 : maxn+1)});
    ans.ar = max({a.ar,b.ar+a.sz,(a.rs == 'a' && b.ls == 'a' ? a.sz-1 : -maxn-1)});
    ans.xs = a.xs && b.xs;
    if(a.rs == 'b' && b.ls == 'b' && ((a.br > a.ar && a.br >= 0) || (b.bl < b.al && b.bl < n)))
    {
        ans.xs = 0;
    }
    return ans;
    //return ct(a.ls,b.rs,min({a.bl,b.bl+a.sz,(a.rs == 'b' && b.ls == 'b' ? a.sz-1 : maxn+1)}),max({a.br,b.bl+a.sz,(a.rs == 'a' && b.ls == 'a' ? a.sz-1 : maxn+1)}),min())
}


void modify(int i,char x,int l,int r,int indV)
{
   // cout << i << ' ' << x << ' ' << l << ' ' << r << ' ' << indV << "\n";
    if(l > i || r < i)
        return ;
    else if(l == r)
    {
        segTree[indV] = (x == 'a' ? ca : cb);
        return ;
    }
    int m = (l+r)/2;
    modify(i,x,l,m,indV*2+1);
    modify(i,x,m+1,r,indV*2+2);
    segTree[indV] = mrg(segTree[indV*2+1],segTree[indV*2+2]);
    return ;
}
ct get(int lx,int rx,int l,int r,int indV)
{
    if(l > rx || r < lx)
        return ct('c','c',-1,-1,-1,-1,0,-1);
    else if(l >= lx && r <= rx)
        return segTree[indV];
    int m = (l+r)/2;
    ct sl = get(lx,rx,l,m,indV*2+1);
    ct sr = get(lx,rx,m+1,r,indV*2+2);
    return mrg(sl,sr);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    //int n;
    cin >> n;
    //string s;
    cin >> s;
    for(int i = 0;i < s.size();++i)
    {
        modify(i,s[i],0,n-1,0);
    }

    int q;
    cin >> q;
    while(q--)
    {
        int t;
        cin >> t;
        if(t == 1)
        {
            int i;
            cin >> i;
            i--;
            if(s[i] == 'a')
            {
                s[i] = 'b';
                modify(i,s[i],0,n-1,0);
            }
            else if(s[i] == 'b')
            {
                s[i] = 'a';
                modify(i,s[i],0,n-1,0);
            }
        }
        else
        {
            int l,r;
            cin >> l >> r;
            l--;
            r--;
            ct ans = get(l,r,0,n-1,0);
          //  cout << ans.ls << ' ' << ans.rs << ' ' << ans.sz << ' ' << ans.xs << ' ' << ans.al << ' ' << ans.ar << ' ' << ans.bl << ' ' << ans.br << "\n";
            if(ans.xs == 0 || (ans.ls == 'b' && (ans.bl < ans.al && ans.bl < n)) || (ans.rs == 'b' && ans.br > ans.ar && ans.br >= 0) || (ans.ls == 'b' && ans.rs == 'b' && ans.ar < 0))
            {
                cout << "NO\n";
            }
            else
                cout << "YES\n";
           // cout << get(l,r,0,n-1,0) << "\n";
        }
    }
}

