#include <bits/stdc++.h>

using namespace std;
#define int long long
typedef long long ll;

#define int long long
const long long nmax = 2e5 + 100, MOD = 1e9 + 7, N = 1e3 + 10;
const long long inf = 2e5 + 100;

#define sz(a) (a.size())

int binpow(int a, int n, int m) {
    int res = 1;
    while (n) {
        if (n & 1) {
            res = (res * a) % m;
        }
        a = (a * a) % m;
        n >>= 1;
    }
    return res;
}

vector<int> inv_fact(nmax), fact(nmax);

void calc_inv() {
    fact[0] = 1;
    inv_fact[0] = binpow(1, MOD - 2, MOD);
    for (int i = 1; i < nmax; i++) {
        fact[i] = (fact[i - 1] * i) % MOD;
        inv_fact[i] = binpow(fact[i], MOD - 2, MOD);
    }
}

int cnk(int n, int k) {
    if (k > n) {
        assert(0);
        return -1;
    }
    return (((fact[n] * inv_fact[n - k]) % MOD) * inv_fact[k]) % MOD;
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n, vector<int>(n));
    for (auto &e: a) {
        for (int &k: e) {
            cin >> k;
        }
    }
    vector<pair<int, int>> pos(n * n + 1);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            pos[a[i][j]] = {i, j};
        }
    }
    int s = 0;
    for (int i = 1; i <= n * n; i++) {
        s += i;
    }
    s /= n;
    vector<int> sums(n), sumtr(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            sums[i] += a[i][j];
        }
    }
    for (int j = 0; j < n; j++) {
        for (int i = 0; i < n; i++) {
            sumtr[j] += a[i][j];
        }
    }
    vector<int> s1, s2;
    for (int i = 0; i < n; i++) {
        if (sums[i] != s) {
            s1.push_back(i);
        }
        if (sumtr[i] != s) {
            s2.push_back(i);
        }
    }
    int sz = (int) s1.size(), sz1 = (int)s2.size();
    int i = s1[0];
    int diff = sums[i] - s;
    for (int j = 0; j < n; j++) {
        int nw = a[i][j] - diff;
        if (nw < 1 || nw > n * n) {
            continue;
        }
        auto [i1, j1] = pos[nw];
        bool fl = true;
        for (int k = 1; k < sz; k++) {
            int x = s1[k];
            pair<int, int> y = {0, n - 1};
            if (i1 != x) {
                fl = false;
                break;
            }
        }
        for (int k = 0; k < sz1; k++) {
            int y = s2[k];
            pair<int, int> x = {0, n - 1};
            if (j1 != y) {
                if (a[i][j] == 6) {
                    cout << s2[k] << ' ' << i1 << ' ' << j1 << ' ' << y << '\n';
                }
                fl = false;
                break;
            }
        }
        if (fl) {
            cout << i + 1 << ' ' << j + 1 << '\n';
            cout << i1 + 1 << ' ' << j1 + 1 << '\n';
            exit(0);
        }
    }
}

int ask(int x) {
    cout << "? " << x << endl;
    cin >> x;
    return x;
}

__int128 pw(__int128 a, int b) {
    if (b < 0) return 0;
    __int128 res = 1;
    while (b--)
        res = res * a;
    return res;
}

void solve1() {

}

void solve2() {
    int n;
    cin >> n;
    int x, y;
    set<pair<int, int>> st[2][2];
    for (int i = 0; i < n; i++) {
        cin >> x >> y;
        x += 1e9;
        y += 1e9;
        if (st[x%2][y%2].find({x, y}) == st[x%2][y%2].end()) {
            st[x%2][y%2].insert({x, y});
        } else {
            st[x%2][y%2].erase({x, y});
        }
        cout << max(max(st[0][0].size(), st[0][1].size()), max(st[1][0].size(), st[1][1].size())) << '\n';

    }
}




signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);



//    solve2();
//    solve1();

//    solve();
//    return 0;

    calc_inv();

    int n;
    cin >> n;
    ll k0 = 0, k1 = 0, k2 = 0;
    ll a;
    for (int i = 0; i < n; i++) {
        cin >> a;
        if (a%3 == 0) k0++;
        if (a%3 == 1) k1++;
        if (a%3 == 2) k2++;
    }
    if ((k1 + 2 * k2) % 3 == 0) {
        cout << 0;
        return 0;
    }
    if (k1 == 1 && k2 == 0 || k1 == 0 && k2 == 1) {
        cout << fact[k0];
        return 0;
    }
    //cout << k0 << " " << k1 << " " << k2 << '\n';
    ll ans = 0;
    if (k1 >= 2 && k1 == k2 + 1 || k1 >= 2 && k1 == k2 + 2) {
        ans = (ans + ((((((cnk(k0 + k1 + k2 - 1, k0) * fact[k1])%MOD)*fact[k2]) % MOD)*fact[k0])%MOD) % MOD);
    }
    if (k2 >= 2 && k2 == k1 + 1 || k2 >= 2 && k2 == k1 + 2) {
        ans = (ans + ((((((cnk(k0 + k1 + k2 - 1, k0) * fact[k1])%MOD)*fact[k2]) % MOD)*fact[k0])%MOD) % MOD);
    }

    cout << ans;
    return 0;
}
