#include <bits/stdc++.h>

using namespace std;
#define int long long
typedef long long ll;

#define int long long
const long long nmax = 2e5 + 100, MOD = 1e9 + 7, N = 1e3 + 10;
const long long inf = 2e5 + 100;

#define sz(a) (a.size())

vector<vector<vector<bool>>> tree(4 * nmax, vector<vector<bool>> (2, vector<bool> (2, false)));

int n;
string s;

vector<vector<bool>> f(vector<vector<bool>> dpl, vector<vector<bool>> dpr, int pos) {
    vector<vector<bool>> dp(2, vector<bool> (2));
    if (s[pos] == 'a' && s[pos + 1] == 'a') {
        for (int l = 0; l < 2; l ++) {
            for (int r = 0; r < 2; r++) {
                bool flag = false;
                if (dpl[l][0] && dpr[0][r]) flag = true;
                if (dpl[l][0] && dpr[1][r]) flag = true;
                if (dpl[l][1] && dpr[0][r]) flag = true;
                if (dpl[l][1] && dpr[1][r]) flag = true;
                dp[l][r] = dp[l][r] | flag;
            }
        }
    } else if (s[pos] == 'a' && s[pos + 1] == 'b') {
        for (int l = 0; l < 2; l ++) {
            for (int r = 0; r < 2; r++) {
                bool flag = false;
                if (dpl[l][0] && dpr[0][r]) flag = true;
                if (dpl[l][0] && dpr[1][r]) flag = true;
                if (dpl[l][1] && dpr[1][r]) flag = true;
                dp[l][r] = dp[l][r] | flag;
            }
        }
    } else if (s[pos] == 'b' && s[pos + 1] == 'a') {
        for (int l = 0; l < 2; l ++) {
            for (int r = 0; r < 2; r++) {
                bool flag = false;
                if (dpl[l][0] && dpr[0][r]) flag = true;
                if (dpl[l][1] && dpr[0][r]) flag = true;
                if (dpl[l][1] && dpr[1][r]) flag = true;
                dp[l][r] = dp[l][r] | flag;
            }
        }
    } else {
        for (int l = 0; l < 2; l ++) {
            for (int r = 0; r < 2; r++) {
                bool flag = false;
                if (dpl[l][1] && dpr[1][r]) flag = true;
                dp[l][r] = dp[l][r] | flag;
            }
        }
    }
    return dp;
}

void build(int v, int tl, int tr) {
    if (tl + 1 == tr) {
        tree[v] = {{false, false}, {false, false}};
        if (s[tl] == 'a')
            tree[v][0][0] = tree[v][1][1] = true;
        else
            tree[v][0][0] = true;
        return;
    }
    int tm = (tl + tr) / 2;
    build(v * 2, tl, tm);
    build(v * 2 + 1, tm, tr);
    tree[v] = f(tree[v * 2], tree[v * 2 + 1], tm - 1);
}

void upd(int v, int tl, int tr, int pos) {
    if (tl + 1 == tr) {
        tree[v] = {{false, false}, {false, false}};
        if (s[tl] == 'a')
            tree[v][0][0] = tree[v][1][1] = true;
        else
            tree[v][0][0] = true;
        return;
    }
    int tm = (tl + tr) / 2;
    pos < tm ? upd(v * 2, tl, tm, pos) : upd(v * 2 + 1, tm, tr, pos);
    tree[v] = f(tree[v * 2], tree[v * 2 + 1], tm - 1);
}

vector<vector<bool>> get(int v, int tl, int tr, int ql, int qr) {
    if (qr <= tl || tr <= ql) return {{false, false}, {false, false}};
    if (ql <= tl && tr <= qr) return tree[v];
    int tm = (tl + tr) / 2;
    return f(get(v * 2, tl, tm, ql, qr), get(v * 2 + 1, tm, tr, ql, qr), tm - 1);
}

void solve() {
    cin >> n;
    cin >> s;
    s = '#' + s;

    for (int i = 1; i <= n; i++)
        upd(1, 1, n + 1, i);

    int q;
    cin >> q;
    while (q--) {
        int t;
        cin >> t;
        if (t == 1) {
            int pos;
            cin >> pos;
            if (s[pos] == 'a') s[pos] = 'b';
            else s[pos] = 'a';
            upd(1, 1, n + 1, pos);
        } else {
            int l, r;
            cin >> l >> r;
            auto res = get(1, 1, n + 1, l, r + 1);
            bool flag = false;
            if (s[l] == 'a' && s[r] == 'a') {
                for (auto e1 : res)
                    for (auto e2 : e1)
                        flag |= e2;
            } else if (s[l] == 'a' && s[r] == 'b') {
                for (int i = 0; i < 2; i++)
                    flag |= res[i][1];
            } else if (s[l] == 'b' && s[r] == 'a') {
                for (int i = 0; i < 2; i++)
                    flag |= res[1][i];
            } else {
                flag |= res[1][1];
            }
            if (flag) cout << "YES" << '\n';
            else cout << "NO" << '\n';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
