#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1e18;
const ll MOD = INF;


ll binpow(ll n, ll p)
{
	if (p == 0) return 1;
	if (p % 2 == 0)
	{
		ll b = binpow(n, p / 2);
		return (b * b) % MOD;
	}
	return (binpow(n, p - 1) * n) % MOD;
}


void solve()
{
	int n;
	cin >> n;
	ll l = 0, r = INF + 1;
	while (r - l > 1) {
		ll d = (l + r) / 2;
		cout << "? "<<d << endl;
		int n1;
		cin >> n1;
		if (n1 > n) r = d;
		else l = d;
	}
	for (int b = 2; b <= 2023; ++b) {
		ll inf = binpow(b, n);
		ll x = inf - r;
		int ans = 0;
		while (x > 0) {
			x = x / b;
			++ans;
		}
		if (ans == n) {
			cout << "! "<<inf - r << ' ' << b << endl;
			return;
		}
	}


}

int main()
{
	int t = 1;
	//cin>>t;
	while (t--) solve();
}