#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const ll M = 1e9 + 7;

ll f(ll a1, ll a2, ll w) {
    if (a1 == 0 && a2 == 0) {
        return 1;
    }
    ll sum = 0;
    if (w == 0) {
        if (a1 > 0) {
            sum += f(a1 - 1, a2, 1);
        }
        if (a2 > 0) {
            sum += f(a1, a2 - 1, 2);
        }
    }
    if (w == 1) {
        if (a1 > 0) {
            sum += f(a1 - 1, a2, 2);
        }
    }
    if (w == 2) {
        if (a2 > 0) {
            sum += f(a1, a2 - 1, 1);
        }
    }
    return sum;
}

void solve() {
    ll n;
    cin >> n;
    ll a0 = 0;
    ll a1 = 0;
    ll a2 = 0;
    for (int i = 0; i < n; ++i) {
        ll u;
        cin >> u;
        if (u % 3 == 0) {
            a0++;
        }
        if (u % 3 == 1) {
            a1++;
        }
        if (u % 3 == 2) {
            a2++;
        }
    }
    ll sum = 0;
    sum += f(a1, a2, 0);
    for (int i = 0; i < a0; ++i) {
        sum *= a1 + a2 + i;
        sum %= M;
    }
    for (ll i = 1; i <= a1; ++i) {
        sum *= i;
        sum %= M;
    }
    for (ll i = 1; i <= a2; ++i) {
        sum *= i;
        sum %= M;
    }
    cout << sum;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }
}
