#include <bits/stdc++.h>
using namespace std;

#define itn int
#define int long long
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define pii pair <int, int>
#define ff first
#define ss second

const int inf = 1e9 + 7;
vector <vector <int>> g;
vector <int> mn;

void cnt(int v, int p){
    for (auto to: g[v]){
        if (to != p){
            cnt(to, v);
            mn[v] = min(mn[v], mn[to] + 1);
        }
    }
    if (mn[v] == inf){
        mn[v] = 0;
    }
}

int mx = -1;
void dfs(int v, int cur, int p, itn cc){
    if (cur == 0){
        int vsp = mn[v];
        for (auto to: g[v]){
            if (to != p){
                if (vsp == 1) {
                    dfs(to, vsp - 1, v, cc + 1);
                }
                else{
                    dfs(to, vsp - 1, v, cc);
                }
            }
        }
    }
    else if (cur == 1){
        for (auto to: g[v]){
            if (to != p){
                dfs(to, cur - 1, v, cc + 1);
            }
        }
    }
    else{
        for (auto to: g[v]){
            if (to != p){
                dfs(to, cur - 1, v, cc);
            }
        }
    }
    if (mn[v] == 0){
        mx = max(mx, cc);
    }
}

void solve(){
    int n;
    cin >> n;
    g.resize(n);
    mn.resize(n, inf);
    for (itn i = 0; i < n - 1; ++i){
        int p;
        cin >> p;
        p--;
        g[i + 1].push_back(p);
        g[p].push_back(i + 1);
    }
//    for (int i = 0; i < n; ++i){
//        for (auto x: g[i]){
//            cout << i << ' ' << x << '\n';
//        }
//        cout << '\n';
//    }
    cnt(0, -1);
//    for (int i = 0; i < n; ++i){
//        cout << mn[i] << ' ';
//    }
//    cout << '\n';
    dfs(0, 0, -1, 0);
    cout << mx << '\n';
}

signed main(){
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

#endif
    cin.tie(nullptr) ->sync_with_stdio(false);
    cout << setprecision(20) << fixed;
    int t = 1;
//    cin >> t;
    while(t--){
        solve();
    }
}