#include <iostream>
#include <algorithm>
#include <set>
#include <vector>
#include <map>

using namespace std;
#define ll long long
#define vll vector<ll>
#define vi vector<int>
#define eol '\n'
#define Fastio(){ios::sync_with_stdio(0);cin.tie(0);cout.tie(0);}

#define print(arr){for(auto x: arr){cout << x << " ";} cout << '\n';}
const int mod = 1e9 + 7;

ll binpowmod(ll a, ll n) {
    if (a == 0) return 0;
    if (n == 0) return 1;
    if (n & 1) return a * binpowmod(a, n - 1) % mod;
    ll d = binpowmod(a, n >> 1);
    return d * d % mod;
}

void solve_d() {
    int n;
    ll dp[5001];
    cin >> n;
    dp[0] = 0;
    dp[1] = 1;
    for (int i = 2; i <= n; ++i) {
        if (i & 1) { //nechet
            int l = i / 2 + 1;
            int r = i - 1;
            ll ans = 0;
            for (int j = l; j <= r; ++j) ans = (ans + binpowmod(2, j - 1)) % mod;
            dp[i] = dp[i - 1] * ans % mod;
        } else {
            int l = i / 2;
            int r = i - 1;
            ll ans = 0;
            for (int j = l; j <= r; ++j) ans = (ans + binpowmod(2, j - 1)) % mod;
            dp[i] = dp[i - 1] * ans % mod;
        }
    }
    //for (int i = 0; i <= n; ++i) cout << dp[i] << ' ';
    cout << dp[n];
}

void solve_f() {
    int n;
    cin >> n;

    vll sum_hor(n, 0);
    vll sum_vert(n, 0);
    vector<vll > a(n, vll(n));
    ll sm = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            ll x;
            cin >> x;
            sm += x;
            a[i][j] = x;
            sum_hor[i] += x;
            sum_vert[j] += x;
        }
    }
    sm /= n;
//
//    print(sum_hor);
//    print(sum_vert);
    vi ii, jj;
    for (int i = 0; i < n; i++) {
        if (sum_hor[i] != sm) {
            ii.push_back(i);
        }
        if (sum_vert[i] != sm) {
            jj.push_back(i);
        }
    }
//    print(ii)
//    print(jj)
//    cout << "___________\n\n";



    if (ii.size() == 0) {
        for (int i = 0; i < n; i++) {
            if (sum_vert[jj[0]] - a[i][jj[0]] + a[i][jj[1]] == sm) {
                cout << i + 1 << " " << jj[0] + 1 << eol << i + 1 << " " << jj[1] + 1 << eol;
                return;
            }
        }
    }
    if (jj.size() == 0) {
        for (int j = 0; j < n; j++) {
            if (sum_hor[ii[0]] - a[ii[0]][j] + a[ii[1]][j] == sm) {
                cout << ii[0] + 1 << " " << j + 1 << eol << ii[1] + 1 << " " << j + 1 << eol;
                return;
            }
        }
    }

    int i1 = ii[0], j1 = jj[0], i2 = ii[1], j2 = jj[1];

    if (sum_vert[i1] - a[i1][j1] + a[i2][j2] == sm) {
        cout << i1 + 1 << " " << j1 + 1 << eol << i2 + 1 << " " << j2 + 1 << eol;
        return;
    }
    if (sum_vert[i1] - a[i1][j2] + a[i2][j1] == sm) {
        cout << i1 + 1 << " " << j2 + 1 << eol << i2 + 1 << " " << j1 + 1 << eol;
    }

}

int main() {
    Fastio();
    solve_f();
}
