#include <iostream>
#include <map>
#include <utility>
#include <algorithm>
#include <stdint.h>
#include <vector>

using namespace std;

int main()
{
	uint32_t n;
	std::cin >> n;
	std::vector<std::vector<uint32_t>> sq(n, vector<uint32_t>(n));
	for (auto& row : sq) {
		for (auto& v : row) {
			std::cin >> v;
		}
	}
	if (n == 3) {
		for (uint32_t x1 = 0; x1 < n; x1++) {
			for (uint32_t y1 = 0; y1 < n; y1++) {
				for (uint32_t x2 = 0; x2 < n; x2++) {
					for (uint32_t y2 = 0; y2 < n; y2++) {
						std::swap(sq[y1][x1], sq[y2][x2]);

						uint32_t rs = 0;
						for (auto& row : sq) {
							uint32_t s = 0;
							for (auto& v : row) {
								s += v;
							}
							if (rs == 0) rs = s;
							else if (rs != s) {
								rs = 0;
								break;
							}
						}
						if (rs == 0) {
							std::swap(sq[y1][x1], sq[y2][x2]);
							continue;
						}
						rs = 0;
						for (uint32_t x = 0; x < n; x++) {
							uint32_t s = 0;
							for (uint32_t y = 0; y < n; y++) {
								s += sq[y][x];
							}
							if (rs == 0) rs = s;
							else if (rs != s) {
								rs = 0;
								break;
							}
						}
						if (rs == 0) {
							std::swap(sq[y1][x1], sq[y2][x2]);
							continue;
						}
						std::cout << x1 + 1 << ' ' << y1 + 1 << '\n' << x2 + 1 << ' ' << y2 + 1;
						return 0;
					}
				}
			}
		}
		return 0;
	}
	std::vector<uint32_t> rows;
	rows.reserve(n);
	std::map<uint32_t, std::pair<uint32_t, uint32_t>> uniqueRows;

	uint32_t i = 0;
	for (auto& row : sq) {
		uint32_t s = 0;
		for (auto& v : row) {
			s += v;
		}
		rows.push_back(s);
		uniqueRows[s].first++;
		uniqueRows[s].second = i;
		i++;
	}

	std::vector<uint32_t> ys;
	uint32_t ny;
	for (auto& row : uniqueRows) {
		if (row.second.first == 1) {
			ys.push_back(row.second.second);
		}
		else {
			ny = row.second.second;
		}
	}

	std::vector<uint32_t> cols;
	cols.reserve(n);
	std::map<uint32_t, std::pair<uint32_t, uint32_t>> uniqueCols;

	for (uint32_t x = 0; x < n; x++) {
		uint32_t s = 0;
		for (uint32_t y = 0; y < n; y++) {
			s += sq[y][x];
		}
		cols.push_back(s);
		uniqueCols[s].first++;
		uniqueCols[s].second = x;
		x++;
	}

	std::vector<uint32_t> xs;
	uint32_t nx;
	for (auto& col : uniqueCols) {
		if (col.second.first == 1) {
			xs.push_back(col.second.second);
		}
		else {
			nx = col.second.second;
		}
	}

	if (xs.empty()) {
		uint32_t delta = (rows[ys[0]] - rows[ny]) * 2;
		for (uint32_t x1 = 0; x1 < n; x1++) {
			for (uint32_t x2 = 0; x2 < n; x2++) {
				if (sq[ys[0]][x1] - sq[ys[1]][x2] == delta) {
					xs = { x1, x2 };
					break;
				}
			}
			if (!xs.empty()) break;
		}
	}
	else if (ys.empty()) {
		uint32_t delta = (cols[xs[0]] - cols[nx]) * 2;
		for (uint32_t y1 = 0; y1 < n; y1++) {
			for (uint32_t y2 = 0; y2 < n; y2++) {
				if (sq[y1][xs[0]] - sq[y2][xs[1]] == delta) {
					ys = { y1, y2 };
					break;
				}
			}
			if (!xs.empty()) break;
		}
	}
	else if (rows[ys[0]] - sq[ys[0]][xs[0]] + sq[ys[1]][xs[1]] != rows[ny]) {
		std::reverse(ys.begin(), ys.end());
	}

	std::cout << xs[0] + 1 << ' ' << ys[0] + 1 << '\n' << xs[1] + 1 << ' ' << ys[1] + 1;
}
