#include <iostream>
#include <vector>

#define int long long

constexpr int mod = 1000000007;

signed main() {
    int n;
    std::cin >> n;
    std::vector<std::vector<int>> dp(n + 10, std::vector<int>(n + 10));
    dp[1][0] = dp[1][1] = dp[1][2] = 1;
    for (int i = 2; i < (int)dp.size(); i++) {
        for (int j = 0; j < (int)dp[i].size(); j++) {
            dp[i][j] = 0;
            for (int k = j - 2; k <= j; k++) {
                if (k >= 0) {
                    dp[i][j] += dp[i - 1][k];
                    if (dp[i][j] >= mod) {
                        dp[i][j] -= mod;
                    }
                }
            }
        }
    }
    int res = 1;
    for (int i = 1; i < n; i++) {
        res = res * 1ll * dp[i][i + 1] % mod;
    }
    std::cout << res << '\n';
    return 0;
}