#include <iostream>

#define int long long

int ask(int x) {
    std::cout << "? " << x << std::endl;
    int res;
    std::cin >> res;
    return res;
}

void ans(int x, int b) {
    std::cout << "! " << x << ' ' << b << std::endl;
    exit(0);
}

constexpr int inf = 4000000000000000000;

int pow(int a, int b) {
    int res = 1;
    while (b > 0) {
        if (b & 1) {
            if (inf / a < res) {
                return inf;
            }
            res = res * a;
        }
        if (inf / a < a) {
            return inf;
        }
        a = a * a;
        b >>= 1;
    }
    return res;
}

signed main() {
    int n;
    std::cin >> n;
    int l = 0;
    int r = 8400000000ll;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        if (ask(mid) > n) {
            r = mid;
        } else {
            l = mid;
        }
    }
    int d1 = r;
    l = d1;
    r = 70368744177664ll;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        if (ask(mid) > n + 1) {
            r = mid;
        } else {
            l = mid;
        }
    }
    int d2 = r;
    l = 1;
    r = 2024;
    while (r - l > 1) {
        int mid = (l + r) / 2;
        int cpow = pow(mid, n);
        if ((d2 - d1) / cpow < (mid - 2) || (mid - 1) * cpow > d2 - d1) {
            r = mid;
        } else {
            l = mid;
        }
    }
    int b = l;
    int cd1 = pow(b, n);
    int x = cd1 - d1;
    ans(x, b);
    return 0;
}