#include<bits/stdc++.h>

using namespace std;

struct node{
    int tpp, tps, suf, pref, cnt;
    bool badM;
};

const int N = 1e5 + 10;

string s;

node t[4 * N];

node nut;

void merg(node &a, node b, node c) {
    if (b.cnt == -1) {
        a = c;
        return;
    }
    if (c.cnt == -1) {
        a = b;
        return;
    }
    a.cnt = b.cnt + c.cnt;
    a.tpp = b.tpp;
    a.pref = b.pref;
    if (a.pref == b.cnt) {
        if (a.tpp == 0) {
            if (c.tpp == 2) {
                a.tpp = 0;
                a.pref += c.pref;
            }
            else if (c.tpp == 3) {
                a.tpp = 1;
                a.pref += c.pref;
            }
        }
        else if (a.tpp == 1) {
            if (c.tpp == 1) {
                a.tpp = 1;
                a.pref += c.pref;
            }
            else if (c.tpp == 0) {
                a.tpp = 0;
                a.pref += c.pref;
            }
        }
        else if (a.tpp == 2) {
            if (c.tpp == 3) {
                a.tpp = 3;
                a.pref += c.pref;
            }
            else if (c.tpp == 2) {
                a.tpp = 2;
                a.pref += c.pref;
            }
        }
        else {
            if (c.tpp == 0) {
                a.tpp = 2;
                a.pref += c.pref;
            }
            else if (c.tpp == 1) {
                a.tpp = 3;
                a.pref += c.pref;
            }
        }
    }

    a.tps = c.tps;
    a.suf = c.suf;
    if (a.suf == c.cnt) {
        if (a.tps == 0) {
            if (b.tps == 1) {
                a.tps = 0;
                a.suf += b.suf;
            }
            else if (b.tps == 3) {
                a.tps = 2;
                a.suf += b.suf;
            }
        }
        else if (a.tps == 1) {
            if (b.tps == 1) {
                b.tps = 1;
                a.suf += b.suf;
            }
            else if (b.tps == 3) {
                b.tps = 3;
                a.suf += b.suf;
            }
        }
        else if (a.tps == 2) {
            if (b.tps == 0) {
                a.tps = 0;
                a.suf += b.suf;
            }
            else if (b.tps == 2) {
                b.tps = 2;
                a.suf += b.suf;
            }
        }
        else {
            if (b.tps == 0) {
                a.tps = 1;
                a.suf += b.suf;
            }
            else if (b.tps == 2) {
                a.tps = 3;
                a.suf += b.suf;
            }
        }
    }
    a.badM = (b.badM || c.badM);
    if (b.tps == 2 && c.tpp == 3 && b.suf != b.cnt && c.pref != c.cnt) {
        a.badM = 1;
    }
    if (b.tps == 3 && c.tpp == 1 && b.suf != b.cnt && c.pref != c.cnt) {
        a.badM = 1;
    }
    if (b.tps == 3 && b.suf != b.cnt && (c.tpp == 2 || c.tpp == 3)) {
        a.badM = 1;
    }
    if (c.tpp == 3 && c.pref != c.cnt && (b.tpp == 1 || b.tpp == 3)) {
        a.badM = 1;
    }
}

void build(int v, int l, int r) {
    if (l + 1 == r) {
        t[v].cnt = 1;
        t[v].suf = t[v].pref = 1;
        t[v].badM = 0;
        if (s[l] == 'a') {
            t[v].tpp = t[v].tps = 0;
        }
        else {
            t[v].tpp = t[v].tps = 3;
        }
        return;
    }
    int m = (l + r) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    merg(t[v], t[2 * v + 1], t[2 * v + 2]);
}

void upd(int v, int l, int r, int qi) {
    if (l + 1 == r) {
        if (s[l] == 'a') {
            s[l] = 'b';
        }
        else {
            s[l] = 'a';
        }
        t[v].cnt = 1;
        t[v].suf = t[v].pref = 1;
        t[v].badM = 0;
        if (s[l] == 'a') {
            t[v].tpp = t[v].tps = 0;
        }
        else {
            t[v].tpp = t[v].tps = 3;
        }
        return;
    }
    int m = (l + r) / 2;
    if (qi < m) {
        upd(2 * v + 1, l, m, qi);
    }
    else {
        upd(2 * v + 2, m, r, qi);
    }
    merg(t[v], t[2 * v + 1], t[2 * v + 2]);
}

node get(int v, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        return t[v];
    }
    if (ql >= r || qr <= l) {
        return nut;
    }
    int m = (l + r) / 2;
    node r1 = get(2 * v + 1, l, m, ql, qr);
    node r2 = get(2 * v + 2, m, r, ql, qr);
    node rr;
    merg(rr, r1, r2);
    return rr;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    nut.cnt = -1;
    int n;
    cin >> n;
    cin >> s;
    build(0, 0, n);
    int q;
    cin >> q;
    while (q--) {
        int op;
        cin >> op;
        if (op == 1) {
            int i;
            cin >> i;
            --i;
            upd(0, 0, n, i);
        }
        else {
            int l, r;
            cin >> l >> r;
            node res = get(0, 0, n, l - 1, r);
            if (res.badM || res.tpp == 3 || res.tps == 3) {
                cout << "NO" << '\n';
            }
            else {
                cout << "YES" << '\n';
            }
        }
    }
}