#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <map>
#include <stack>
#include <set>

using namespace std;

#define ll long long
#define vll vector<ll>
#define pll pair<ll,ll>
#define FOR(i,a,b) for(ll i = (a); i < (b); ++i)
#define vvll vector<vll>

const ll INF = 1e18;


void speed()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
}

vvll gr;
vector<pll> wh;
ll ans = 0;
ll h = 0;
ll indb = 0;
ll indr = 0;
ll dfs(ll v)
{
	if (gr[v].size() == 0)
		return 1;
	ll mindl = INF;
	ll ind = -1;
	for (auto to : gr[v])
	{
		ll cnt = dfs(to);
		if (cnt < mindl)
		{
			mindl = cnt;
			ind = to;
		}
	}
	wh[v].first = ind;
	wh[v].second = mindl;
	return  mindl + 1;
}
void dfs2(ll v, ll ost)
{
	if (gr[v].size() == 0)
		return;
	if (ost == 0)
	{
		ans++;
		ost = wh[v].second;
	}
	for (auto to : gr[v])
	{
		dfs2(to, ost - 1);
	}
	return;
}


int main()
{
	ll n;
	cin >> n;
	gr.resize(n);
	wh.resize(n);
	FOR(i, 1, n)
	{
		ll a;
		cin >> a;
		--a;
		gr[a].push_back(i);
	}
	dfs(0);
	dfs2(0, 0);
	cout << ans;
}