#include <bits/stdc++.h>
using namespace std;
using ll = long long;

bool is_ok(int n, vector<vector<int>> &keks) {
    vector<int> rs(n), cs(n);
    int s = n * (n * n + 1) / 2;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
//            cin >> a[i][j];
            rs[i] += keks[i][j];
            cs[j] += keks[i][j];
        }
    }
    vector<int> br, bc;
    for (int i = 0; i < n; ++i) {
        if (rs[i] != s) {
            br.push_back(i);
        }
        if (cs[i] != s) {
            bc.push_back(i);
        }
    }
    if (br.empty() && bc.empty()) {
        return true;
    }
    return false;
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
    int n;
    cin >> n;
    int s = n * (n * n + 1) / 2;
    vector<vector<int>> a(n, vector<int>(n));
    vector<int> rs(n), cs(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> a[i][j];
            rs[i] += a[i][j];
            cs[j] += a[i][j];
        }
    }
    vector<int> br, bc;
    for (int i = 0; i < n; ++i) {
        if (rs[i] != s) {
            br.push_back(i);
        }
        if (cs[i] != s) {
            bc.push_back(i);
        }
    }
    if (br.size() == 0) {
        for (int cr = 0; cr < n; ++cr) {
            swap(a[cr][bc[0]], a[cr][bc[1]]);
            if (is_ok(n, a)) {
                cout << cr + 1 << ' ' << bc[0] + 1 << '\n';
                cout << cr + 1 << ' ' << bc[1] + 1 << '\n';
                return 0;
            }
            swap(a[cr][bc[0]], a[cr][bc[1]]);
        }
    } else if (bc.size() == 0) {
        for (int cc = 0; cc < n; ++cc) {
            swap(a[br[0]][cc], a[br[1]][cc]);
            if (is_ok(n, a)) {
                cout << br[0] + 1 << ' ' << cc + 1 << '\n';
                cout << br[1] + 1 << ' ' << cc + 1 << '\n';
                return 0;
            }
            swap(a[br[0]][cc], a[br[1]][cc]);
        }
    } else {
        swap(a[br[0]][bc[0]], a[br[1]][bc[1]]);
        if (is_ok(n, a)) {
            cout << br[0] + 1 << ' ' << bc[0] + 1 << '\n';
            cout << br[1] + 1 << ' ' << bc[1] + 1 << '\n';
            return 0;
        }
        swap(a[br[0]][bc[0]], a[br[1]][bc[1]]);
        swap(a[br[0]][bc[1]], a[br[1]][bc[0]]);
        if (is_ok(n, a)) {
            cout << br[0] + 1 << ' ' << bc[1] + 1 << '\n';
            cout << br[1] + 1 << ' ' << bc[0] + 1 << '\n';
            return 0;
        }
    }

    return 0;
}
