#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector a(n, vector<int>(n));
    vector<int> sumX(n), sumY(n);

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> a[i][j];
            sumX[i] += a[i][j];
            sumY[j] += a[i][j];
        }
    }

    auto check = [&]() -> bool {
        vector<int> sx(n), sy(n);
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                sx[i] += a[i][j];
                sy[j] += a[i][j];
            }
        }

        int was = -1;
        for (int x : sx) {
            if (was != -1 && was != x) {
                return false;
            }
            was = x;
        }
        for (int x : sy) {
            if (was != -1 && was != x) {
                return false;
            }
            was = x;
        }

        return true;
    };

    set<int> checked;

    for (auto &v : {sumX, sumY}) {
        for (int su : v) {
            if (checked.count(su)) {
                continue;
            }
            vector<int> rows, cols;
            for (int i = 0; i < n; ++i) {
                if (sumX[i] != su) {
                    rows.push_back(i);
                }
            }
            for (int i = 0; i < n; ++i) {
                if (sumY[i] != su) {
                    cols.push_back(i);
                }
            }
            if (size(rows) <= 2 && size(cols) <= 2) {
                assert(size(rows) == 2 || size(rows) == 0);
                assert(size(cols) == 2 || size(cols) == 0);
                if (!rows.empty() && !cols.empty()) {
                    for (int t = 0; t < 2; ++t) {
                        swap(a[rows[t]][cols[0]], a[rows[t ^ 1]][cols[1]]);
                        if (check()) {
                            cout << rows[t] + 1 << " " << cols[0] + 1 << "\n" << rows[t ^ 1] + 1 << " " << cols[1] + 1 << '\n';
                            return 0;
                        }
                        swap(a[rows[t]][cols[0]], a[rows[t ^ 1]][cols[1]]);
                    }
                } else if (rows.empty()) {
                    int u = cols[0], d = cols[1];
                    for (int i = 0; i < n; ++i) {
                        int sumYu = sumY[u] - a[i][u] + a[i][d];
                        int sumYd = sumY[d] - a[i][d] + a[i][u];
                        if (sumYu == sumYd) {
                            cout << i + 1 << " " << u + 1 << "\n" << i + 1 << " " << d + 1 << '\n';
                            return 0;
                        }
                    }
                } else {
                    int u = rows[0], d = rows[1];
                    for (int i = 0; i < n; ++i) {
                        int sumYu = sumX[u] - a[u][i] + a[d][i];
                        int sumYd = sumX[d] - a[d][i] + a[u][i];
                        if (sumYu == sumYd) {
                            cout << u + 1 << " " << i + 1 << "\n" << d + 1 << " " << i + 1 << '\n';
                            return 0;
                        }
                    }
                }
            }
            checked.insert(su);
        }
    }

    assert(false);

    return 0;
}