//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>

using namespace std;

//#define int long long
#define ll long long
#define dl long double
#define pii pair<int, int>
#define all(v) v.begin(), v.end()
#define sz(v) (int)v.size()

const ll inf = 1e18, mod = 1e9 + 7, maxn = 1e3 + 1;
int wasl[maxn][maxn], wasr[maxn][maxn];
int exl[maxn][maxn], exr[maxn][maxn];

int fl(int sum, int lim) {
    if (!sum) return 1;
    if (exl[sum][lim]) return wasl[sum][lim];
    int ans = 0;
    for (int x = 1; x <= min(sum, lim); ++x) {
        ans += fl(sum - x, x);
        while (ans >= mod) ans -= mod;
    }
    exl[sum][lim] = 1;
    wasl[sum][lim] = ans;
    return ans;
}

int n;

int fr(int sum, int lim) {
    if (!sum) return 1;
    if (exr[sum][lim]) return wasr[sum][lim];
    int ans = 0;
    for (int x = sum; x >= lim; --x) {
        ans += fr(sum - x, x);
        while (ans >= mod) ans -= mod;
    }
    exr[sum][lim] = 1;
    wasr[sum][lim] = ans;
    return ans;
}

void solve() {
    //int n;
    cin >> n;
    ll ans = 0;
    for (int mex = 1; mex * (mex - 1) / 2 <= n; ++mex) {
        int ost = n - (mex - 1) * mex / 2;
        for (int sl = 0; sl <= ost; ++sl) {
            ll cnt = (ll) fl(sl, mex - 1) * (ll) fr(ost - sl, mex + 1) % mod;
            // cout<<mex<<" : "<<cnt<<'\n';
            ans += cnt * (ll) mex % mod;
            while (ans >= mod) ans -= mod;
        }
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
        cout << '\n';
    }
}