#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define S second
#define F first

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> mtx(n, vector<int>(n));
    ll sm = 0;
    for (auto &i : mtx) {
        for (auto &j : i) {
            cin >> j;
            sm += j;
        }
    }
    ll sub_sm = sm / n;
    vector<int> rws, cols;
    for (int i = 0; i < n; i++) {
        ll cur = 0;
        for (int j = 0; j < n; j++) {
            cur += mtx[i][j];
        }
        if (cur != sub_sm)
            rws.emplace_back(i);
    }
    for (int j = 0; j < n; j++) {
        ll cur = 0;
        for (int i = 0; i < n; i++) {
            cur += mtx[i][j];
        }
        if (cur != sub_sm)
            cols.emplace_back(j);
    }

    auto check = [&](int i1, int j1, int i2, int j2, vector<vector<int>> m) {
        swap(m[i1][j1], m[i2][j2]);
        bool ok = true;
        for (int i = 0; i < n; i++) {
            ll cur = 0;
            for (int j = 0; j < n; j++) {
                cur += m[i][j];
            }
            ok &= (cur == sub_sm);
        }
        for (int j = 0; j < n; j++) {
            ll cur = 0;
            for (int i = 0; i < n; i++) {
                cur += m[i][j];
            }
            ok &= (cur == sub_sm);
        }
        return ok;
    };
    if (rws.size() == 0 && cols.size() == 0) {
        map<int, pair<int, int>> mp;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (mp.count(mtx[i][j])) {
                    cout << mp[mtx[i][j]].F + 1 << ' ' << mp[mtx[i][j]].S + 1 << '\n';
                    cout << i + 1 << ' ' << j + 1 << '\n';
                    return;
                } else {
                    mp[mtx[i][j]] = {i, j};
                }
            }
        };
    } else if (rws.size() == 0) {
        int j = cols[0], j1 = cols[cols.size() - 1];
        for (int i = 0; i < n; i++) {
            if (check(i, j, i, j1, mtx)) {
                cout << i + 1 << ' ' << j + 1 << '\n';
                cout << i + 1 << ' ' << j1 + 1 << '\n';
                return;
            }
        }
    } else if (cols.size() == 0) {
        int i = rws[0], i1 = rws[rws.size() - 1];
        for (int j = 0; j < n; j++) {
            if (check(i, j, i1, j, mtx)) {
                cout << i + 1 << ' ' << j + 1 << '\n';
                cout << i1 + 1 << ' ' << j + 1 << '\n';
                return;
            }
        }
    } else {
        int i = rws[0], i1 = rws[rws.size() - 1];
        int j = cols[0], j1 = cols[cols.size() - 1];
        if (check(i, j, i1, j1, mtx)) {
            cout << i + 1 << ' ' << j + 1 << '\n';
            cout << i1 + 1 << ' ' << j1 + 1 << '\n';
        } else if (check(i, j1, i1, j, mtx)) {
            cout << i + 1 << ' ' << j1 + 1 << '\n';
            cout << i1 + 1 << ' ' << j << '\n';
        }
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
