#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define nl endl
#else
#define nl '\n'
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define forn(i, n) for (decltype(n) i = 0; i < n; i++)
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define ll long long
#define ull unsigned long long
#define ld long double
#define _ <<" "<<

template<typename T> using ordered_set = trie<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

void solve() {
    vector<vector<int>> cnt(2, vector<int>(2));
    vector<int> mxx(2), mxy(2);

    set<pair<int, int>> st;
    int n;
    cin >> n;
    forn(i, n) {
        int x, y;
        cin >> x >> y;
        if (st.find({x, y}) == st.end()) {
            st.emplace(x, y);
            cnt[x % 2][y % 2]++;
            if (cnt[x % 2][y % 2] > cnt[x % 2][(y % 2) ^ 1]) mxx[x % 2]++;
            if (cnt[x % 2][y % 2] > cnt[(x % 2) ^ 1][y % 2]) mxy[y % 2]++;
        } else {
            st.erase({x, y});
            cnt[x % 2][y % 2]--;
            if (cnt[x % 2][y % 2] >= cnt[x % 2][(y % 2) ^ 1]) mxx[x % 2]--;
            if (cnt[x % 2][y % 2] >= cnt[(x % 2) ^ 1][y % 2]) mxy[y % 2]--;
        }
        cout << max({mxx[0], mxx[1], mxy[0], mxy[1]}) << nl;
    }
}

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    cout << fixed << setprecision(15);

    int tt = 1;
//    cin >> tt;
    while (tt--) solve();
}

