#include <bits/stdc++.h>
using namespace std;

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int n;
    cin >> n;
    vector<vector<int>> a(n, vector<int>(n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
        }
    }
    int S = n * (n * n + 1) / 2;
    vector<int> rows, cols;
    for (int i = 0; i < n; i++) {
        int cur = S;
        for (int j = 0; j < n; j++) {
            cur -= a[i][j];
        }
        if (cur != 0) {
            rows.push_back(i);
        }
    }
    for (int i = 0; i < n; i++) {
        int cur = S;
        for (int j = 0; j < n; j++) {
            cur -= a[j][i];
        }
        if (cur != 0) {
            cols.push_back(i);
        }
    }
    if (rows.empty() && cols.empty()) {
        cout << "1 1\n1 1\n";
        exit(0);
    }
    if (rows.empty()) {
        assert(cols.size() == 2);
        int u = cols[0], v = cols[1];
        int S1 = 0, S2 = 0;
        for (int i = 0; i < n; ++i) {
            S1 += a[i][u];
            S2 += a[i][v];
        }
        for (int i = 0; i < n; ++i) {
            if (S1 - a[i][u] + a[i][v] == S &&
                S2 - a[i][v] + a[i][u] == S) {
                    cout << i + 1 << ' ' << u + 1 << '\n' << i + 1 << ' ' << v + 1 << '\n';
                    exit(0);
                }

        }
        assert(false);
    }
    if (cols.empty()) {
        

        int x = rows[0], y = rows[1];
        int S1 = 0, S2 = 0;
        for (int i = 0; i < n; ++i) {
            S1 += a[x][i];
            S2 += a[y][i];
        }
        for (int i = 0; i < n; ++i) {
            if (S1 - a[x][i] + a[y][i] == S &&
                S2 - a[y][i] + a[x][i] == S) {
                    cout << x +1  << ' ' << i + 1 << '\n' << y + 1 << ' ' << i + 1 << '\n';
                    exit(0);
                }

        }
        assert(false);
    }
    assert(cols.size() == 2);
    assert(rows.size() == 2);
    for (int x = 0; x < 2; x++) {
        for (int y = 0; y < 2; y++) {
            int x1 = rows[x], y1 = cols[y], x2 = rows[x ^ 1], y2 = cols[y ^ 1];
            vector<vector<int>> b = a;
            swap(b[x1][y1], b[x2][y2]);
            bool good = true;
            for (int i = 0; i < n; i++) {
                int cur = S;
                for (int j = 0; j < n; j++) {
                    cur -= b[i][j];
                }
                if (cur != 0) {
                    good = false;
                }
            }
            for (int i = 0; i < n; i++) {
                int cur = S;
                for (int j = 0; j < n; j++) {
                    cur -= b[j][i];
                }
                if (cur != 0) {
                    good = false;
                }
            }
            if (good) {
                cout << 1 + x1 << " " << 1 + y1 << "\n" << 1 + x2 << " " << 1 + y2 << "\n";
                exit(0);
            }
        }
    }
}
