#include <bits/stdc++.h>

#define int long long
using namespace std;

int ask(int x) {
    int ans;
    cout << "? " << x << endl;
    cin >> ans;
    return ans;
}

int binpow(int n, int p) {
    int ans = 1;
    while (p) {
        if (p & 1)
            ans = ans * n;
        n = n * n;
        p >>= 1;
    }
    return ans;
}

void solve() {
    int x;
    cin >> x;
    int l = 2, r = 2023;
    while (l < r - 1) {
        int m = (l + r) / 2;
        if (ask(binpow(m, x + 1)) >= x + 1)
            r = m;
        else
            l = m + 1;
    }
    while (l < r && ask(binpow(l, x + 2)) != x + 2)
        l++;
    int b = l;
    int my = 0, lft = 0;
    for (int i = x; i; i--) {
        l = 1, r = b;
        int cur = binpow(b, i - 1);
        while (l < r - 1) {
            int m = (l + r) / 2;
            if (ask(m * cur + lft) < x + 1)
                l = m + 1;
            else
                r = m;
        }
        while (l < r && ask(l * cur + lft) < x + 1)
            l++;
        lft += (l - 1) * cur;
        my += (b - l) * cur;
//        cout << l << ' ' << cur << ' \n';
    }
    cout << "! " << my << ' ' << b << endl;
}

main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();

    return 0;
}
