#include <bits/stdc++.h>

#define pp pair<int,int>
#define all(x) x.begin(),x.end()
#define ll long long


using namespace std;

template<class T> istream& operator>>(istream& is,vector<T>& arr) { for(auto &i:arr) is>>i; return is;}
template<class T> ostream& operator<<(ostream& os,vector<T>& arr) { for(auto &i:arr) os<<i<<" "; return os;}


const ll mod = 1e9 + 7;

ll fact(int x) {
    ll res = 1;
    for(ll i=1;i<=x;i++)
        res = (res * i) % mod;
    return res;
}

ll bin_pow(ll a, ll n) {
    ll res = 1;
    while(n) {
        if (n & 1) res = (res * a) % mod;
        a = (a * a) % mod;
        n >>= 1;
    }
    return res;
}

ll cnk(ll n, ll k) {
    if (k > n) { cout<<":"<<endl; return 0;}
    ll z = (fact(k) * fact(n - k)) % mod;
    ll c = (fact(n) * bin_pow(z, mod - 2)) % mod;
    return c;
}


ll umn(ll n,vector<ll> a) {
    ll A = 0, B = 0, C = 0;
    for(int i=0;i<n;i++) {
        if (a[i] % 3 == 0) C++;
        if (a[i] % 3 == 1) A++;
        if (a[i] % 3 == 2) B++;
    }
    ll ans = 1;
    ans = (fact(A) * fact(B)) % mod;
    if (A > 2 && B == 0) {
        return 0;
    }
    if (B > 2 && A == 0) {
        return 0;
    }
    if (A == 1 && B == 1) {
        return 0;
    }
    if (A == 0 && B == 0 && C != 0) {
        return 0;
    }
    if (abs(A - B) > 2 || abs(A - B) == 0) {
        return 0;
    }

    //ans = (ans * cnk(A + B, C)) % mod;
    ll N = A + B;
    int m = C;
    for(int i=0;i<m;i++) {
        ans = (ans * (N + i)) % mod;
    }
    ans%=mod;
return ans;
}


ll stu(ll n,vector<ll> a) {
int cnt=0;
sort(all(a));
vector<pp> b;
for(int i=0;i<n;i++) b.push_back({a[i],i});
sort(all(b));

do {
    int ok=1;
    int sum=0;
    for(int i=0;i<n;i++) {
        sum+=b[i].first;
        ok&= sum%3!=0;
    }
    cnt+=ok;
} while( next_permutation(all(b)) );
return cnt;
}

int main()
{

ll n;
cin>>n;
vector<ll> a(n);
cin>>a;
cout<< umn(n,a);
return 0;

for(int ii=0;ii<199;ii++) {
  int n = 6;
  vector<ll> a(n);
  for(int i=0;i<n;i++) a[i] = rand()%10;
  int bad = umn(n,a);
  int tru = stu(n,a);
  if(bad!=tru) { cout<<ii<< "!!! stu:"<<tru<<", but your: "<<bad<<endl<<"test: "<<n<<endl<<a; return 0;}
}

    return 0;
}
