#include <bits/stdc++.h>
using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
using ll = long long;
using ld = long double;

// ARGHHHHHHHHHHHHHHHH
// ARGHHHHHHHHHHHHHHHH
const int N = 1e6;
pair<int, int> sizes[N];

pair<ll, ll> operator -(pair<ll, ll> &a, pair<ll, ll> &b) {
	return make_pair(a.first - b.first, a.second - b.second);
}

ll pse(pair<ll, ll> &a, pair<ll, ll> &b) {
	return a.first * b.second - a.second * b.first;
}

void mysort(vector<pair<ll, ll>> &v, int ver) {
	vector<pair<ll, ll>> up, down;
	int n = v.size();
	for (int i = 0; i < n; i++) {
		if (v[i].second > 0 || (v[i].second == 0 && v[i].first > 0)) up.push_back(v[i]);
		else down.push_back(v[i]);
	}
	sizes[ver].first = up.size();
	sizes[ver].second = down.size();
	sort(up.begin(), up.end(), [&](pair<ll, ll> &a, pair<ll, ll> &b) {return pse(a, b) < 0;});
	sort(down.rbegin(), down.rend(), [&](pair<ll, ll> &a, pair<ll, ll> &b) {return pse(a, b) < 0;});
	vector<pair<ll, ll>> newv;
	for (int i = 0; i < up.size(); i++) newv.push_back(up[i]);
	for (int i = 0; i < down.size(); i++) newv.push_back(down[i]);
	v = newv;
}

pair<pair<ll, ll>, pair<ll, ll>> f(vector<pair<ll, ll>> &v, int id, pair<ll, ll> vct) {
	int ans = 0;
	if (vct.second > 0 || (vct.second == 0 && vct.first > 0)) {
		int l = -1;
		int r = sizes[id].first;
		while (r - l > 1) {
			int mid = l + r >> 1;
			if (pse(v[mid], vct) >= 0) r = mid;
			else l = mid;
		}
		ans = r;
	} else {
		int l = -1;
		int r = sizes[id].second;
		while (r - l > 1) {
			int mid = l + r >> 1;
			if (pse(v[mid + sizes[id].first], vct) <= 0) r = mid;
			else l = mid;
		}
	}
	if (ans >= v.size()) ans -= v.size();
	return make_pair(v[ans], v[(ans - 1 + v.size()) % v.size()]);
}

vector<set<int>> newg;
vector<pair<int, int>> e;
vector<int> used;
vector<set<int>> v_g;

void calc(int v) {
	used[v] = 1;
	v_g[e[v].first].insert(e[v].second);
	v_g[e[v].second].insert(e[v].first);
	for (auto u : newg[v]) {
		if (used[u] != 1) {
			calc(u);
		}
	}
}

void clear(int v) {
	v_g[e[v].first].clear();
	v_g[e[v].second].clear();
	used[v] = 2;
	for (auto u : newg[v]) {
		if (used[u] != 2) {
			clear(u);
		}
	}
}

int calc_ans(int v, int p) {
	int ans = (v_g[v].size() - (p != -1) + 1) / 2;
	for (auto u : v_g[v]) {
		if (u == p) continue;
		ans += calc_ans(u, v);
	}
	return ans;
}

int32_t main() {
	cin.tie(nullptr);
	ios::sync_with_stdio(false);

	int n;
	cin >> n;

	vector<pair<ll, ll>> p(n);
	vector<vector<pair<ll, ll>>> ver(n);
	vector<map<pair<ll, ll>, int>> id(n);
	map<pair<int, int>, int> ide;
	for (int i = 0; i < n; i++) {
		cin >> p[i].first >> p[i].second;
	}

	vector<vector<int>> g(n);
	for (int i = 0; i < n - 1; i++) {
		int a, b;
		cin >> a >> b;
		a--; b--;
		e.push_back({a, b});
		ide[{a, b}] = i;
		ide[{b, a}] = i;
		g[a].push_back(b);
		g[b].push_back(a);
	}

	for (int i = 0; i < n; i++) {
		for (int to : g[i]) {
			ver[i].push_back(p[to] - p[i]);
		}
		for (int j = 0; j < g[i].size(); j++) id[i][ver[i][j]] = ide[{i, g[i][j]}];
		mysort(ver[i], i);
	}

	newg.resize(n - 1);
	for (int i = 0; i < n; i++) {
		for (int to : g[i]) {
			pair<ll, ll> vct = p[to] - p[i];
			auto res = f(ver[to], to, vct);
			newg[ide[{i, to}]].insert(id[to][res.first]);
			newg[ide[{i, to}]].insert(id[to][res.second]);
		}
	}

	for (int i = 0; i < n - 1; i++) {
		vector<int> bad = {i};
		for (auto u : newg[i]) {
			if (!newg[u].count(i)) {
				bad.push_back(u);
			}
		}
		for (auto el : bad) newg[i].erase(el);
	}

	int ans = 0;
	v_g.resize(n);
	used.assign(n, 0);
	for (int i = 0; i < n - 1; i++) {
		if (used[i]) continue;
		calc(i);
		ans += calc_ans(e[i].first, -1);
		clear(i);
	}

	cout << ans << '\n';

	return 0;
}