#include <bits/stdc++.h>

#define int long long

using namespace std;

const int N = 2e5 + 10;
vector<int> g[N];
int mn[N], ans = 0;

void dfs1(int v, int p = -1) {
    if (g[v].size() == 1 && g[v].back() == p) {
        mn[v] = 0;
        return;
    }
    for (auto u: g[v]) {
        if (u != p) {
            dfs1(u, v);
            mn[v] = min(mn[v], mn[u]);
        }
    }
    mn[v]++;
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<vector<int>> a(n, vector<int>(n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
        }
    }
    int sred = 0;
    set<int> s;
    vector<int> stolb(n);
    vector<int> strok(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            strok[i] += a[i][j];
            stolb[j] += a[i][j];
        }
        s.insert(strok[i]);
        s.insert(stolb[i]);
    }
    s.erase(s.begin());
    sred = *s.begin();
    int posmaxi = 0, posmaxj = 0;
    int posmini = 0, posminj = 0;
    for (int i = 0; i < n; i++) {
        if (stolb[posmaxj] < stolb[i]) {
            posmaxj = i;
        }
        if (stolb[posminj] > stolb[i]) {
            posminj = i;
        }
        if (strok[posmaxi] < strok[i]) {
            posmaxi = i;
        }
        if (strok[posmini] > strok[i]) {
            posmini = i;
        }
    }
    if (strok[posmaxi] != strok[posmini] && stolb[posmaxj] != stolb[posminj]) {
        cout << posmaxi + 1 << ' ' << posmaxj + 1 << '\n' << posmini + 1 << ' ' << posminj + 1;
    } else if (stolb[posmaxj] == stolb[posminj]) {
        int x = strok[posmaxi], y = strok[posmini];
        for (int i = 0; i < n; i++) {
            if (x - a[posmaxi][i] + a[posmini][i] == y - a[posmini][i] + a[posmaxi][i]) {
                cout << posmaxi + 1 << ' ' << i + 1 << '\n' << posmini + 1 << ' ' << i + 1;
                return 0;
            }
        }
    } else if (strok[posmaxi] == strok[posmini]) {
        int x = stolb[posmaxj], y = stolb[posminj];
        for (int i = 0; i < n; i++) {
            if (x - a[i][posmaxj] + a[i][posminj] == y - a[i][posminj] + a[i][posmaxj]) {
                cout << i + 1 << ' ' << posmaxj + 1 << '\n' << i + 1 << ' ' << posminj + 1;
                return 0;
            }
        }
    }
}
