#include <bits/stdc++.h>

using namespace std;

#define int long long

typedef long long ll;

const ll MOD = 1'000'000'007;

ll sum(ll a, ll b) {
    if (a + b >= MOD) {
        return a + b - MOD;
    }
    return a + b;
}

void solve() {
    ll n;
    cin >> n;
    vector<ll> dp(n + 3, 0);
    dp[0] = 1;
    ll ans = 1;
    for (ll i = 0; i < n - 1; i++) {
        vector<ll> ndp(n + 3, 0);
        for (ll j = 0; j <= n; j++) {
            ndp[j] = sum(ndp[j], dp[j]);
            ndp[j + 1] = sum(ndp[j + 1], dp[j]);
            ndp[j + 2] = sum(ndp[j + 2], dp[j]);
        }
        dp = ndp;
        ans *= dp[i + 2];
        ans %= MOD;
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}
