//
// Created by sch on 12.12.2023.
//
#include <bits/stdc++.h>

using namespace std;

bool check(int n, vector<vector<int>> a, long long sm) {
    for (int i = 0; i < n; ++i) {
        long long sum1 = 0, sum2 = 0;
        for (int j = 0; j < n; ++j) {
            sum1 += a[i][j];
            sum2 += a[j][i];
        }
        if (sum1 != sm || sum2 != sm) {
            return false;
        }
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<vector<int>> a(n, vector<int>(n));
    long long sum = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> a[i][j];
            sum += a[i][j];
        }
    }
    long long sm = sum / n;
    int i1 = -1, i2 = -1;
    for (int i = 0; i < n; ++i) {
        long long sum_nw = 0;
        for (int j = 0; j < n; ++j) {
            sum_nw += a[i][j];
        }
        if (sum_nw != sm) {
            if (i1 == -1) {
                i1 = i;
            } else {
                i2 = i;
            }
        }
    }
    int j1 = -1, j2 = -1;
    for (int j = 0; j < n; ++j) {
        long long sum_nw = 0;
        for (int i = 0; i < n; ++i) {
            sum_nw += a[i][j];
        }
        if (sum_nw != sm) {
            if (j1 == -1) {
                j1 = j;
            } else {
                j2 = j;
            }
        }
    }
    if (i2 != -1 && j2 != -1) {
        swap(a[i1][j1], a[i2][j2]);
        if (check(n, a, sm)) {
            cout << i1 + 1 << ' ' << j1 + 1 << ' ' << i2 + 1 << ' ' << j2 + 1 << '\n';
            return 0;
        }
        cout << i1 + 1 << ' ' << j2 + 1 << '\n' << i2 + 1 << ' ' << j1 + 1 << '\n';
        return 0;
    }
    if (i2 != -1) {
        long long sum1 = 0, sum2 = 0;
        for (int j = 0; j < n; ++j) {
            sum1 += a[i1][j];
            sum2 += a[i1][j];
        }
        for (int j = 0; j < n; ++j) {
            if (sum1 - a[i1][j] + a[i2][j] == sm) {
                cout << i1 + 1 << ' ' << j + 1 << '\n' << i2 + 1 << ' ' << j + 1 << '\n';
                return 0;
            }
        }
        assert(false);
    }
    if (j2 != -1) {
        long long sum1 = 0, sum2 = 0;
        for (int i = 0; i < n; ++i) {
            sum1 += a[i][j1];
            sum2 += a[i][j2];
        }
        for (int i = 0; i < n; ++i) {
            if (sum1 - a[i][j1] + a[i][j2] == sm) {
                cout << i + 1 << ' ' << j1 + 1 << '\n' << i + 1 << ' ' << j2 + 1 << '\n';
                return 0;
            }
        }
        assert(false);
    }
    assert(false);
    return 0;
}
