#include <bits/stdc++.h>

using namespace std;
using ll = long long;

const int N = 1009;

#define int long long

ll n, a[N][N], r[N], c[N];

bool check(int r1, int c1, int r2, int c2, ll val) {
    swap(a[r1][c1], a[r2][c2]);

    bool bad = 0;

    for (int i = 1; i <= n; i++) {
        ll sr = 0, sc = 0;

        for (int j = 1; j <= n; j++) {
            sr += a[i][j];
            sc += a[j][i];
        }

        if (sc != val || sr != val) bad = 1;
    }

    swap(a[r1][c1], a[r2][c2]);;

    return !bad;
}

int32_t main() {
    cin >> n;

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            cin >> a[i][j];
            r[i] += a[i][j];
            c[j] += a[i][j];
        }
    }

    for (int p = 1; p <= 3; p++) {
        ll e = r[p];

        vector < int > br, bc;

        for (int i = 1; i <= n; i++) if (r[i] != e) br.push_back(i);
        for (int i = 1; i <= n; i++) if (c[i] != e) bc.push_back(i);

        if ((int)br.size() > 2 ||(int)bc.size() > 2) continue;

        if ((int)br.size() == 2 && (int)bc.size() == 2) {
            if (check(br[0], bc[0], br[1], bc[1], e)) {
                cout << br[0] << " " << bc[0] << " " << br[1] << " " << bc[1];
                return 0;
            }

            if (check(br[1], bc[0], br[0], bc[1], e)) {
                cout << br[1] << " " << bc[0] << " " << br[0] << " " << bc[1];
                return 0;
            }
        }

        if ((int)br.size() == 2 && (int)bc.size() == 0) {
            int r1 = br[0], r2 = br[1];

            for (int j = 1; j <= n; j++) {
                if (r[r1] - a[r1][j] + a[r2][j] == e && r[r2] - a[r2][j] + a[r1][j] == e) {
                    cout << r1 << " " << j << " " << r2 << " " << j;
                    return 0;
                }
            }
        }

        if ((int)bc.size() == 2 && (int)br.size() == 0) {
            int c1 = bc[0], c2 = bc[1];

            for (int i = 1; i <= n; i++) {
                if (c[c1] - a[i][c1] + a[i][c2] == e && c[c2] - a[i][c2] + a[i][c1] == e) {
                    cout << i << " " << c1 << " " << i << " " << c2;
                    return 0;
                }
            }
        }
    }
}
