#include <iostream>
#include <vector>
#include <map>

using namespace std;

int module = 1e9 + 7;

int fact(int x) {
    int res = 1;
    for (int i = 1; i <= x; ++i) {
        res *= i;
        res %= module;
    }
    res %= module;
    return res;
}

int main() {
    int n;
    cin >> n;
    vector<int> dp(n, 1);
    dp[2] = 2;
    for (int i = 3; i < n; i++) {
        int res = i;
        for (int j = 2; j <= (i + 1) / 2; ++j) {
            int first = fact(i) / ((fact(j) * fact(i - j)) % module);
            int second = fact(i - j) / ((fact(i + 1 - (j * 2)) * fact((i - j) - (i + 1 - (j * 2)))) % module);
            res += (first * second) % module;
        }
        dp[i] = (dp[i - 1] * res) % module;
    }
    cout << dp[n - 1] % module;
    return 0;
}

//int main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
//    int n;
//    cin >> n;
//    vector<vector<int>> arr(n, vector<int>(n));
//    for (int i = 0; i < n; ++i) {
//        for (int j = 0; j < n; ++j) {
//            cin >> arr[i][j];
//        }
//    }
//    long long prev_sum = 0;
//    int r1 = 0, l1 = 0, r2 = 0, l2 = 0;
//    map<int, int> ans;
//    while (true) {
//        if (ans[arr[r1][l1]] == arr[r2][l2] || ans[arr[r2][l2]] == arr[r1][l1]) {
//            if (r2 == n - 1 && l2 == n - 1) {
//                if (l1 < n - 1) {
//                    l1++;
//                } else {
//                    l1 = 0;
//                    r1++;
//                }
//                r2 = 0;
//                l2 = 0;
//            } else if (l2 < n - 1) {
//                l2++;
//            } else {
//                l2 = 0;
//                r2++;
//            }
//        } else {
//            bool solved = true;
//            swap(arr[r1][l1], arr[r2][l2]);
//            for (int i = 0; i < n; ++i) {
//                long long sum_c = 0, sum_s = 0;
//                for (int j = 0; j < n; ++j) {
//                    sum_s += arr[i][j];
//                    sum_c += arr[j][i];
//                }
//                if (sum_c != sum_s) {
//                    swap(arr[r1][l1], arr[r2][l2]);
//                    solved = false;
//                    ans[arr[r1][l1]] = arr[r2][l2];
//                    ans[arr[r2][l2]] = arr[r1][l1];
//                    break;
//                } else {
//                    if (prev_sum != 0) {
//                        if (prev_sum != sum_c) {
//                            swap(arr[r1][l1], arr[r2][l2]);
//                            solved = false;
//                            prev_sum = 0;
//                            ans[arr[r1][l1]] = arr[r2][l2];
//                            ans[arr[r2][l2]] = arr[r1][l1];
//                            break;
//                        }
//                    } else {
//                        prev_sum = sum_c;
//                    }
//                }
//            }
//            if (solved) {
//                break;
//            } else {
//                if (r2 == n - 1 && l2 == n - 1) {
//                    if (l1 < n - 1) {
//                        l1++;
//                    } else {
//                        l1 = 0;
//                        r1++;
//                    }
//                    r2 = 0;
//                    l2 = 0;
//                } else if (l2 < n - 1) {
//                    l2++;
//                } else {
//                    l2 = 0;
//                    r2++;
//                }
//            }
//        }
//    }
//    cout << r1 + 1 << " " << l1 + 1 << "\n" << r2 + 1 << " " << l2 + 1;
//    return 0;
//}
