#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll inf = ll(2e18) + 36;
#define int long long
int mod = 1e9 + 7;


struct Fast {
    vector<vector<ll>> g;
    vector<ll> d;
    ll best = 1;
    void dfs(ll v = 0, ll p = -1, ll push = 0, ll cur = 0) {
        if (g[v].size() == 1 && v > 0) {
            best = max(best, cur);
            return;
        }
        if (!push) {
            cur++;
            push = d[v];
        }
        for (auto& u : g[v]) {
            if (u == p) continue;
            dfs(u, v, push - 1, cur);
        }
    }
    void solve() {
        ll n;
        cin >> n;
        g.resize(n);
        for (ll i = 1; i < n; i++) {
            ll p;
            cin >> p;
            p--;
            g[i].emplace_back(p);
            g[p].emplace_back(i);
        }
        queue<ll> q;
        d.resize(n, inf);
        for (ll i = 0; i < n; i++) {
            if (g[i].size() == 1 && i > 0) {
                q.push(i);
                d[i] = 0;
            }
        }
        while (!q.empty()) {
            ll v = q.front(); q.pop();
            for (auto& u : g[v]) {
                if (d[u] > d[v] + 1) {
                    q.push(u);
                    d[u] = d[v] + 1;
                }
            }
        }
        dfs();
        cout << best;
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int __ = 1;
    //cin>>__;
    while (__--) {
        auto s = Fast();
        s.solve();
    }
    return 0;
}
