#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll inf = ll(2e18) + 36;
#define int long long
int mod = 1e9 + 7;


struct Fast {
    int mul(int a, int b) {
        return 1ll * a * b % mod;
    }

    int add(int a, int b) {
        return (a + b < mod ? a + b : a + b - mod);
    }

    int sub(int a, int b) {
        return (a - b < 0 ? a - b + mod : a - b);
    }

    int binP(int a, ll n) {
        return (n ? n & 1 ? mul(a, binP(a, n - 1)) : mul(mul(a, a), binP(a, n / 2)) : 1);
    }

    void solve() {
        ll n;
        cin >> n;
        if (n == 1){
            cout << 2;
            exit(0);
        }
        vector<vector<ll>> dp1(n + 1, vector<ll>(n + 1, 0)); // sum, last
        dp1[1][1] = 1;
        for (int sum = 2; sum <= n; sum++) {
            for (int last = 1; last <= sum; last++) {
                dp1[sum][last] = add(dp1[sum][last], add(dp1[sum - last][last], dp1[sum - last][last - 1]));
            }
        }
        vector<vector<ll>> dp2(n, vector<ll>(n + 1, 0)); // els, sum
        dp2[0][n] = 1;
        for (int i = 1; i < n; i++) {
            int val = n - i;
            for (int sum = 0; sum <= n; sum++) {
                dp2[i][sum] = dp2[i - 1][sum];
                if (sum - val >= 0) {
                    dp2[i][sum] = add(dp2[i][sum], add(dp2[i][sum - val], dp2[i - 1][sum - val]));
                }
            }
        }
        int res = 0;
        dp1[0][0] = 1;
        dp2[0][0] = 1;
        for (int mex = 1; mex <= n + 1; mex++) {
            if (mex != 1 && mex != n && mex != n + 1) {
                for (int sum = 0; sum <= n; sum++) {
                    res = add(res, mul(mul(dp1[sum][mex - 1], dp2[n - (mex + 1)][n - sum]), mex));
                }
            } else if (mex == 1){
                res = add(res, dp2[n - 2][n]);
            } else if (mex == n + 1){
                res = add(res, mul(dp1[n][n], n + 1));
            } else {
                res = add(res, mul(dp1[n][n - 1], n));
            }
        }
        cout << res;
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int __ = 1;
    //cin>>__;
    while (__--) {
        auto s = Fast();
        s.solve();
    }
    return 0;
}
