#include <bits/stdc++.h>

#define ll long long
#define int long long
#define F first
#define S second
using namespace std;

struct st {
    vector<ll> sum;
    ll sz;

    st(ll len) {
        ll k = 1;
        while (k < len)
            k *= 2;
        sz = k * 2;
        sum.resize(sz);
    }

    void se(ll u, ll v) {
        u += sz / 2;
        sum[u] = v;
        while (u > 1) {
            u /= 2;
            sum[u] = sum[u * 2] + sum[u * 2 + 1];
        }
    }

    ll l, r;

    ll ask(ll _l, ll _r) {
        l = _l, r = _r;
        return ask(0, sz / 2, 1);
    }

    ll ask(ll L, ll R, ll now) {
        if (L >= l && R <= r)
            return sum[now];
        else if (L >= r || R <= l)
            return 0;
        else
            return ask(L, (R + L) / 2, now * 2) + ask((R + L) / 2, R, now * 2 + 1);
    }
};

ll n;
string s;

bool bad1(ll u) {
    if (u + 2 > n)
        return 0;
    if (s[u] == 'b' && s[u + 1] == 'b' && s[u + 2] == 'b')
        return 1;
    else
        return 0;
}

bool bad2(ll u) {
    if (u + 4 > n)
        return 0;
    if (s[u] == 'b' && s[u + 1] == 'b' && s[u + 2] == 'a' && s[u + 3] == 'b' && s[u + 4] == 'b')
        return 1;
    else
        return 0;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n >> s;
    s.push_back('b');
    std::reverse(s.begin(), s.end());
    s.push_back('b');
    std::reverse(s.begin(), s.end());

    st st1 = *new st(s.size());
    st st2 = *new st(s.size());

    for (int i = 0; i < n; ++i) {
        st1.se(i, bad1(i));
        st2.se(i, bad2(i));
    }

    ll _, h1, h2, h3;
    cin >> _;
    while (_--) {
        cin >> h1;
        if (h1 == 1) {
            cin >> h2;
            s[h2] = s[h2] == 'a' ? 'b' : 'a';
            for (int i = h2; i > max(0ll, h2 - 3); --i)
                st1.se(i, bad1(i));
            for (int i = h2; i > max(0ll, h2 - 5); --i)
                st2.se(i, bad2(i));
        } else {
            cin >> h2 >> h3;

            if (h3 - h2 == 0 && s[h2] == 'b') {
                cout << "NO\n";
                continue;
            } else {
                if (s[h2] == 'b' && s[h2 + 1] == 'b') {
                    cout << "NO\n";
                    continue;
                }

                if (s[h3] == 'b' && s[h3 - 1] == 'b') {
                    cout << "NO\n";
                    continue;
                }

                if (h3 - h2 == 2) {
                    if (s[h2] == 'b' && s[h3] == 'b') {
                        cout << "NO\n";
                        continue;
                    }
                } else {
                    if (s[h2] == 'b' && s[h2 + 1] == 'a' && s[h2 + 2] == 'b' && s[h2 + 3] == 'b') {
                        cout << "NO\n";
                        continue;
                    }
                    if (s[h3] == 'b' && s[h3 - 1] == 'a' && s[h3 - 2] == 'b' && s[h3 - 3] == 'b') {
                        cout << "NO\n";
                        continue;
                    }
                }
            }

            if (!st1.ask(h2, h3 - 2 + 1) && !st2.ask(h2, h3 - 4 + 1))
                cout << "YES\n";
            else
                cout << "NO\n";
        }
    }

    return 0;
}
/*
7
abbabba
4
2 3 4
2 3 5
1 6
2 3 7

7
abbbaba
10
2 1 7
2 1 4
2 4 7
1 4
2 1 7
1 5
2 1 7
2 1 4
2 1 3
2 5 7

7
abbabba
1
2 1 7


2 1 4
2 4 7
1 4
2 1 7
1 5
2 1 7
2 1 4
2 1 3
2 5 7

*/