#include <bits/stdc++.h>
using namespace std;
#define int long long
const int inf = 1e18;

vector<int> ver(1001), hor(1001);
vector<vector<int>> a;
int res;

void f() {
    int n = a.size();
    hor = a[0];
    for (int i = 1; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            hor[j] += a[i][j];
        }
    }
    for (int i = 0; i < n; ++i) ver[i] = a[0][i];
    for (int j = 1; j < n; ++j) {
        for (int i = 0; i < n; ++i) {
            ver[i] += a[i][j];
        }
    }
}

bool ok(int i1, int j1, int i2, int j2) {
    if (j1 != j2) {
        return (hor[i1] - a[i1][j1] + a[i2][j2] == res);
    }
    if (i1 != i2) {
        return (ver[j1] - a[i1][j1] + a[i2][j2] == res);
    }
}

signed main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n; cin >> n;
    a.resize(n, vector<int> (n));
    hor.resize(n);
    ver.resize(n);
    map<int, pair<int, int>> cc;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> a[i][j];
            cc[a[i][j]] = {i, j};
        }
    }
    f();
    res = n*n*(n*n + 1) / 2;
    res /= n;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (hor[i] == res) continue;
            int tmp = res - hor[i] + a[i][j];
            if (tmp == a[i][j]) continue;
            if (ok(i, j, cc[tmp].first, cc[tmp].second)) {
                cout << i + 1 << ' ' << j + 1 << '\n';
                cout << cc[tmp].first + 1 << ' ' << cc[tmp].second + 1 << '\n';
                return 0;
            }
        }
    }
    return 0;
}
