#include "bits/stdc++.h"

using namespace std;

#define int long long
#define vec vector
#define sz(a) (int)((a).size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rend(), (a).rbegin()

template<typename t>
istream& operator>>(istream& in, vector<t>& v) {
    for (auto& u: v) in >> u;
    return in;
}

const int maxn = 5005, mod = 1'000'000'007;

pair<int, bool> binpow(int a, int b) {
    int ans = 1, e = a;
    __int128 x = 1, e2 = a;
    while (b > 0) {
        if (b & 1) {
            ans = ans * e, x = x * e2;
            if (x > 2e18) return {0, 0};
        }
        b >>= 1; e = e * e; e2 = e2 * e2;
        if (b > 0 && e2 > 2e18) return {0, 0};
    }
    return {ans, 1};
}

void solve () {
    int n;
    cin >> n;
    int l = 0, r = 1e18;
    while (l + 1 != r) {
        int j = (l + r) / 2;
        cout << "? " << j << endl;
        int k;
        cin >> k;
        if (k > n) r = j;
        else l = j;
    }
    //cout << r << endl;
    int d_l = 1, d_r = 2024;
    while (d_l + 1 != d_r) {
        int j = (d_l + d_r) / 2;
        pair<int, bool> c = binpow(j, n + 1);
        pair<int, bool> d = binpow(j, n);
        if (!c.second) d_r = j;
        else {
            c.first -= d.first;
            if (r + c.first > 1e18) d_r = j;
            else {
                cout << "? " << r + c.first << endl;
                int k;
                cin >> k;
                if (k > n + 1) d_r = j;
                else d_l = j;
            }
        }
    }
    cout << "! " << binpow(d_r, n).first - r << " " << d_r << endl;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

#ifdef LOCAL
    //freopen("in.txt", "r", stdin);
#endif

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }

    return 0;
}