#include <iostream>
#include <vector>
# define int unsigned long long
using namespace std;

int factorial(int x, int m) {
    int res = 1;
    for (int i = 2; i <= x; i++) {
        res = (res *  i) % m;
    }
    return res;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n; cin >> n;
    int m = 1e9 + 7;
    vector<int> dp(n + 1);
    dp[1] = 1;

    for (int i = 2; i <= n; i++) {
        dp[i] = (factorial(i-1, m) * dp[i-1]) % m;
    }

    cout << dp.back();
    return 0;
}
