#include <bits/stdc++.h>

#define int long long

using namespace std;

const int INF  = 1e9, MAXN = (1 << 18), mod = 1e9 + 7;

int bin_pow(int n, int p) {
    int ans = 1;
    while (p) {
        if (p & 1) {
            ans *= n;
            ans %= mod;
        }
        n *= n;
        n %= mod;
        p /= 2;
    }
    return ans;
}

vector<int> fact(1e5 + 1, 1);
int C(int n, int k) {
    int ans = 1;
    ans *= fact[n];
    ans *= (bin_pow(fact[k], mod - 2));
    ans %= mod;
    ans *= (bin_pow(fact[n - k], mod - 2));
    ans %= mod;
    return ans;
}

void solve() {
    int n;
    cin >> n;
    for (int i = 1; i < 1e5 + 1; i++) {
        fact[i] = fact[i - 1] * i;
        fact[i] %= mod;
    }
    vector<int> a(n);
    vector<int> cnt(3, 0);
    for (auto &el : a) {
        cin >> el;
        cnt[el % 3]++;
    }
    if (abs(cnt[1] - cnt[2]) > 2 || cnt[1] == cnt[2]) {
        cout << 0;
        return;
    }
    int ans = 1;
    ans *= fact[cnt[1]];
    ans %= mod;
    ans *= fact[cnt[2]];
    ans %= mod;
    int nu = C(n - 1, cnt[2] + cnt[1] - 1);
    nu *= fact[cnt[0]];
    nu %= mod;
    ans *= nu;
    ans %= mod;
    cout << ans;
}

signed main() {
#ifdef home
    freopen("input.txt", "r", stdin);
#endif

    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int test = 1;
    //cin >> test;
    while (test--) {
        solve();
    }
}
// 1 2 0