#include <bits/stdc++.h>
 
using namespace std;
 
const int N = 2e5 + 7, K = 700;
int tin[N];
int dp[N];
vector <int> g[N];
vector <pair <int, int>> on_depth[N]; // <dp, tin>
int T = 0;
mt19937 rnd(239);
 
int get_max(int d, int tin_thresh) {
    auto &layer = on_depth[d];

    int r = (int) layer.size() - 1;
    int l = lower_bound(layer.begin(), layer.end(), tin_thresh, [](const auto &p, int v) { return p.second < v; }) - layer.begin();
    int ans = 0;
    for (int i = 0; i < min(K, r - l + 1); i++) {
        ans = max(ans, layer[l + i].first);
        ans = max(ans, layer[r - i].first);
        int rnd_pos = l + rnd() % (r - l + 1);
        ans = max(ans, layer[rnd_pos].first);
    }
    return ans;
}
 
int dfs(int v, int d = 0) {
    dp[v] = 0;
    tin[v] = T++;
    
    if (g[v].empty()) {
        return d;
    }
 
    int min_leaf_depth = -1;
    for (int u : g[v]) {
        int rec_min_leaf_depth = dfs(u, d + 1);
        if (min_leaf_depth == -1 || rec_min_leaf_depth < min_leaf_depth) {
            min_leaf_depth = rec_min_leaf_depth;
        }
    }

    dp[v] = 1 + get_max(min_leaf_depth, tin[v]);
    on_depth[d].emplace_back(dp[v], tin[v]);
    return min_leaf_depth;
}
 
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    
    int n;
    cin >> n;
    for (int i = 2; i <= n; i++) {
        int p;
        cin >> p;
        g[p].push_back(i);
    }
    dfs(1);
    cout << dp[1] << '\n';
    return 0;
}