#include <bits/stdc++.h>
 
using namespace std;
 
const char en = '\n';
 
#ifdef LOCAL
#include "debug.h"
#else
#define debug(...) 42
#endif
 
const int MOD = 1'000'000'000 + 7;
 
int mul(int a, int b) { return (1ll * a * b) % MOD; }
 
int binpow(int a, int n) {
    if (n == 0) { return 1; }
    if (n % 2 == 1) { return mul(a, binpow(a, n - 1)); }
    else {
        int b = binpow(a, n / 2);
        return mul(b, b);
    }
}
 
int del(int a, int b) { return mul(a, binpow(b, MOD - 2)); }
 
int sum(int a, int b) { return (a + b) % MOD; }
 
int sub(int a, int b) { return ((a - b) % MOD + MOD) % MOD; }
 
const int N = 100'005;
 
int fact[N];
int rfact[N];
 
int C(int n, int k) {
    return mul(fact[n], mul(rfact[k], rfact[n - k]));
}
 
void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    array<int, 3> cnt{};
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        ++cnt[a[i] % 3];
    }
    if (abs(cnt[1] - cnt[2]) != 1) {
        cout << 0 << en;
        return;
    }
    int ans = mul(fact[cnt[1]], fact[cnt[2]]);
    cout << ans << en;
}
 
int32_t main() {
#ifdef THEEVILBIRD
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    fact[0] = 1;
    rfact[0] = 1;
    for (int i = 1; i < N; ++i) {
        fact[i] = mul(fact[i - 1], i);
        rfact[i] = del(1, fact[i]);
    }
    solve();
    return 0;
}
