#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const char en = '\n';

#ifdef LOCAL
#include "debug.h"
#else
#define debug(...) 42
#endif

void solve() {
    int n;
    string s;
    int q;
    cin >> n >> s >> q;
    for (int w = 0; w < q; ++w) {
        int type;
        cin >> type;
        if (type == 1) {
            int i;
            cin >> i;
            --i;
            if (s[i] == 'a') {
                s[i] = 'b';
            } else {
                s[i] = 'a';
            }
        } else {
            int l, r;
            cin >> l >> r;
            --l;
            bool ok = true;
            for (int i = l; i < r; ++i) {
                if (s[i] == 'b' && (i == l || s[i - 1] == 'b')) {
                    for (int j = i; j < r; ++j) {
                        if (s[j] == 'b' && (j + 1 == r || s[j + 1] == 'b')) {
                            array<int, 2> cnt = {0, 0};
                            for (int k = i; k <= j; ++k) {
                                ++cnt[s[k] - 'a'];
                            }
                            if (cnt[0] < cnt[1]) {
                                ok = false;
                            }
                        }
                    }
                }
            }
            cout << (ok ? "YES" : "NO") << en;
        }
    }
}

int32_t main() {
#ifdef THEEVILBIRD
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    solve();
    return 0;
}
