#include<bits/stdc++.h>

using namespace std;

const int inf = (int)1e9 + 7;
const int N = (int)5e3 + 7;
const int MOD = (int)1e9 + 7;

int sum(int x, int y) {
    x += y;
    if(x >= MOD) {
        x -= MOD;
    }
    return x;
}

int mult(int x, int y) {
    return 1ll*x*y%MOD;
}

int n, dp[N], c[N][N];

int main() {
    ios_base::sync_with_stdio(NULL);
    cin.tie(0);
    c[0][0] = 1;
    for(int i = 1; i < N; ++i) {
        c[i][0] = 1;
        c[i][i] = 1;
        for(int j = 1; j < i; ++j) {
            c[i][j] = sum(c[i-1][j], c[i-1][j-1]);
        }
    }
    cin >> n;
    dp[1] = 1;
    dp[2] = 1;
    for(int i = 3; i <= n; ++i) {
        for(int x = 1; x < i; ++x) {
            int y = i-x-x;
            if(x + y > i-1 || x+x+y != i || y < 0) continue;
            dp[i] = sum(dp[i], mult(dp[i-1], c[i-1][x]));
        }
    }
    cout << dp[n];
    return 0;
}
