#include<bits/stdc++.h>

using namespace std;

const int inf = (int)1e9 + 7;
const int N = (int)3e5 + 7;
const int MOD = (int)1e9 + 7;

int sum(int x, int y) {
    x += y;
    if(x >= MOD) {
        x -= MOD;
    }
    return x;
}

int sub(int x, int y) {
    x -= y;
    if(x < 0) {
        x += MOD;
    }
    return x;
}

int mult(int x, int y) {
    return 1ll*x*y%MOD;
}

int ask(long long x) {
    cout << "? " << x << endl;
    int ans;
    cin >> ans;
    return ans;
}

int get(long long n, long long b) {
    int cnt = 1;
    long long val = 1;
    for(int i = 1; ; ++i) {
        if(val <= n/b) {
            cnt = i+1;
            val *= b;
        } else {
            break;
        }
    }
    return cnt;
}

int n;

int main() {
    ios_base::sync_with_stdio(NULL);
    cin.tie(0);
    cin >> n;
    long long lim = 1e9;
    lim *= 2024ll;
    long long l = 1, r = 10, ans = -1;
    while(l <= r) {
        long long mid = (l+r) >> 1;
        if(ask(mid) >= n+1) {
            ans = mid;
            r = mid-1;
        } else {
            l = mid+1;
        }
    }
    assert(ans != -1);
    for(int b = 2; b <= 2023; ++b) {
        long long cur = 1;
        bool is = 1;
        for(int i = 1; i <= n; ++i) {
            if(cur * b > lim) {
                is = 0;
                break;
            }
            cur *= b;
        }
        if(!is) {
            break;
        }
        assert(get(cur, b) == n+1);
        if(get(cur-ans, b) == n) {
            cout << "! " << cur-ans << ' ' << b << endl;
            return 0;
        }
    }
    return 0;
}
