# include <bits/stdc++.h>
# define nl '\n'
# define pb push_back

using namespace std;
using ll = long long;

const ll N = 1e5+5;
const ll inf = (ll)2e18 + 7;
const ll mod = 1e9 + 7;

ll fact[N];
ll binpow (ll x, ll n) {
    ll res = 1;
    while (n > 0) {
        if (n & 1) {
            res = (res * x) % mod;
        }
        x = (x * x) % mod;
        n >>= 1;
    }
    return res;
}
void precalc () {
    fact[0] = 1;
    for (ll i = 1; i < N; ++i) {
        fact[i] = fact[i - 1] * i % mod;
    }
}
void ma1n () {
    precalc();
    ll n;
    cin >> n;
    ll cnt[3] = {};
    for (ll i = 1; i <= n; ++i) {
        ll x;
        cin >> x;
        cnt[(x % 3)]++;
    }
    if (cnt[2] != cnt[1] && abs(cnt[2] - cnt[1]) <= 2) {
        ll x = cnt[2];
        ll y = cnt[1];
        ll z = cnt[0];
        ll ans = fact[x] * fact[y] % mod;
        ll val = fact[x + y - 1 + z] * binpow(fact[x + y - 1], mod - 2) % mod;
        ans = (ans * val) % mod;
        cout << ans;
    }
    else {
        cout << 0;
    }
}

signed main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    ma1n();
    return 0;
}
