﻿#include <vector>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <map>
#include <iostream>
#include <string>
#include <iomanip>
#include <cmath>
#define int long long
using ll = long long;
using namespace std;
const int mod = 1e9 + 7;
const int INF = 1e9 + 7;
#define get_time (double)clock() / (double)(CLOCKS_PER_SEC)
#ifndef ONLINE_JUDGE
#define debug(x) cerr << (#x) << ": " << x << endl;
#else
#define debug(x)
#endif
ll max(ll a, ll b) {
    return (a > b) ? a : b;
}
ll min(ll a, ll b) {
    return (a < b) ? a : b;
}
ll bs_sqrt(ll x) {
    ll left = 0, right = 2000000123;
    while (right > left) {
        ll mid = (left + right) / 2;
        if (mid * mid > x) {
            right = mid;
            continue;
        }
        left = mid + 1;
    }
    return left - 1;
}
int gcd(int a, int b) {
    while (a > 0 && b > 0) {
        int c = a;
        a = b % a;
        b = c;
    }
    return a + b;
}
int bin_pow(int a, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0) {
        ll t = bin_pow(a, n / 2);
        return (t * t) % mod;
    } else {
        ll t = bin_pow(a, n - 1);
        return (t * a) % mod;
    }
}
int rev(int x) {
    return bin_pow(x, mod - 2);
}
int mul(int a, int b) {
    return (a * b) % mod;
}
int make_add(int a, int b) {
    return (a + b) % mod;
}
vector<vector<int> > gr;
vector<int> min_len, h;
vector<int> dp;
void calc_len(int u) {
    for (auto to : gr[u]) {
        h[to] = h[u] + 1;
        calc_len(to);
    }
    if (gr[u].size() == 0) {
        min_len[u] = 0;
        return;
    }
    for (auto to : gr[u]) {
        min_len[u] = min(min_len[u], min_len[to] + 1);
    }
}
vector<map<int, int> > pereli;
void dfs(int u) {
    for (auto to : gr[u]) {
        dfs(to);
        if (pereli[to].size() > pereli[u].size()) swap(pereli[u], pereli[to]);
        for (auto c : pereli[to]) {
            pereli[u][c.first] = max(pereli[u][c.first], c.second);
        }
    }
    if (gr[u].size() == 0) return;
    int mn_len = min_len[u];
    int must_h = h[u] + mn_len;
    if (pereli[u].count(must_h) == 0) {
        dp[u] = 0;
    }
    else {
        int add = pereli[u][must_h];
        dp[u] = add + 1;
    }
    pereli[u][h[u]] = max(pereli[u][h[u]], dp[u]);
}
void solve() {
    int n;
    cin >> n;
    pereli = vector<map<int, int> >(n);
    dp = vector<int>(n, 0);
    h = vector<int>(n, 0);
    min_len = vector<int>(n, INF);
    gr = vector<vector<int > >(n);
    for (int i = 1; i < n; i++) {
        int p; cin >> p; p--;
        gr[p].push_back(i);
    }
    calc_len(0);
    dfs(0);
    cout << dp[0] + 1;
}
signed main() {
    cout << fixed << setprecision(20);
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
/*
3
4 5 2
3 9 7
8 1 6
*/