#include <bits/stdc++.h>

using namespace std;

//@formatter:off
using ll = long long;
template<typename T> istream &operator>>(istream &is, vector<T> &a);
template<typename T> ostream &operator<<(ostream &os, vector<T> &a);
//@formatter:on

ll bpow(ll x, ll k) {
    ll r = 1;
    while (k) {
        if (k & 1)
            r = r * x ;
        x = x * x;
        k >>= 1;
    }
    return r;
}

ll X = 1, B = 2;
ll get(ll x){
    if (X + x == 1) return 1;
    else return ceill(logl(X + x) / logl(B));
}

ll query(ll x){

    cout << "? " << x << endl;
    int len;
    cin >> len;
    return len;

}

signed main() {
    ll L;

    cin >> L;


    ll l = 1, r = 1;
    ll cnt = 0;
    while (bpow(r, L) <= 3e12 && r <= 2023) r++;
    while (r - l > 1){
        ll mid = (l + r) / 2;

        ll len = query(bpow(mid, L) + bpow(mid, L + 1));
        ++cnt;
        assert(cnt < 100);
        if (len - L >= 2) r = mid;
        else l = mid;
    }

    ll b = r;

    l = 0, r = 3e12;
    while (r - l > 1){
        ll mid = (l + r) / 2;
        if (query(mid) > L) r = mid;
        else l = mid;
        ++cnt;
        assert(cnt < 100);
    }

    cout << "! " << bpow(b, L) - r + 1 << " " << b << endl;
}

// region POZOR
template<typename T>
ostream &operator<<(ostream &os, vector<T> &a) {
    for (int i = 0; i < a.size(); i++)
        os << a[i] << " \n"[i == a.size() - 1];
    return os;
}

template<typename T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i: a)
        is >> i;
    return is;
}
// endregion