#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
const ll INF = 1e9 + 1;
const int MOD = 1e9 + 7;
#define int long long
#define endl "\n"

vector <vector <int>> sm;
vector <int> dp;
vector <int> m;
vector <int> h;

void dfs1(int v, int height, int p = -1){
    h[v] = height;
    for (int i = 0; i < (int)sm[v].size(); i++){
        int to = sm[v][i];
        if (to == p)
            continue;
        dfs1(to, height + 1, v);
        m[v] = min(m[to] + 1, m[v]);
    }
    if (m[v] == INF)
        m[v] = 0;
}

map <int, int> dfs(int v, int p = -1){
    map <int, int> res;
    vector <map <int, int>> g;
    for (int i = 0; i < (int)sm[v].size(); i++){
        int to = sm[v][i];
        if (to == p)
            continue;
        g.push_back(dfs(to, v));
        if ((int)g[0].size() < (int)g.back().size())
            swap(g[0], g.back());
    }
    if (g.empty()){
        dp[v] = 0;
        return {{h[v], 0}};
    }
    swap(g[0], res);
    for (int i = 1; i < (int)g.size(); i++){
        for (auto j:g[i]){
            res[j.first] = max(res[j.first], j.second);
        }
    }
    dp[v] = res[h[v] + m[v]] + 1;
    res[h[v]] = max(res[h[v]], dp[v]);
    return res;
}

mt19937 gen(600);

int f(int n){
    int res = 1;
    for (int i = 1; i <= n; i++)
        res *= i, res %= MOD;
    return res;
}
signed main() {
  //  ios_base::sync_with_stdio(false);
  //  cin.tie(nullptr);
    int n;
    cin >> n;
    vector <int> x(n);
    int cnt1 = 0, cnt2 = 0, cnt0 = 0;
    for (int i = 0; i < n; i++){
        cin >> x[i];
        if (x[i] % 3 == 1)
            cnt1++;
        if (x[i] % 3 == 2)
            cnt2++;
        if (x[i] % 3 == 0)
            cnt0++;
    }
    int a = cnt1, b = cnt2;
    a--;
    int ind = 0;
    while (a > 0 || b > 0){
        if (ind % 2 == 0)
            a--;
        else
            b--;
        ind++;
    }
    int ans = 0;
    if (a == 0 && b == 0){
        int res = f(cnt1) * f(cnt2);
        res %= MOD;
        int g = cnt1 + cnt2;
        for (int i = 0; i < cnt0; i++){
            res *= g;
            g++;
            res %= MOD;
        }
        ans += res;
    }
    a = cnt1, b = cnt2;
    b--;
    ind = 0;
    while (a > 0 || b > 0){
        if (ind % 2 == 0)
            b--;
        else
            a--;
        ind++;
    }
    if (a == 0 && b == 0){
        int res = f(cnt1) * f(cnt2);
        res %= MOD;
        int g = cnt1 + cnt2;
        for (int i = 0; i < cnt0; i++){
            res *= g;
            g++;
            res %= MOD;
        }
        ans += res;
    }
    ans %= MOD;
    cout << ans;
}