#include <bits/stdc++.h>
#define fast ios_base::sync_with_stdio(0); cin.tie(0);
#define int long long
#define all(r) r.begin(), r.end()

using namespace std;

const int MOD = 1e9 + 7;

signed main() {
    fast;
    int n;
    cin >> n;
    vector< vector<int> > matr(n, vector<int> (n));
    vector<int> row(n, 0), st(n, 0);
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < n; ++j)
        {
            cin >> matr[i][j];
            row[i] += matr[i][j];
            st[j] += matr[i][j];
        }
    }
    int correct = n * (n * n + 1) / 2;
    int r1 = -1, r2, s1 = -1, s2;
    for (int i = 0; i < n; ++i)
    {
        if (row[i] != correct)
        {
            if (r1 == -1)
            {
                r1 = i;
            }
            else
            {
                r2 = i;
            }
        }
        if (st[i] != correct)
        {
            if (s1 == -1)
            {
                s1 = i;
            }
            else
            {
                s2 = i;
            }
        }
    }
    if (r1 == -1)
    {
        for (int i = 0; i < n; ++i)
        {
            if (st[s1] - matr[i][s1] + matr[i][s2] == correct
                && st[s2] - matr[i][s2] + matr[i][s1] == correct)
            {
                cout << i + 1 << " " << s1 + 1 << endl;
                cout << i + 1 << " " << s2 + 1 << endl;
                return 0;
            }
        }
    }
    if (s1 == -1)
    {
        for (int i = 0; i < n; ++i)
        {
            if (row[r1] - matr[r1][i] + matr[r2][i] == correct
                && row[r2] - matr[r2][i] + matr[r1][i] == correct)
            {
                cout << r1 + 1 << " " << i + 1 << endl;
                cout << r2 + 1 << " " << i + 1 << endl;
                return 0;
            }
        }
    }
    if (row[r1] - matr[r1][s1] + matr[r2][s2] == correct
        && row[r2] - matr[r2][s2] + matr[r1][s1] == correct
        && st[s1] - matr[r1][s1] + matr[r2][s2] == correct
        && st[s2] - matr[r2][s2] + matr[r1][s1] == correct)
    {
        cout << r1 + 1 << " " << s1 + 1 << endl;
        cout << r2 + 1 << " " << s2 + 1 << endl;
        return 0;
    }
    cout << r1 + 1 << " " << s2 + 1 << endl;
    cout << r2 + 1 << " " << s1 + 1 << endl;
    return 0;
}
