#include <bits/stdc++.h>
using namespace std;
#define int long long

mt19937 rnd(23);
const int MOD = 1e9 + 7;

int ans = 0;
int cnt1 = 0, cnt2 = 0, cnt0 = 0;

void solve(int n, int one, int two, int zero, int now) {
    if (n == 0) {
        ans++;
        return;
    }
    if (one && (now + 1) % 3) {
        solve(n - 1, one - 1, two, zero, (now + 1) % 3);
    }
    if (two && (now + 2) % 3) {
        solve(n - 1, one, two - 1, zero, (now + 2) % 3);
    }
    if (zero) {
        solve(n - 1, one, two, zero - 1, now);
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        int a;
        cin >> a;
        if (a % 3 == 0) {
            cnt0++;
        } else if (a % 3 == 1) {
            cnt1++;
        } else {
            cnt2++;
        }
    }

    if (cnt1) {
        solve(n - 1, cnt1 - 1, cnt2, cnt0, 1);
    }
    if (cnt2) {
        solve(n - 1, cnt1, cnt2 - 1, cnt0, 2);
    }

    vector<int> fact(n + 1);
    fact[0] = 1;
    for (int i = 1; i <= n; i++) {
        fact[i] = fact[i - 1] * i % MOD;
    }
    ans *= fact[cnt0];
    ans %= MOD;
    ans *= fact[cnt1];
    ans %= MOD;
    ans *= fact[cnt2];
    cout << ans % MOD;
    return 0;
}
