#include <bits/stdc++.h>

using ll = long long;

const int M = 1e9 + 7;

void solve() {
    int n; std::cin >> n;
    ll ans = 1;
    std::vector<std::vector<ll>>C(n + 1, std::vector<ll>(n + 1, 1));
    for (int i = 2; i <= n; ++i) {
        for (int j = 1; j < i; ++j) {
            C[i][j] = C[i - 1][j - 1] + C[i - 1][j];
            if (C[i][j] >= M) {
                C[i][j] -= M;
            }
        }
    }
    for (int i = 2; i <= n; ++i) {
        ll sum = 0;
        for (int m = (i + 1) / 2; m < i; ++m) {
            sum += C[m][i - m] * C[i - 1][m] % M;
            if (sum >= M) {
                sum -= M;
            }
        }
        ans *= sum;
        ans %= M;
    }
    std::cout << ans << '\n';
}

int main() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    int t = 1;

    while (t--) {
        solve();
    }

    return 0;
}
