#include <iostream>
#include <vector>

using namespace std;

using ll = long long;
const ll MOD = 1000000007;
const int MAX_N = 100005;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    vector<ll> factorial(MAX_N);
    factorial[0] = 1;
    for (int i = 1; i < MAX_N; i++) factorial[i] = (i*factorial[i - 1])%MOD;;
    int n;
    cin >> n;
    ll a, b, c;
    a = b = c = 0;
    while(n--)
    {
        ll in;
        cin >> in;
        in %= 3;
        if (in == 0) a++;
        if (in == 1) b++;
        if (in == 2) c++;
    }
    ll ans = 1;
    if (b == c || abs(b - c) >= 3) ans = 0;
    for (ll i = a + b + c - 1; i >= b + c; i--) ans = (i*ans)%MOD;
    ans = (factorial[b]*ans)%MOD;
    ans = (factorial[c]*ans)%MOD;
    cout << ans;
    return 0;
}
