#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define rs resize
#define pb push_back
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define int long long

typedef pair<int, int> pii;

template<typename T>
istream &operator >>(istream &in, vector<T> &arr) {
    for (auto &i : arr) in >> i;
    return in;
}
template<typename T>
ostream &operator <<(ostream &in, vector<T> &arr) {
    for (auto &i : arr) in << i << " ";
    return in;
}
const int mod = 1e9 + 7;
int add(int x, int y) {
    int c = x + y;
    if (c >= mod)
        c -= mod;
    return c;
}

int sub(int x, int y) {
    int c = x * y % mod;
    return c;
}

int binpow(int x, int y) {
    if (y == 0) return 1;
    if (y % 2 == 1) return sub(x, binpow(x, y - 1));
    int a = binpow(x, y / 2);
    return sub(a, a);
}

void solve() {
    int n;
    cin >> n;
    vector<int> al(n);
    map<int, vector<int>> cnt;
    map<int, int> a;
    map<int, int> b;
    map<int, int> c;
    for (int i = 0; i < n; i++) {
        cin >> al[i];
        cnt[al[i] % 3].push_back(al[i]);
        if (al[i] % 3 == 0)
            a[al[i]]++;
        else if (al[i] % 3 == 1)
            b[al[i]]++;
        else
            c[al[i]]++;
    }
    if (cnt[1].size() - cnt[2].size() == 0 || abs(sz(cnt[1]) - sz(cnt[2])) > 2) {
        cout << 0;
        return;
    }
    vector<int> f(n + 2);
    f[0] = 1;
    for (int i = 1; i <= n + 1; i++)
        f[i] = sub(f[i - 1], i);
    vector<int> rf(n + 2);
    rf[n] = binpow(f[n], mod - 2);
    for (int i = n - 1; i >= 0; i--)
        rf[i] = sub(rf[i + 1], i + 1);


    int sm_a = 0;
    int p_a = 1;
    for (auto [x, y] : a) {
        sm_a = add(sm_a, y);
        p_a = sub(p_a, f[y]);
    }
    int cnt_a = sub(f[sm_a], binpow(p_a, mod - 2));

    int sm_b = 0;
    int p_b = 1;
    for (auto [x, y] : b) {
        sm_b = add(sm_b, y);
        p_b = sub(p_b, f[y]);
    }
    int cnt_b = sub(f[sm_b], binpow(p_b, mod - 2));

    int sm_c = 0;
    int p_c = 1;
    for (auto [x, y] : c) {
        sm_c = add(sm_c, y);
        p_c = sub(p_c, f[y]);
    }
    int cnt_c = sub(f[sm_c], binpow(p_c, mod - 2));

    int k = sz(cnt[0]);
    int ans = sub(cnt_a, sub(cnt_b, cnt_c));
    ans = sub(ans, f[n - 1]);
    ans = sub(ans, binpow(f[n  - k - 1], mod - 2));
    ans = sub(ans, binpow(f[k], mod - 2));
    cout << ans;
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
#ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    int tt = 1;
    //cin >> tt;

    while (tt--) {
        solve();
    }
}
