#include <iostream>
#include <algorithm>
#include <string>
#include <bitset>
#include <map>
#include <vector>
#include <chrono>
#include <queue>
#include <set>
using namespace std;

#define all(x) x.begin(), x.end()
using ll = long long;

struct node
{
	map<int,pair<int,int>> nums;
	ll res = 0;
	void add(pair<int, int> a, int cnt) {
		auto& x = nums[a.first];
		res -= max(x.first, x.second);
		if (a.second % 2 == 0)x.first+= cnt;
		else x.second+= cnt; 
		res += max(x.first, x.second);
	}
};

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	node xE, xO, yE, yO;

	map<pair<int, int>, bool>were;

	int n;
	cin >> n;
	while (n--)
	{
		int x, y;
		cin >> x >> y;
		int cnt = 1;
		if (were[{x, y}])cnt = -1, were[{x, y}] = false;
		else were[{x, y}] = true;
		if (x % 2 == 0)xE.add({ x,y }, cnt);
		if (x % 2 == 1)xO.add({ x,y }, cnt);
		if (y % 2 == 0)yE.add({ y,x }, cnt);
		if (y % 2 == 1)yO.add({ y,x }, cnt);
		cout << max(max(xE.res, xO.res), max(yE.res, yO.res)) << '\n'; 
	}
}

