#include <bits/stdc++.h>
#define int long long
using ll = long long;
using namespace std;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;

    vector<int> w(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }

    vector<int> d(n - 1);
    for (int i = 0; i < n - 1; i++) {
        cin >> d[i];
    }

    while (q--) {
        int t;
        cin >> t;

        if (t == 1) {
            int p, x;
            cin >> p >> x;
            w[p - 1] = x;
        } else if (t == 2) {
            int p, x;
            cin >> p >> x;
            d[p - 1] = x;
        } else {
            int l, r, x;
            cin >> l >> r >> x;

            l--, r--;

            int cur = LLONG_MAX;

            for (int left = 0; left <= x; left++) {
                int right = x - left;

                int ans = 0;

                vector<pair<int&, int>> back;
                back.emplace_back(w[l], w[l]);
                back.emplace_back(w[r], w[r]);

                if (w[l] > left) {
                    w[l] -= left;
                } else {
                    ans += left - w[l];
                    w[l] = 0;
                }

                if (w[r] > right) {
                    w[r] -= right;
                } else {
                    ans += right - w[r];
                    w[r] = 0;
                }

                vector<int> Q = {w[l]};
                vector<int> R = {d[l]};

                for (int i = l + 1; i < r; i++) {
                    R.push_back(R.back() + d[i]);
                }

                for (int i = l + 1; i <= r; i++) {
                    Q.push_back(Q.back() + w[i]);
                }

                int mn = 0;

                for (int i = 0; i < (int)R.size(); i++) {
                    mn = min(mn, Q[i + 1] - R[i]);
                }

                if (mn < 0) {
                    ans += -mn;
                }

                cur = min(cur, ans);

                for (const auto &p : back) {
                    p.first = p.second;
                }
            }

            cout << cur << '\n';
        }
    }
    return 0;
}
