#include "bits/stdc++.h"

using namespace std;
using ll = long long;

#define all(a) a.begin(), a.end()

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}

const ll MOD = 1e9+7;

void solve() {
    vector<vector<ll>> cnk(5001, vector<ll>(5001, 1));
    for (ll i = 1;i<cnk.size();i++){
        cnk[i][0]=1;
        cnk[i][i]=1;
        for (ll j = 1;j<i;j++){
            cnk[i][j] = (cnk[i-1][j] + cnk[i-1][j-1]) % MOD;
        }
    }
    ll n;
    cin >> n;
    ll ans = 1;
    for (ll i = 1;i<n;i++){
        ll res = 0;
        for (ll x = 1;x * 2 <= i+1;x++){
            ll y = i + 1 - x * 2;
            if (x + y <= i){
                res = (res + cnk[i][x] * cnk[i-x][y]) % MOD;
            }
        }
        ans =(ans*res)%MOD;
    }
    cout << ans << "\n";
}
