#include <bits/stdc++.h>

#define int long long
#define itn int
#define pii pair<int, int>
#define ff first
#define ss  second
#define X first
#define Y second
#define str string
#define db double
#define ld long double
#define ll long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
using namespace std;

const int MAXN = 1e5 + 10;
const int INF = 1e18;
const int maxn = MAXN;
const ld EPS = 1e-7;

void fastios() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n, vector<int>(n));
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < n; ++j)
            cin >> a[i][j];
    vector<int> row(n), col(n);
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < n; ++j) {
            row[i] += a[i][j];
            col[j] += a[i][j];
        }
    int s = (n * n + 1) * n / 2;
    int s1 = -1, s2 = -1;
    for (int i = 0; i < n; ++i)
        if (row[i] != s) {
            if (s1 == -1)
                s1 = i;
            else
                s2 = i;
        }
    if (s1 != -1 && s2 != -1) {
        for (int i = 0; i < n; ++i)
            for (int j = 0; j < n; ++j)
                if (row[s1] - a[s1][i] + a[s2][j] == s && row[s2] - a[s2][j] + a[s1][i] == s &&
                    (i != j && col[i] - a[s1][i] + a[s2][j] == s && col[j] - a[s2][j] + a[s1][i] == s)) {
                    cout << s1 + 1 << ' ' << i + 1 << '\n';
                    cout << s2 + 1 << ' ' << j + 1 << '\n';
                    return;
                }
    }
    s1 = -1, s2 = -1;
    for (int i = 0; i < n; ++i)
        if (col[i] != s) {
            if (s1 == -1)
                s1 = i;
            else
                s2 = i;
        }
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < n; ++j) {
            if (col[s1] - a[i][s1] + a[j][s2] == s && col[s2] - a[j][s2] + a[i][s1] == s) {
                cout << i + 1 << ' ' << s1 + 1 << '\n';
                cout << j + 1 << ' ' << s2 + 1 << '\n';
                return;
            }
        }
}


signed main() {
    fastios();
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    db time = clock();
#endif
    int ttt = 1;
    //cin >> ttt;
    while (ttt--) {
        solve();
    }
#ifdef LOCAL
    cerr << "Time: " << (clock() - time) / CLOCKS_PER_SEC << '\n';
#endif
}