#include <bits/stdc++.h>
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define allr(x) x.rbegin(), x.rend()
typedef long long ll;
using namespace std;

const ll MOD = 1e9 + 7;

void solve() {
    ll n;
    cin >> n;

    vector<vector<ll>> dp(n + 5, vector<ll> (n + 5));

    for (int j = 0; j <= n + 3; j++) dp[0][j] = 1;

    for (int i = 1; i <= n; i++) {
        for (int j = i - 1; j >= 0; j--) {
            dp[i][j] = (dp[i][j + 1] + dp[i - j - 1][j]) % MOD;
        }
    }

    vector<vector<ll>> dp2(n + 5, vector<ll> (n + 5));

    for (int j = 0; j <= n + 3; j++) dp2[0][j] = 1;

    for (int i = 1; i <= n; i++) {
        for (int j = 2; j <= n + 1; j++) {
            dp2[i][j] = dp2[i][j - 1];

            if (j <= i + 1) dp2[i][j] += dp2[i - j + 1][j];

            dp2[i][j] %= MOD;

            //cout << i << " " << j << " " << dp2[i][j] << endl;
        }
    }

    ll ans = 0;
    for (ll mex = 1; mex <= n + 1; mex++) {
        ll s = (mex * (mex - 1)) / 2;

        ll os = n - s;
        if (os < 0) break;

        ll ans2 = 0;
        for (ll sum1 = 0; sum1 <= os; sum1++) {
            ans2 += (dp2[sum1][mex] * dp[os - sum1][mex]) % MOD;
            ans2 %= MOD;
        }
        ans = (ans + (ans2 * mex) % MOD) % MOD;
        //cout << mex << " " << ans2 << " " << os << endl;
    }
    cout << ans << endl;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
}

