#include <bits/stdc++.h>

using namespace std;

#define endl "\n"

template<typename T>
istream& operator>>(istream& in, vector<T> &arr__) {
    for (auto &i : arr__) {
        in >> i;
    }
    return in;
}
template<typename T>
ostream& operator<<(ostream& out, vector<T> &arr__) {
    for (auto &i : arr__) {
        out << i << " ";
    }
    return out;
}

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using str = string;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
//#define int ll

#define fast cin.tie(0); cout.tie(0); cin.sync_with_stdio(0); cout.sync_with_stdio(0);
#define file(a, b) freopen(a, "r", stdin); freopen(b, "w", stdout);
#define p_b push_back
#define all(x) (x).begin() (x).end()
#define rall(x) (x).rbegin() (x).rend()

const int INT_INF = INT_MAX;
const ll LL_INF = LONG_LONG_MAX;

int n;
vector<vector<int>> g;

vector<int> min_d, sz, h;
void make_md_sz_h(int v) {
    min_d[v] = INT_INF;
    sz[v] = 1;
    for (auto u : g[v]) {
        h[u] = h[v] + 1;
        make_md_sz_h(u);
        min_d[v] = min(min_d[v], min_d[u] + 1);
        sz[v] += sz[u];
    }
    if (sz[v] == 1) {
        min_d[v] = 0;
    }
}

vector<int> dp;
vector<int> a;

void del(int v) {
    a[h[v]] = -1;
    for (auto u : g[v]) {
        del(u);
    }
}
void add(int v) {
    a[h[v]] = max(a[h[v]], dp[v]);
    for (auto u : g[v]) {
        add(u);
    }
}

void solve(int v) {
    if (sz[v] == 1) {
        dp[v] = -1;
        return;
    }

    int big = g[v][0];
    for (auto u : g[v]) {
        if (sz[big] < sz[u]) {
            big = u;
        }
    }

    for (auto u : g[v]) {
        if (u != big) {
            solve(u);
            del(u);
        }
    }

    solve(big);
    for (auto u : g[v]) {
        if (u != big) {
            add(u);
        }
    }

    int h_u = h[v] + min_d[v];
    if (h_u >= n) {
        dp[v] = 0;
    } else {
        dp[v] = a[h_u] + 1;
    }
    a[h[v]] = max(a[h[v]], dp[v]);
}

signed main() {
    file("inp.txt", "out.txt")
    fast

    cin >> n;
    g.resize(n);
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        p--;
        g[p].p_b(i);
    }

    min_d.resize(n);
    sz.resize(n);
    h.resize(n);
    h[0] = 0;
    make_md_sz_h(0);

    a.assign(n, -1);
    dp.resize(n);
    solve(0);

    cout << dp[0] + 1;
}
