#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

typedef long long ll;

signed main() {
	cin.tie(0);
	ios::sync_with_stdio(0);

	ll n, sm;
	cin >> n;
	sm = n * (n * n + 1) / 2;
	vector<vector<ll>> a(n, vector<ll>(n));
	vector<ll> ss(n), st(n);
	vector<ll> bds, bts;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			cin >> a[i][j];
			ss[i] += a[i][j];
			st[j] += a[i][j];
		}
	}
	for (int i = 0; i < n; ++i) {
		if (ss[i] != sm) {
			bds.push_back(i);
		}
		if (st[i] != sm) {
			bts.push_back(i);
		}
	}

	if (bds.size() == 0) {
		for (int i = 0; i < n; ++i) {
			for (auto j : bts) {
				for (auto u : bts) {
					if (st[j] - a[i][j] + a[i][u] == sm && st[u] - a[i][u] + a[i][j] == sm) {
						cout << i + 1 << ' ' << j + 1 << '\n';
						cout << i + 1 << ' ' << u + 1 << '\n';
						return 0;
					}
				}
			}
		}
	}

	if (bts.size() == 0) {
		for (int j = 0; j < n; ++j) {
			for (auto i : bds) {
				for (auto u : bds) {
					if (ss[i] - a[i][j] + a[u][j] == sm && ss[u] - a[u][j] + a[i][j] == sm) {
						cout << i + 1 << ' ' << j + 1 << '\n';
						cout << u + 1 << ' ' << j + 1 << '\n';
						return 0;
					}
				}
			}
		}
	}

	for (auto i : bds) {
		for (auto j : bts) {
			for (auto u : bds) {
				for (auto v : bts) {
					if (ss[i] - a[i][j] + a[u][v] == sm && ss[u] - a[u][v] + a[i][j] == sm) {
						if (st[j] - a[i][j] + a[u][v] == sm && st[v] - a[u][v] + a[i][j] == sm) {
							cout << i + 1 << ' ' << j + 1 << '\n';
							cout << u + 1 << ' ' << v + 1 << '\n';
							return 0;
						}
					}
				}
			}
		}
	}

	cout << "1 1\n1 1\n";

	return 0;
}