#include <iostream>
#include <vector>
#include <map>
using namespace std;

#define vi vector<int>
#define vvi vector<vector<int>>
#define ff first
#define ss second
#define pi pair<int, int>

int main()
{
	int n;
	cin >> n;
	vvi vec(n, vi(n));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			cin >> vec[i][j];
		}
	}
	
	if (n <= 3) {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				for (int x = 0; x < n; x++) {
					for (int y = 0; y < n; y++) {
						if (pi(i, j) == pi(x, y)) {
							continue;
						}
						swap(vec[i][j], vec[x][y]);
						vi v(n);
						vi h(n);
						for (int i = 0; i < n; i++) {
							for (int j = 0; j < n; j++) {
								v[j] += vec[i][j];
								h[i] += vec[i][j];
							}
						}
						bool ok = 1;
						for (int t = 0; t < n; t++) {
							if (v[0] != v[t]) {
								ok = 0;
							}
							if (h[0] != h[t]) {
								ok = 0;
							}
						}
						if (ok) {
							cout << i + 1 << ' ' << j + 1 << endl;
							cout << x + 1 << ' ' << y + 1 << endl;
							return 0;
						}
						swap(vec[i][j], vec[x][y]);
					}
				}
			}
		}
	}
	vi v(n);
	vi h(n);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			v[j] += vec[i][j];
			h[i] += vec[i][j];
		}
	}
	map<int, int> mh;
	map<int, int> mv;
	for (int i = 0; i < n; i++) {
		mh[h[i]]++;
	}
	for (int i = 0; i < n; i++) {
		mv[v[i]]++;
	}
	int vo = -1;
	int ho = -1;
	for (pi el : mh) {
		if (mh[ho] <= el.ss) {
			ho = el.ff;
		}
	}
	for (pi el : mv) {
		if (mv[vo] <= el.ss) {
			vo = el.ff;
		}
	}
	vi not_v;
	vi not_h;
	for (int i = 0; i < n; i++) {
		if (h[i] != ho) {
			not_h.push_back(i);
		}
		if (v[i] != vo) {
			not_v.push_back(i);
		}
	}
	if (!not_h.size()) {
		int a = not_v[0];
		int b = not_v[0];
		int d = v[a] - v[b];
		for (int i = 0; i < n; i++) {
			if (vec[a][i] - vec[b][i] == d) {
				cout << a + 1 << ' ' << i + 1 << endl;
				cout << b + 1 << ' ' << i + 1 << endl;
				return 0;
			}
		}
	}
	if (!not_v.size()) {
		int a = not_h[0];
		int b = not_h[0];
		int d = h[a] - h[b];
		for (int i = 0; i < n; i++) {
			if (vec[i][a] - vec[i][b] == d) {
				cout << a + 1 << ' ' << i + 1 << endl;
				cout << b + 1 << ' ' << i + 1 << endl;
				return 0;
			}
		}
	}
	pi a = { not_h[0], not_v[0] };
	pi b = { not_h[0], not_v[0] };
	int d = vec[a.ff][a.ss] - vec[b.ff][b.ss];
	if (d == h[a.ff] - h[b.ff] && d == v[a.ff] - v[b.ff]) {
		cout << a.ff << ' ' << a.ss << endl;
		cout << b.ff << ' ' << b.ss << endl;
	}
	cout << b.ff << ' ' << a.ss << endl;
	cout << a.ff << ' ' << b.ss << endl;
}

