#include <iostream>
#include <vector>
#include<cmath>
#include<algorithm>
#include<map>
#include<unordered_map>

using namespace std;

#define int long long
#define fir first
#define sec second
#define endl '\n'
#define pii pair<int,int>
#define all(u) u.begin(), u.end()
#define rall(u) u.rbegin(), u.rend()
#define pb push_back

int block = 340;
string s;

bool can(int l, int r) {
    if (l > r) {
        return true;
    }
    if (l == r) {
        if (s[l] == 'a') {
            return true;
        }
        return false;
    }
    if (s[l] == 'b') {
        if (s[l + 1] == 'b') {
            return false;
        }
        return can(l + 2, r);
    }
    if (s[l + 1] == 'b') {
        return can(l + 2, r);
    }
    return can(l + 1, r);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    cin >> s;
    vector<bool> lr(n + 1), l(n + 1), r(n + 1), a(n + 1);
    for (int i = 0; i < (n - 1) / block + 1; i++) {
        int left = i * block, right = min(n - 1, (i + 1) * block - 1);
        lr[i] = can(left, right);
        l[i] = can(left, right - 1);
        r[i] = can(left + 1, right);
        a[i] = can(left + 1, right - 1);
    }
    int q;
    cin >> q;
    while (q--) {
        int tt;
        cin >> tt;
        if (tt == 1) {
            int i;
            cin >> i;
            i--;
            if (s[i] == 'a') {
                s[i] = 'b';
            }
            else {
                s[i] = 'a';
            }
            int j = i / block;
            int left = j * block, right = min(n - 1, (j + 1) * block - 1);
            lr[j] = can(left, right);
            l[j] = can(left, right - 1);
            r[j] = can(left + 1, right);
            a[j] = can(left + 1, right - 1);
        }
        else {
            int x, y;
            cin >> x >> y;
            x--;
            y--;
            int i = x / block;
            int j = y / block;
            if (i == j) {
                if (can(x, y)) {
                    cout << "YES\n";
                }
                else {
                    cout << "NO\n";
                }
                continue;
            }
            bool rig = can(x, (i + 1) * block - 1), aaa = can(x, (i + 1) * block - 2);
            for (int t = i + 1; t < j; t++) {
                bool r1 = false, a1 = false;
                if (rig & lr[t]) {
                    r1 = true;
                }
                if (rig & l[t]) {
                    a1 = true;
                }
                if (aaa & r[t]) {
                    if (s[t * block] != s[t * block - 1]) {
                        r1 = true;
                    }
                }
                if (aaa & a[t]) {
                    if (s[t * block] != s[t * block - 1]) {
                        a1 = true;
                    }
                }
                rig = r1, aaa = a1;
            }
            int lefti = j * block, righti = y;
            bool r1 = false, a1 = false;
            if (rig & can(lefti, righti)) {
                r1 = true;
            }
            if (rig & can(lefti, righti - 1)) {
                a1 = true;
            }
            if (aaa & can(lefti + 1, righti)) {
                if (s[j * block] != s[j * block - 1]) {
                    r1 = true;
                }
            }
            if (aaa & can(lefti + 1, righti + 1)) {
                if (s[j * block] != s[j * block - 1]) {
                    a1 = true;
                }
            }
            rig = r1, aaa = a1;
            if (rig) {
                cout << "YES\n";
            }
            else {
                cout << "NO\n";
            }
        }
    }
}