#include<bits/stdc++.h>

using namespace std;

#define int long long

const int INF = 1e9 + 17;

vector <vector <int>> g;
vector <int> p;
vector <int> h;
vector <int> dist;
vector <vector <int>> a;

void dfs(int v)
{
    h[v] = h[p[v]] + 1;
    a[h[v]].push_back(v);
    if (g[v].size() == 0)
        dist[v] = 0;
    for (auto u : g[v])
    {
        if (u != p[v])
        dfs(u);
        dist[v] = min(dist[v], dist[u]+1);
    }
}

int dfs2(int v)
{
    int ans = -INF;
    if (dist[v] == 0) ans = 1;
    else
    for(auto u : a[h[v]+dist[v]])
    {
        ans = max(ans, dfs2(u)+1);
    }
    return ans;
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n;
    cin >> n;
    p.resize(n);
    h.resize(n);
    g.resize(n);
    dist.resize(n, INF);
    a.resize(n);

    int v;
    p[0] = 0;
    h[0] = -1;
    for (int i=1; i<n; i++)
    {
        cin >> v; v--;
        p[i] = v;
        g[v].push_back(i);
    }

    dfs(0);
    cout << dfs2(0)-1;

    return 0;
}