#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &i: a)in >> i;
    return in;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, const pair<T1, T2> &a) {
    out << a.first << ' ' << a.second;
    return out;
}

template<typename T>
ostream &operator<<(ostream &out, const vector<T> &a) {
    for (auto &i: a)out << i << '\n';
    return out;
}

vector<vector<int>> g;
vector<int> dist;
int n;
vector<int> dist2;

int bfs(int start) {
    if (g[start].empty())return 0;
    deque<int> q;
    q.push_back(start);
    dist[start] = 0;
    int z = dist2[start];
    while (!q.empty()) {
        int v = q.front();
        if (dist[v] == z)break;
        q.pop_front();
        for (auto u: g[v]) {
            dist[u] = dist[v] + 1;
            q.push_back(u);
        }
    }
    int ans = 0;
    for (auto u: q) {
        ans = max(ans, bfs(u));
    }
    return ans + 1;
}

void dfs(int v) {
    dist2[v]=n+1;
    if (g[v].empty()){
        dist2[v]=0;
        return;
    }
    for (auto u: g[v]) {
        dfs(u);
        dist2[v]=min(dist2[v], dist2[u]+1);
    }
}

void solve() {
    cin>>n;
    g.resize(n);
    dist2.resize(n);
    dist.resize(n);
    for (int i=1;i<n;i++){
        int p;
        cin>>p;
        g[p-1].push_back(i);
    }
    dfs(0);
    cout<<bfs(0);
}

signed main() {
#ifdef Local
    freopen("in.in", "r", stdin);
    freopen("out.out", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    ll t = 1;
    //cin>>t;
    while (t--) solve();
}