#include <bits/stdc++.h>

//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2")

#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define sz(x) ((int)(x).size())
#define ff first
#define ss second
#define pb push_back
#define eb emplace_back
#define ppb pop_back

#define int long long

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

int tmp;

int n;
vector<vector<int>> a;

bool check() {
    int sm_col = 0, sm_row = 0;
    for (int i = 0; i < n; ++i) {
        sm_row += a[0][i];
        sm_col += a[i][0];
    }
    for (int i = 1; i < n; ++i) {
        int sm = 0;
        for (int j = 0; j < n; ++j) {
            sm += a[i][j];
        }
        if (sm != sm_row) return false;
    }
    for (int j = 1; j < n; ++j) {
        int sm = 0;
        for (int i = 0; i < n; ++i) {
            sm += a[i][j];
        }
        if (sm != sm_col) return false;
    }
    return true;
}

void solve() {
    cin >> n;
    a.assign(n, vector<int>(n, 0));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> a[i][j];
        }
    }
    if (n < 5) {
        for (int r1 = 0; r1 < n; ++r1) {
            for (int r2 = r1; r2 < n; ++r2) {
                for (int c1 = 0; c1 < n; ++c1) {
                    for (int c2 = c1; c2 < n; ++c2) {
                        swap(a[r1][c1], a[r2][c2]);
                        if (check()) {
                            cout << r1 + 1 << " " << c1 + 1 << '\n';
                            cout << r2 + 1 << " " << c2 + 1 << '\n';
                            return;
                        }
                        swap(a[r1][c1], a[r2][c2]);
                        swap(a[r2][c1], a[r1][c2]);
                        if (check()) {
                            cout << r2 + 1 << " " << c1 + 1 << '\n';
                            cout << r1 + 1 << " " << c2 + 1 << '\n';
                            return;
                        }
                        swap(a[r2][c1], a[r1][c2]);
                    }
                }
            }
        }
        while (true) {}
    }
    map<int, vector<int>> cnt_rows, cnt_cols;
    for (int i = 0; i < n; ++i) {
        int sm = 0;
        for (int j = 0; j < n; ++j) {
            sm += a[i][j];
        }
        cnt_rows[sm].pb(i);
    }
    for (int j = 0; j < n; ++j) {
        int sm = 0;
        for (int i = 0; i < n; ++i) {
            sm += a[i][j];
        }
        cnt_cols[sm].pb(j);
    }
    vector<pii> rw, cl;
    for (auto [sm, ind]: cnt_rows) {
        if (sz(ind) <= 2) {
            for (int i: ind) rw.eb(i, sm);
        }
    }
    for (auto [sm, ind]: cnt_cols) {
        if (sz(ind) <= 2) {
            for (int i: ind) cl.eb(i, sm);
        }
    }
    if (sz(rw) == 2 && sz(cl) == 2) {
        int r1 = rw[0].ff, r2 = rw[1].ff, c1 = cl[0].ff, c2 = cl[1].ff;
        swap(a[r1][c1], a[r2][c2]);
        if (check()) {
            cout << r1 + 1 << " " << c1 + 1 << '\n';
            cout << r2 + 1 << " " << c2 + 1 << '\n';
            return;
        } else {
            cout << r2 + 1 << " " << c1 + 1 << '\n';
            cout << r1 + 1 << " " << c2 + 1 << '\n';
            return;
        }
    } else if (sz(rw) == 2) {
        int r1 = rw[0].ff, r2 = rw[1].ff;
        int sm1 = rw[0].ss, sm2 = rw[1].ss;
        for (int c = 0; c < n; ++c) {
            if ((sm1 - sm2) == 2 * (a[r1][c] - a[r2][c])) {
                cout << r1 + 1 << " " << c + 1 << '\n';
                cout << r2 + 1 << " " << c + 1 << '\n';
                return;
            }
        }
    } else {
        int c1 = cl[0].ff, c2 = cl[1].ff;
        int sm1 = cl[0].ss, sm2 = cl[1].ss;
        for (int r = 0; r < n; ++r) {
            if ((sm1 - sm2) == 2 * (a[r][c1] - a[r][c2])) {
                cout << r + 1 << " " << c1 + 1 << '\n';
                cout << r + 1 << " " << c2 + 1 << '\n';
                return;
            }
        }
    }
}

signed main() {
    int tt = 1;
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#else
    freopen("../input.txt", "r", stdin);
    cin >> tt;
#endif
    while (tt--) {
        solve();
        cout << '\n';
    }
    return 0;
}
