#include<bits/stdc++.h>
#define ll long long

using namespace std;

ll n, ans, MOD = 1e9 + 7;
vector<ll> a;

void input() {
    cin >> n;
    a.resize(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
    }
}

ll BVS(ll tek, ll step) {
    if (step == 1) {
        return tek;
    }
    if (step == 0) {
        return 1;
    }
    if (step % 2 == 0) {
        return BVS((tek * tek) % MOD, step / 2);
    } else {
        return (BVS(tek, step - 1) * tek) % MOD;
    }
}

ll obr(ll x) {
    return BVS(x, MOD - 2);
}

void solve() {
    vector<ll> fac(n + 1, 1), obrfac(n + 1, 1);
    for (ll i = 1; i < n + 1; i++) {
        fac[i] = (fac[i - 1] * i) % MOD;
    }
    for (ll i = 1; i < n + 1; i++) {
        obrfac[i] = obr(fac[i]);
    }
    ll c0 = 0, c1 = 0, c2 = 0;
    for (ll i = 0; i < n; i++) {
        if (a[i] % 3 == 0) {
            c0++;
        } else if (a[i] % 3 == 1) {
            c1++;
        } else {
            c2++;
        }
    }
    ans = 1;
    ans *= ((fac[c1 + c2 + c0 - 1] * obrfac[c0]) % MOD * obrfac[c1 + c2 + c0 - 1 - c0]) % MOD;
    ans %= MOD;
    if (c1 == c2 - 1 || c1 == c2 - 2 || c2 == c1 - 1 || c2 == c1 - 2) {
        ans *= (fac[c1] * fac[c2]) % MOD;
    } else {
        ans = 0;
        return;
    }
}

void output() {
    cout << ans;
}

signed main () {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    solve();
    output();
    return 0;
}
