#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
using namespace std;
using ll = long long;
using ld = long double;

const ll INF = 1e18;
const ll MOD = INF;


ll binpow(ll n, ll p)
{
	if (p == 0) return 1;
	if (p % 2 == 0)
	{
		ll b = binpow(n, p / 2);
		return (b * b) % MOD;
	}
	return (binpow(n, p - 1) * n) % MOD;
}


void solve()
{
	vector<set<pair<int, int>>>w(4);
	int n; cin >> n;
	for (int i = 0; i < n; ++i) {
		int x, y; cin >> x >> y;
		w[abs(x % 2) * 2 + abs(y % 2)].insert({ x,y });
		cout << max(max(w[0].size(), w[1].size()), max(w[2].size(), w[3].size())) << "\n";
	}
	
}

int main()
{
	int t = 1;
	//cin>>t;
	while (t--) solve();
}