#include <bits/stdc++.h>

using namespace std;

#define int long long
#define vi vector<int>
#define sz(x) (int)(x).size()
#define vvi vector<vi>
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define pb push_back

const int MOD = 1e9 + 7;

const int maxn = 2e5 + 31;

vi g[maxn];
int dp[maxn];
pair<int, int> dph[maxn];

struct sg {
    int n;
    vector<pair<int, int>> t;
    vi a;
    sg() {}
    sg(int n) : n(n) {
        t.resize(4 * n);
    }
    sg(const vi& a) : a(a) {
        n = sz(a);
        t.resize(4 * n, {0, 0});
    }
    void upd(int node, int l, int r, int idx, int val) {
        if (r < idx || l > idx) return;
        if (l == r) {
            t[node] = {val, idx};
            return;
        }
        int m = (l + r) >> 1;
        upd(2 * node, l, m, idx, val);
        upd(2 * node + 1, m + 1, r, idx, val);
        t[node] = max(t[2 * node],  t[2 * node + 1]);
    }
    pair<int, int> get(int node, int l, int r, int ql, int qr) {
        if (l > qr || ql > r) return {-1, 0};
        if (ql <= l && r <= qr) { return t[node]; }
        int m = (l + r) / 2;
        return max(get(2 * node, l, m, ql, qr), get(2 * node + 1, m + 1, r, ql, qr));
    }
};
sg st[maxn];

int timer = 0;
int tin[maxn];
int tout[maxn];
vi timeinh[maxn];
vi timeouth[maxn];
vi vh[maxn];
void tmm(int v, int h, int p) {
    tin[v] = ++timer;
    timeinh[h].pb(tin[v]);
    vh[h].pb(v);
    for (int u : g[v]) {
        if (u != p) {
            tmm(u, h + 1, v);
        }
    }
    tout[v] = ++timer;
    timeouth[h].pb(tout[v]);
}

void dfs(int v, int h, int p) {

    if (sz(g[v]) == 1 && v) {
        dp[v] = 1;
        dph[v] = {h, v};
        int idx = lower_bound(all(timeinh[h]), tin[v]) - timeinh[h].begin();
        st[h].upd(1, 0, st[h].n - 1, idx, 0);
        return;
    }
    dph[v] = {1e9, 0};
    for (int u : g[v]) {
        if (u != p) {
            dfs(u, h + 1, v);
            dph[v] = min(dph[v], dph[u]);
        }
    }
    int hh = h;
    h = dph[v].first;
    int idx = lower_bound(all(timeinh[h]), tin[dph[v].second]) - timeinh[h].begin();
    int idxl = lower_bound(all(timeinh[h]), tin[v]) - timeinh[h].begin();
    int idxr = upper_bound(all(timeouth[h]), tout[v]) - timeouth[h].begin() - 1;

    pair<int, int> res = {0, 0};

    res = max(res, st[h].get(1, 0, st[h].n - 1, idxl, idx - 1));

    res = max(res, st[h].get(1, 0, st[h].n - 1, idx + 1, idxr));
    dp[v] = res.first + 1;

    idx = lower_bound(all(timeinh[hh]), tin[v]) - timeinh[hh].begin();
    st[hh].upd(1, 0, st[hh].n - 1, idx, dp[v]);
}

void solve() {
    int n;
    cin >> n;
    for (int i = 1; i < n; ++i) {
        int j;
        cin >> j;
        --j;
        g[i].pb(j);
        g[j].pb(i);
    }
    tmm(0, 0, 0);
    for (int i = 0; i <= n; ++i) {
        st[i] = sg(vh[i]);
    }
    dfs(0, 0, 0);
    cout << dp[0] << endl;
}

signed main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
    // cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}