MOD = 1_000_000_007


def mult(x, y):
    return (x * y) % MOD


def fact(x):
    res = 1
    for i in range(1, x + 1):
        res = mult(res, i)
    return res


def power(x, p):
    if p == 0:
        return 1
    if p & 1:
        return mult(x, power(x, p ^ 1))
    q = power(x, p >> 1)
    return mult(q, q)


def c(n1, k1):
    return mult(fact(n1), power(mult(fact(k1), fact(n1 - k1)), MOD - 2))


n = int(input())
cnt = [0, 0, 0]
a = list(map(int, input().split()))
for i in range(n):
    cnt[a[i] % 3] += 1
if cnt[1] - cnt[2] in (-2, -1, 1, 2):
    print(mult(mult(mult(fact(cnt[1]), fact(cnt[2])), c(n - 1, cnt[1] + cnt[2] - 1)), fact(cnt[0])))
else:
    print(0)
