#include<bits/stdc++.h>
using namespace std;

string s;

const int N = 1e5;
struct node {
    int l = -1, r = -1;
    array<bool, 4> ok;

    node() {
        ok.fill(0);
    }
} tr[2 * N];

node merge(node left, node right) {
    if (left.l == -1) return right;
    if (right.r == -1) return left;
    node c;
    for (int c1 = 0; c1 < 4;++c1) {
        for (int c2 = 0; c2 < 4; ++c2) {
            int msk = (c1 & 1) | (c2 & 2);
            if ((c1 & 2) && (c2 & 1)) {
                if (left.ok[c1] && right.ok[c2]) c.ok[msk] = 1;
            }
            if (!(c1 & 2) && !(c2 & 1)) {
                if (s[left.r] != s[right.l] && left.ok[c1] && right.ok[c2]) c.ok[msk] = 1;
            }
        }
    }
    c.l = left.l;
    c.r = right.r;
    return c;
}

void update(int k) {
    k += s.size();
    tr[k] = node();
    tr[k].l = k - s.size();
    tr[k].r = k - s.size();
    tr[k].ok[0] = 0;
    tr[k].ok[1] = tr[k].ok[2] = 1;
    tr[k].ok[3] = s[k - s.size()] == 'a';
//    cout << k << ' ' << tr[k].l << ' ' << tr[k].r;
//    for (auto i : tr[k].ok) cout << ' ' << i;
//    cout << endl;
    while (k > 1) {
        k >>= 1;
        tr[k] = merge(tr[k << 1], tr[k << 1 | 1]);
//        cout << k << ' ' << tr[k].l << ' ' << tr[k].r;
//        for (auto i : tr[k].ok) cout << ' ' << i;
//        cout << endl;
    }
}

bool get(int l, int r) {
    node left, right;
    for (l += s.size(), r += s.size(); l <= r; l >>= 1, r >>= 1) {
        if (l & 1) left = merge(left, tr[l++]);
        if (~r & 1) right = merge(tr[r--], right);
    }
    return merge(left, right).ok[3];
}

int main() {
    cin.tie(0)->sync_with_stdio(0);

    int n;
    cin >> n;
    cin >> s;
    for (int i= 0; i < n; ++i) update(i);
    int q;
    cin >> q;
    while (q--) {
        int t;
        cin >> t;
        if (t == 1) {
            int k;
            cin >> k;
            --k;
            if (s[k] == 'a') s[k] = 'b';
            else s[k] = 'a';
            update(k);
        } else {
            int l, r;
            cin >> l >> r;
            --l,--r;
            if (get(l, r)) cout << "YES\n";
            else cout << "NO\n";
        }
    }
}