#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define pb push_back
#define all(a) a.begin(), a.end()
#define ve vector
#define F first
#define S second

ll fast_pow(ll a, ll b) {
    if (b == 0) {
        return 1;
    }
    if (b % 2 == 0) {
        ll d = fast_pow(a, b / 2);
        return d * d;
    }
    return a * (fast_pow(a, b - 1));
}

void solve1() {
    ll n;
    cin >> n;
    map<pair<ll, ll>, ll> cnt;
    set<pair<ll, ll>> used;
    for (int i = 0; i < n; i++) {
        ll x, y;
        cin >> x >> y;
        if (used.find({x, y}) == used.end()) {
            cnt[{x % 2, y % 2}]++;
            used.insert({x, y});
        } else {
            cnt[{x % 2, y % 2}]--;
            used.erase({x, y});
        }
        ll ans = 0;
        for (auto j: cnt) {
            ans = max(ans, j.second);
        }
        cout << ans << endl;
    }
}

void solve_3() {
    ll cnt = 0;
    ll n;
    cin >> n;
    ll l = 0;
    ll r = (1e9) * 2023 + 1;
    while (r - l > 1) {
        ll m = (l + r) / 2;
        cout << "? " << m << endl;
        cnt++;
        ll ans;
        cin >> ans;
        if (ans > n) {
            r = m;
        } else
            l = m;
    }
    cout << "? " << r << endl;
    ll k;
    cin >> k;
    ll d = r; // x + d = b ^ k
    l = 0;
    r = (1e9) * 2023 * 2023 + 1;
    while (r - l > 1) {
        ll m = (l + r) / 2;
        cout << "? " << m << endl;
        ll ans;
        cin >> ans;
        if (ans > n + 1)
            r = m;
        else
            l = m;
    }
    ll razn = r - d;
    for (ll i = 2; i < 2024; i++) {
        if ((i - 1) * (fast_pow(i, k - 1)) == razn) {
            cout << "! " << fast_pow(i, k - 1) - d << " " << i << endl;
            return;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve_3();
    return 0;
}


