#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define pb push_back
#define all(a) a.begin(), a.end()
#define ve vector
#define F first
#define S second

void solve2();
void solve1();
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve1();
    return 0;
}



void solve1() {
    ll n;
    cin >> n;
    ll a[n][n];
    for (auto &el: a) {
        for (auto &j: el)
            cin >> j;
    }
    ll total = n * (n * n + 1) / 2;
    ve<ll> stol, stro;

    for (int i = 0; i < n; ++i) {
        ll sum = 0;
        for (int j = 0; j < n; ++j) {
            sum += a[i][j];
        }
        if (sum != total)
            stol.pb(i);
    }
    for (int i = 0; i < n; ++i) {
        ll sum = 0;
        for (int j = 0; j < n; ++j) {
            sum += a[j][i];
        }
        if (sum != total)
            stro.pb(i);
    }
    if (stol.size() == 2 && stro.size() == 2) {
        ll x1 = stol[0], y1 = stro[0];
        ll x2 = stol[1], y2 = stro[1];
        swap(a[x1][y1], a[x2][y2]);
        bool flag = true;
        for (int i = 0; i < n; ++i) {
            ll sum = 0;
            for (int j = 0; j < n; ++j) {
                sum += a[i][j];
            }
            if (sum != total)
                flag = false;
        }
        for (int i = 0; i < n; ++i) {
            ll sum = 0;
            for (int j = 0; j < n; ++j) {
                sum += a[j][i];
            }
            if (sum != total)
                flag = false;
        }
        if (flag) {
            cout << x1 + 1 << ' ' << y1 + 1 << '\n' << x2 + 1 << ' ' << y2 + 1;
            return;
        }
        cout << stol[0] + 1 << ' ' << stro[1] + 1 << '\n' << stol[1] + 1 << ' ' << stro[0] + 1;
        return;
    }
    if (stro.size() == 0) {
        ll sum1 = 0, sum2 = 0;
        for (int j = 0; j < n; ++j) {
            sum1 += a[stol[0]][j];
            sum2 += a[stol[1]][j];
        }
        for (int j = 0; j < n; ++j) {
            if ((total == sum1 - a[stol[0]][j] + a[stol[1]][j]) && (total == sum2 - a[stol[1]][j] + a[stol[0]][j])) {
                cout << stol[0] + 1 << ' ' << j + 1 << '\n' << stol[1] + 1 << ' ' << j + 1;
                return;
            }
        }
    } else {
        ll sum1 = 0, sum2 = 0;
        for (int j = 0; j < n; ++j) {
            sum1 += a[j][stro[0]];
            sum2 += a[j][stro[1]];
        }
        for (int j = 0; j < n; ++j) {
            if ((total == sum1 - a[j][stro[0]] + a[j][stro[1]]) && (total == sum2 - a[j][stro[1]] + a[j][stro[0]])) {
                cout << j + 1 << ' ' << stro[0] + 1 << '\n' << j + 1 << ' ' << stro[1] + 1;
                return;
            }
        }
    }
}

vector<vector<ll>> g;
vector<ll> used, dp;
void do_dp(ll v) {
    ll cnt = 1e18;
    for (auto u : g[v]) {
        do_dp(u);
        cnt = min(cnt, dp[u] + 1);
    }
    if (cnt != 1e18) {
        dp[v] = cnt;
    }
}
ll ans = 0;
vector<ll> dist;
void dfs(ll v) {
    dist.push_back(v);
    for (auto u : g[v]) {
        dfs(u);
    }
    if ((int)g[v].size() == 0) {
        ll cnt = 0, ind = 0;
        while (ind < ll(dist.size()) - 1) {
            if (ind + dp[dist[ind]] < dist.size()) {
                cnt++;
            }
            ind += dp[dist[ind]];
        }
        ans = max(ans, cnt);
    }
    dist.pop_back();
}
void solve2() {
    ll n;
    cin >> n;
    g.resize(n);
    used.resize(n);
    dp.resize(n);
    for (int i = 1; i < n; i++) {
        ll v;
        cin >> v;
        v--;
        g[v].push_back(i);
    }
    do_dp(0);
    dfs(0);
    cout << ans;
}