import itertools

states = [
    None,
    None,
    [
        ((0, 'aa'), (1, 3, 'aa')),
        ((0, 'bb'), ('cc', 2, 'bb')),
        ((0, 'bc'), ('cb', None, 'bc')),
        ((0, 'ab'), (4, 'ac', 'ab')),
        ((0, 'ba'), (None, 'ca', 'ba')),
    ],
    [
        ((0, 'aa'), (1, 9, 16)),
        ((0, 'bb'), (2, 4, 7)),
        ((1, 'ca'), (None, 3, 'cca')),
        ((1, 'cb'), (None, 'ccc', 'ccb')),
        ((1, 'cc'), (5, 6, 'bcc')),
        ((1, 'bb'), (None, 'cba', 'cbb')),
        ((1, 'ca'), ('cbc', 'bcb', 'bca')),
        ((1, 'ba'), (None, 8, 'bba')),
        ((1, 'bb'), (None, 'bbc', 'bbb')),
        ((1, 'bb'), (10, 13, 'abb')),
        ((1, 'ac'), ('aca', 11, 12)),
        ((0, 'ca'), ('acc', 'baa', 'caa')),
        ((0, 'ca'), (None, 'bac', 'cac')),
        ((1, 'ab'), (14, 'acb', 15)),
        ((1, 'bc'), (None, 'aba', 'abc')),
        ((0, 'ca'), (None, 'bab', 'cab')),
        ((1, 'aa'), (None, 17, 'aaa')),
        ((1, 'ab'), (None, 'aac', 'aab')),
    ],
]

def solve_block(len_, i):
    state = 0
    while type(state) == int:
        args = states[len_][state][0]
        state = states[len_][state][1][get(args[0] + i, args[1])]
    return state

def solve_1(i):
    if get(i - 1, s[-1] + 'a') == 2:
        return 'a'
    elif get(i - 1, s[-1] + 'b') == 2:
        return 'b'
    return 'c'

'''def test_get(i, s_):
    return (s[i] == s_[0]) + (s[i + 1] == s_[1])

get = test_get

for s in itertools.product('abc', repeat=2):
    s = ''.join(s)
    print(s == solve_block(2, 0))'''

def get(i, s_):
    print('?', i + 1, s_, flush=True)
    return int(input())

while True:
    n = int(input())
    if n == 0:
        break
    s = ''
    for i in range(0, n, 3):
        if n - i >= 2:
            s += solve_block(min(3, n - i), i)
        else:
            s += solve_1(i)

    print('!', s, flush=True)