#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <queue>

using namespace std;
using ll = long long;
using pii = pair<int, int>;
using vint = vector<int>;
#define endl '\n'
#define all(x) x.begin(), x.end()
#define rep(x) for(int ri = 0; ri < x; ++ri)
//#define int long long

const long long INF = 1e9;

const long long LINF = 1e18;
int pred[3], dp[3];

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0);
	cout.precision(10);
	ll n;
	cin >> n;
	vector<vector<int>> v(n, vector<int>(n));
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			cin >> v[i][j];
		}
	}
	ll a = n * (n * n + 1) / 2;
	int r1 = 0, r2 = 0, c1 = 0, c2 = 0;
	for (int i = 0; i < n; ++i) {
		ll s = 0;
		for (int j = 0; j < n; ++j) {
			s += v[i][j];
		}
		if (s != a) {
			r1 = r2;
			r2 = i;
		}
	}
	for (int i = 0; i < n; ++i) {
		ll s = 0;
		for (int j = 0; j < n; ++j) {
			s += v[j][i];
		}
		if (s != a) {
			c1 = c2;
			c2 = i;
		}
	}
	ll s1 = 0, s2 = 0;
	for (int i = 0; i < n; ++i) {
		s1 += v[r1][i];
		s2 += v[r2][i];
	}
	if ((s1 - a == v[r1][c1] - v[r2][c2]) && (s2 - a == v[r2][c2] - v[r1][c1])) {
		cout << r1 + 1 << ' ' << c1 + 1 << '\n' << r2 + 1 << ' ' << c2 + 1;
	}
	else {
		cout << r1 + 1 << ' ' << c2 + 1 << '\n' << r2 + 1 << ' ' << c1 + 1;
	}
}