#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <random>
#include <queue>

using namespace std;
using ll = long long;
using pii = pair<int, int>;
using vint = vector<int>;
#define endl '\n'
#define all(x) x.begin(), x.end()
#define rep(x) for(int ri = 0; ri < x; ++ri)
#define int long long

const int INF = 2e9 + 7;
const long long LINF = 1e18 + 7;
const int MOD = 1e9 + 7;

ll fact(ll x) {
	ll ans = 1, k = 2;
	while (k <= x) {
		ans *= k;
		ans %= MOD;
		++k;
	}
	return ans;
}
int binpow(int a, int n) {
	if (!n)
		return 1;
	if (n % 2)
		return 1LL * binpow(a, n - 1) * a % MOD;
	int ans = binpow(a, n / 2);
	return 1LL * ans * ans % MOD;
}

signed main() {
	ios_base::sync_with_stdio(0); cin.tie(0);
	cout.precision(10);
	int n, el;
	cin >> n;
	vector<int> v(3, 0);
	for (int i = 0; i < n; ++i) {
		cin >> el;
		++v[el % 3];
	}
	if (v[1] - v[2] == 1 || v[1] - v[2] == 2 || v[1] - v[2] == -1 || v[1] - v[2] == -2) {
		ll a = 1;
		a *= fact(v[1]);
		a %= MOD;
		a *= fact(v[2]);
		a %= MOD;
		a *= fact(v[0]);
		a %= MOD;
		a *= fact(n - 1);
		a %= MOD;
		int d1 = binpow(fact(v[0]), MOD - 2);
		int d2 = binpow(fact(n - v[0] - 1), MOD - 2);
		a = 1LL * a * d1 % MOD;
		a = 1LL * a * d2 % MOD;
		cout << a;
	}
	else {
		cout << 0;
	}
}