#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

vector <ll> fac;
ll mod = 1e9 + 7;

ll st(ll a, ll n) {
    ll y = 1;
    while (n) {
        if (n % 2) y = y * a % mod;
        a = a * a % mod;
        n /= 2;
    }
    return y;
}

ll C(ll n, ll k) {
    return fac[n] * st(fac[k], mod-2) % mod * st(fac[n-k], mod-2) % mod;
}

ll F(ll a1, ll a2, ll a3) {
    if (a1+a2==0) return 0;
    if (a1-a2>2 || a1-a2<1) return 0;
    return fac[a1] * fac[a2] % mod * C(a2+a1+a3-1, a3) % mod * fac[a3] % mod;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n, a1 = 0, a2 = 0, a3 = 0, i, a;
    cin >> n;
    for (i = 0; i < n; i++) {
        cin >> a;
        if (a % 3 < 1) a3++;
        if (a % 3 == 1) a1++;
        if (a % 3 == 2) a2++;
    }
    fac.resize(100005, 1);
    for (i = 2; i < 100005; i++) fac[i] = fac[i-1] * i % mod;
    cout << (F(a1, a2, a3)+F(a2, a1, a3))%mod;
    return 0;
}