#include <bits/stdc++.h>
using namespace std;
using ll = long long;

//#define int ll
int MOD = 1e9 + 7;
const int MAX_N = 100005;
ll F[MAX_N];

ll binPow(ll x, ll p) {
    if (p == 0) {
        return 1;
    }

    ll half = binPow(x, p / 2);
    if (p & 1) {
        return (((half * half) % MOD) * x) % MOD;
    } else {
        return (half * half) % MOD;
    }
}

ll C(ll n, ll k) {
    if (k == 0) {
        return 1;
    }

    return (((F[n] * binPow(F[k], MOD - 2)) % MOD) * binPow(F[n - k], MOD - 2)) % MOD;
}

signed main() {
    F[0] = 1;
    for (ll i = 1; i < MAX_N; ++i) {
        F[i] = (F[i - 1] * i) % MOD;
    }
    cin.tie(nullptr)->sync_with_stdio(false);
    int n;
    cin >> n;
    vector<int> c(3, 0);
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        ++c[x % 3];
    }
    if (abs(c[1] - c[2]) > 2 || c[1] == c[2]) {
        cout << "0\n";
        return 0;
    }
    ll ok = F[c[2]] * F[c[0]] % MOD * F[c[1]] % MOD * C(n - 1, c[0]) % MOD;
    cout << ok << '\n';
}