#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    constexpr ll INF = 1e9 + 7;

#ifdef LOCAL
    ll X, B;
    cin >> X >> B;
#endif

    auto ask = [&](ll d) {
        cout << "? " << d << endl;
#ifdef LOCAL
        ll Y = X + d;
        ll w = 1;
        ll ans = 0;
        while (w <= Y) {
            ans += 1;
            w *= B;
        }
        cerr << Y << " " << B << ": " << ans << endl;
        return ans;

#else
        ll res;
        cin >> res;
        return res;
#endif
    };

    int K;
    cin >> K;

    ll lo = 0, hi = INF * 2023;

    while (lo + 1 < hi) {
        ll mid = lo + hi >> 1;
        if (ask(mid) != K) {
            hi = mid;
        } else {
            lo = mid;
        }
    }

    ll D1 = hi;

    lo = D1, hi = INF * 2023 * 2023;

    while (lo + 1 < hi) {
        ll mid = lo + hi >> 1;
        if (ask(mid) > K + 1) {
            hi = mid;
        } else {
            lo = mid;
        }
    }

    ll D2 = hi;
//    cerr << D2 - D1 << endl;
//    cerr << D1 << endl;
//    cerr << D2 << endl;

    for (int b = 2; b <= 2023; ++b) {
        ll sum = 0;
        ll pw1 = 1;
        for (int i = 1; i <= K; ++i) {
            pw1 *= b;
        }
        if (pw1 * b - pw1 == D2 - D1) {
            ll x = pw1 - D1;
            cout << "! " << x << " " << b << endl;
            break;
        }
    }

    return 0;
}