#define _CRT_SECURE_NO_WARNINGS

//#pragma  GCC optimize("O3, unroll-loops")
//#pragma GCC target("avx2, bmi, bmi2, lzcnt, popcnt")
//#pragma GCC optimize("trapv")
#include <bits/stdc++.h>

using namespace std;

#define stdin stdout

using lld = long long;
using lf = long double;
using ll = long long;
using ull = unsigned long long;
using ld = long double;

const ll mod = 1e9 + 7;

auto now_rand = chrono::high_resolution_clock::now();
mt19937 rnd(now_rand.time_since_epoch().count());

lld matrix[1001][1001], sumStolb[1001], sumLine[1001];

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(10);
    // Shablon
    lld n, i, j, sum, ideal;
    scanf("%lld", &n);
    for (i = 0; i < n; ++i) {
        sum = 0;
        for (j = 0; j < n; ++j) {
            scanf("%lld", &matrix[i][j]);
            sum += matrix[i][j];
        }
        sumLine[i] = sum;
    }
    for (j = 0; j < n; ++j) {
        sum = 0;
        for (i = 0; i < n; ++i)
            sum += matrix[i][j];
        sumStolb[j] = sum;
    }
    vector<lld> diffsI, diffsJ;
    ideal = n * (n * n + 1) / 2;
    for (i = 0; i < n; ++i)
        if (sumLine[i] != ideal)
            diffsI.push_back(i);
    for (j = 0; j < n; ++j)
        if (sumStolb[j] != ideal)
            diffsJ.push_back(j);
    if (diffsI.size() == 0) {
        lld firstJ = diffsJ[0], secondJ = diffsJ[1], firstI, secondI;
        for (i = 0; i < n; ++i) {
            firstI = i;
            secondI = i;
            // {firstI, firstJ}, {secondI, secondJ}
            if (
                sumStolb[firstJ] - matrix[firstI][firstJ] + matrix[secondI][secondJ] == ideal &&
                sumStolb[secondJ] - matrix[secondI][secondJ] + matrix[firstI][firstJ] == ideal) {
                printf("%lld %lld\n%lld %lld", firstI + 1, firstJ + 1, secondI + 1, secondJ + 1);
                return 0;
            }
            // {firstI, secondJ}, {secondI, firstJ}
            swap(firstJ, secondJ);
            if (
                sumStolb[firstJ] - matrix[firstI][firstJ] + matrix[secondI][secondJ] == ideal &&
                sumStolb[secondJ] - matrix[secondI][secondJ] + matrix[firstI][firstJ] == ideal) {
                printf("%lld %lld\n%lld %lld", firstI + 1, firstJ + 1, secondI + 1, secondJ + 1);
                return 0;
            }
        }
        return 0;
    }
    if (diffsJ.size() == 0) {
        lld firstJ, secondJ , firstI = diffsI[0], secondI = diffsI[1];
        for (i = 0; i < n; ++i) {
            firstJ = i;
            secondJ = i;
            // {firstI, firstJ}, {secondI, secondJ}
            if (sumLine[firstI] - matrix[firstI][firstJ] + matrix[secondI][secondJ] == ideal &&
                sumLine[secondI] - matrix[secondI][secondJ] + matrix[firstI][firstJ] == ideal) {
                printf("%lld %lld\n%lld %lld", firstI + 1, firstJ + 1, secondI + 1, secondJ + 1);
                return 0;
            }
            // {firstI, secondJ}, {secondI, firstJ}
            swap(firstJ, secondJ);
            if (sumLine[firstI] - matrix[firstI][firstJ] + matrix[secondI][secondJ] == ideal &&
                sumLine[secondI] - matrix[secondI][secondJ] + matrix[firstI][firstJ] == ideal) {
                printf("%lld %lld\n%lld %lld", firstI + 1, firstJ + 1, secondI + 1, secondJ + 1);
                return 0;
            }
        }
        return 0;
    }
    lld firstI = diffsI[0], secondI = diffsI[1], firstJ = diffsJ[0], secondJ = diffsJ[1];
    // {firstI, firstJ}, {secondI, secondJ}
    if (sumLine[firstI] - matrix[firstI][firstJ] + matrix[secondI][secondJ] == ideal &&
            sumStolb[firstJ] - matrix[firstI][firstJ] + matrix[secondI][secondJ] == ideal &&
            sumLine[secondI] - matrix[secondI][secondJ] + matrix[firstI][firstJ] == ideal &&
            sumStolb[secondJ] - matrix[secondI][secondJ] + matrix[firstI][firstJ] == ideal) {
        printf("%lld %lld\n%lld %lld", firstI + 1, firstJ + 1, secondI + 1, secondJ + 1);
        return 0;
    }
    // {firstI, secondJ}, {secondI, firstJ}
    swap(secondJ, firstJ);
    if (sumLine[firstI] - matrix[firstI][firstJ] + matrix[secondI][secondJ] == ideal &&
        sumStolb[firstJ] - matrix[firstI][firstJ] + matrix[secondI][secondJ] == ideal &&
        sumLine[secondI] - matrix[secondI][secondJ] + matrix[firstI][firstJ] == ideal &&
        sumStolb[secondJ] - matrix[secondI][secondJ] + matrix[firstI][firstJ] == ideal) {
        printf("%lld %lld\n%lld %lld", firstI + 1, firstJ + 1, secondI + 1, secondJ + 1);
        return 0;
    }
    return 0;
}
