#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define S second
#define F first

const int mod = 1e9 + 7;

const int N = 4e7 + 3;
int minP[N], primes[N], psz;
bitset<N> isPrime;

void sieve() {
    isPrime.set();
    isPrime[0] = isPrime[1] = 0;
    minP[0] = minP[1] = -1;
    psz = 0;
    for (int i = 2; i < N; ++i) {
        if (isPrime[i]) {
            // cerr << i << ' ';
            minP[i] = i;
            primes[psz++] = i;
        }
        for (int j = 0; j < psz && primes[j] <= minP[i] && primes[j] * 1ll * i < N; ++j) {
            int num = primes[j] * i;
            minP[num] = primes[j];
            isPrime[num] = false;
        }
    }
}

//int cnt = 0;
//ll xx = 1, bb = 2;
//int ask(ll d) {
//    cnt++;
//    assert(d != 0);
//    int ans  = 0;
//    ll tmp = xx + d;
//    while (tmp != 0) {
//        tmp /= bb;
//        ans++;
//    }
//    return ans;
//}

int ask(ll d) {
    cout << "? " << d << endl;
    int ans;
    cin >> ans;
    return ans;
}

ll binpow(ll x, ll k) {
    if (k == 0) return 1ll;
    if (k & 1) {
        return binpow(x, k - 1) * x;
    }
    ll c = binpow(x, k / 2);
    return c * c;
}

// на самом деле найдем x + 1 (добавляем к запросам 1 всегда)
void solve() {
    int k;
    cin >> k;

    ll r = 1;
    ll last_r;

    for (int i = 0; i < k; i++) {
        r *= 2023;
        if (r > 1e9 * 2023)
            r = 1e9 * 2023 + 4;
    }

    last_r = r;
    ll l = 0;
    while (l + 1 < r) {
        ll m = (l + r) / 2;
        if (ask(m) > k) r = m;
        else l = m;
    }
    ll q1 = r;

    l = 0, r = last_r * 2023;
    while (l + 1 < r) {
        ll m = (l + r) / 2;
        if (ask(m) > k + 1) r = m;
        else l = m;
    }
    ll q2 = r;

    ll e = q2 - q1;
    ll d = q1;
    map<ll, int> cnt_e;
    //map<ll, int> cnt_p_e;
    vector<ll> divs = {1};
    for (ll i = 2; i * i <= e; i++) {
        ll sub = e;
        if (sub % i == 0) {
            divs.emplace_back(i);
        }
        while (sub % i == 0) {
            cnt_e[i]++;
            sub /= i;
        }
    }

    vector<pair<int, int>> cndts; // {b, k}
    ll b = 0;
    for (auto x : divs) {
        ll mb = x + 1;
        if (binpow(mb, k) * (mb - 1) == e) {
            b = mb;
        }
    }

    ll x = binpow(b, k) - q1;
    cout << "! " << x << ' ' << b << endl;
    //cerr << cnt << endl;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    sieve();
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}