#ifdef LOCAL
#define _GLIBCXX_DEBUG
#define nl endl
#else
#define nl '\n'
#pragma GCC optimize("Ofast")
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define forn(i, n) for (decltype(n) i = 0; i < n; i++)
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define ll long long
#define ull unsigned long long
#define ld long double
#define _ <<" "<<

template <typename T> using ordered_set = trie<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

void solve(){
    ll mod = 1e9 + 7;

    int n;
    cin >> n;

    vector<vector<int>> C(5001, vector<int> (5001));
    C[0][0] = 1;
    for (int i = 1; i <= 5000; i++){
        C[i][0] = 1;
        for (int j = 1; j <= 5000; j++) C[i][j] = C[i - 1][j] + C[i - 1][j - 1], C[i][j] %= mod;
    }

    ll ans = 1;
    for(int i = 2; i < n + 1; i ++){
        ll sum = 0;
        for (int j = 1; j * 2 <= i; j++){
            sum += 1ll * C[i - 1][j] * C[i - j - 1][i - 2 * j] % mod;
            sum %= mod;
        }
        ans *= sum, ans %= mod;
    }

    cout << ans << nl;

}

signed main(){
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    cout << fixed << setprecision(15);

    int tt = 1;
//    cin >> tt;
    while(tt--) solve();
}

