#include <bits/stdc++.h>
using namespace std;
#define int long long
#define ll long long
#define eb emplace_back
#define pb push_back

const int MOD = 1e9 + 7;

bool check(vector<vector<int>> &a, int n) {
    vector<int> sum1(n), sum2(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            sum1[i] += a[i][j];
            sum2[j] += a[i][j];
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            if (sum1[i] != sum1[j] || sum2[i] != sum2[j] || sum1[i] != sum2[j] || sum1[j] != sum2[i])
                return false;
        }
    }
    return true;
}

int get_ans2(int cnt1, int cnt2) {
    int ans = cnt2, curr_mod = 2;
    cnt2--;
    while (cnt1 + cnt2 > 0) {
        if (curr_mod == 1) {
            ans = (ans * cnt1) % MOD;
            cnt1--;
            curr_mod = 2;
        } else {
            ans = (ans * cnt2) % MOD;
            cnt2--;
            curr_mod = 1;
        }
    }
    if (cnt1 < 0 || cnt2 < 0) ans = 0;
    return ans;
}

int get_ans1(int cnt1, int cnt2) {
    int ans = cnt1, curr_mod = 1;
    cnt1--;
    while (cnt1 + cnt2 > 0) {
        if (curr_mod == 1) {
            ans = (ans * cnt1) % MOD;
            cnt1--;
            curr_mod = 2;
        } else {
            ans = (ans * cnt2) % MOD;
            cnt2--;
            curr_mod = 1;
        }
    }
    if (cnt1 < 0 || cnt2 < 0) ans = 0;
    return ans;
}

void solve() {
    int n, cnt0 = 0, cnt1 = 0, cnt2 = 0;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        if (t % 3 == 0) cnt0++;
        if (t % 3 == 1) cnt1++;
        if (t % 3 == 2) cnt2++;
    }
    int ans = get_ans1(cnt1, cnt2) + get_ans2(cnt1, cnt2);
    int sz = cnt1 + cnt2;
    for (int i = cnt0; i > 0; --i) {
        ans = (ans * sz++) % MOD;
    }
    cout << ans << '\n';
//    int n;
//    cin >> n;
//    vector<vector<int>> a(n, vector<int> (n));
//    for (int i = 0; i < n; i++) {
//        for (int j = 0; j < n; j++) {
//            cin >> a[i][j];
//        }
//    }
//    if (n == 3) {
//        for (int i = 0; i < n * n; i++) {
//            for (int j = i + 1; j < n * n; j++) {
//                swap(a[i / n][i % n], a[j / n][j % n]);
//                if (check(a, n)) {
//                    cout << i / n  + 1 << " " << i % n + 1 << endl;
//                    cout << j / n + 1 << " " << j % n + 1 << endl;
//                    return;
//                }
//                swap(a[i / n][i % n], a[j / n][j % n]);
//            }
//        }
//        return;
//    }
//    vector<int> sum1(n), sum2(n);
//    for (int i = 0; i < n; i++)  {
//        for (int j = 0; j < n; j++) {
//            sum1[i] += a[i][j];
//            sum2[j] += a[i][j];
//        }
//    }
//    map<int, int> cnt;
//    for (int i = 0; i < n; i++) {
//        cnt[sum1[i]]++;
//        cnt[sum2[i]]++;
//    }
//    int res = -1;
//    for (auto [key, val] : cnt) {
//        if (val > cnt[res])
//            res = key;
//    }
//    int x1 = -1, y1 = -1, x2 = -1, y2 = -1;
//    for (int i = 0; i < n; i++) {
//        if (sum1[i] != res && x1 == -1)
//            x1 = i;
//        else if (sum1[i] != res)
//            x2 = i;
//    }
//    if (x2 == -1)
//        x2 = x1;
//    for (int i = 0; i < n; i++) {
//        if (sum2[i] != res && y1 == -1)
//            y1 = i;
//        else if (sum2[i] != res)
//            y2 = i;
//    }
//    if (y2 == -1)
//        y2 = y1;
//    swap(a[x1][y1], a[x2][y2]);
//    if (!check(a, n))
//        swap(x1, x2);
//    cout << x1 + 1 << " " << y1 + 1 << endl;
//    cout << x2 + 1 << " " << y2 + 1 << endl;
}

signed main() {
    cin.tie(0);
    ios::sync_with_stdio(0);
    int T = 1;
    //cin >> T;
    while (T--)
        solve();
    return 0;
}
