#include <bits/stdc++.h>
using namespace std;
void solve();
int main() {
#ifdef LOCAL
    freopen("input.txt","r",stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
#define int long long
#define endl '\n'
const int N=2e5+10,INF=2e15,MOD=1e9+7;
struct seg_tree{
    int t[4*N];
    void update(int v,int l,int r,int pos,int val){
        if(l==r){
            t[v]=val;
            return;
        }
        int m=(l+r)/2;
        if(pos<=m) {
            update(v * 2, l, m, pos, val);
        }else {
            update(v * 2 + 1, m + 1, r, pos, val);
        }
        t[v]=max(t[v*2],t[v*2+1]);
    }
    int get(int v,int l,int r,int tl,int tr){
        if(l>=tl && r<=tr){
            return t[v];
        }
        if(l>tr || r<tl){
            return -1;
        }
        int m=(l+r)/2;
        return max(get(v*2,l,m,tl,tr),get(v*2+1,m+1,r,tl,tr));
    }
};
seg_tree t;
vector<vector<int>> gr(N);
vector<vector<int>> gr2(N);
int ans[N];
int d[N];
int dlist[N];
int pos[N];
vector<int> mpc[N];
int tin[N],tout[N],timer=0;
bool upper(int f,int s){
    return tin[f]<=tin[s] && tout[f]>=tout[s];
}
void find(int v,int dist=0){
    d[v]=dist;
    mpc[d[v]].push_back(v);
    for(auto to:gr[v]){
        find(to,dist+1);
    }
}
void dfs2(int v){
    tin[v]=timer++;
    dlist[v]=INF;
    for(auto to:gr[v]){
        dfs2(to);
        if(dlist[v]>dlist[to]+1){
            pos[v]=pos[to];
        }
        dlist[v]=min(dlist[v],dlist[to]+1);
    }
    if(gr[v].empty()){
        pos[v]=v;
        dlist[v]=0;
    }
    tout[v]=timer++;
}
int n;
void dfs(int v){
    auto cd=&d;
    auto cpos=&pos;
    auto cmpc=&mpc;
    auto cans=&ans;
    for(auto to:gr[v]){
        dfs(to);
    }
    if(gr[v].empty()){
        ans[v]=0;
    }else{
        int need=d[v]+dlist[v];
        int l=0,r=mpc[need].size();
        while(l+1<r){
            int m=(l+r)/2;
            if(mpc[need][m]<=pos[v]){
                l=m;
            }else{
                r=m;
            }
        }
        int posv=l;
        l=-1,r=posv;
        while(l+1<r){
            int m=(l+r)/2;
            if(upper(v,mpc[need][m])){
                r=m;
            }else{
                l=m;
            }
        }
        int cl=r;
        l=posv;
        r=mpc[need].size();
        while(l+1<r){
            int m=(l+r)/2;
            if(upper(v,mpc[need][m])){
                l=m;
            }else{
                r=m;
            }
        }
        int cr=l;
        int val=t.get(1,0,n-1,mpc[need][cl],mpc[need][cr]);
        ans[v]=val+1;
        t.update(1,0,n-1,v,val+1);
    }
}
int mp[N];
void solve() {
    cin>>n;
    for(int i=0;i<n-1;i++){
        int p;
        cin>>p;
        p--;
        gr2[p].push_back(i+1);
    }
    queue<int> q;
    q.push(0);
    vector<bool> used(n+1,false);
    int cur=0;
    while(!q.empty()){
        int v=q.front();
        q.pop();
        used[v]=true;
        mp[v]=cur++;
        for(auto to:gr2[v]){
            if(!used[to]){
                q.push(to);
            }
        }
    }
    for(int i=0;i<n;i++){
        for(auto y:gr2[i]){
            gr[mp[i]].push_back(mp[y]);
        }
    }
    dfs2(0);
    find(0);
    for(int i=0;i<n;i++){
        sort(mpc[i].begin(),mpc[i].end());
    }
    dfs(0);
    cout<<ans[0]<<endl;
}