#include <bits/stdc++.h>
using namespace std;
void solve();
int main() {
#ifdef LOCAL
    freopen("input.txt","r",stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
#define int long long
#define endl '\n'
const int N=2e5+10,INF=2e15;
bool magic(vector<vector<int>>&a){
    int n=a.size();
    vector<int> col(n, 0), row(n, 0);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            row[i] += a[i][j];
            col[j] += a[i][j];
        }
    }
    int nsum = (n) * (n * n + 1) / 2;
    vector<int> pr, pc;
    for (int i = 0; i < n; i++) {
        if (row[i] != nsum) {
            return false;
        }
        if (col[i] != nsum) {
            return false;
        }
    }
    return true;
}
void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n, vector<int>(n));
    vector<int> col(n, 0), row(n, 0);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
            row[i] += a[i][j];
            col[j] += a[i][j];
        }
    }
    int nsum = (n) * (n * n + 1) / 2;
    vector<int> pr, pc;
    for (int i = 0; i < n; i++) {
        if (row[i] != nsum) {
            pr.push_back(i);
        }
        if (col[i] != nsum) {
            pc.push_back(i);
        }
    }
    if(pc.empty() && pr.empty()){
        cout<<"1 1"<<endl<<"1 1"<<endl;
        return;
    }
    if (pr.size() == 0 && pc.size()>=2) {
        for(int i=0;i<n;i++){
            if(pc[0]-a[i][pc[0]]+a[i][pc[1]]==nsum){
                if(pc[1]-a[i][pc[1]]+a[i][pc[0]]==nsum){
                    cout<<i+1<<" "<<pc[0]+1<<" "<<i+1<<" "<<pc[1]+1<<endl;
                    return;
                }
            }
        }
    } else if (pc.size() == 0 && pr.size()>=2) {
        for(int i=0;i<n;i++){
            if(pr[1]-a[pr[1]][i]+a[pr[0]][i]==nsum){
                if(pr[0]-a[pr[0]][i]+a[pr[1]][i]==nsum){
                    cout<<pr[0]+1<<" "<<i+1<<" "<<pr[1]+1<<" "<<i+1<<endl;
                    return;
                }
            }
        }
    }else if(pr.size()>=2 && pc.size()>=2){
        swap(a[pr[0]][pc[0]],a[pr[1]][pc[1]]);
        if(magic(a)){
            cout<<pr[0]+1<<" "<<pc[0]+1<<endl<<pr[1]+1<<" "<<pc[1]+1<<endl;
            return;
        }
        cout<<pr[0]+1<<" "<<pc[1]+1<<endl<<pr[1]+1<<" "<<pc[0]+1<<endl;
    }else{
        cout<<"1 1"<<endl<<"1 1"<<endl;
    }
}
