#include <iostream>
#include <string>
#include <vector>

#include <map>

const int none = 1000;

int main()
{
	std::map<char, int> map;
	for (int i = 0; i < 26; i++)
		map[i + 'a'] = none;
	std::string s;
	std::cin >> s;
	int size;
	std::cin >> size;
	while (size--)
	{
		char a;
		int b;
		std::cin >> a >> b;
		map[a] = b;
	}
	std::vector<int> count(26);
	long long res = 0;
	for (auto i : s)
	{
		count[i - 'a']++;
	}
	for (int i = 0; i < count.size(); i++)
	{
		if (count[i] == 0)
			continue;
		char c = i + 'a';
		int cnt = count[i];
		res += cnt;
		if (map[c] == none)
			continue;
		res += count[i] / map[c];
		if (count[i] % map[c] == 1)
			res += 2;
		else if (count[i] % map[c])
			res++;
	}
	std::cout << res << '\n';
	return 0;
}