#include <bits/stdc++.h>
using namespace std;

#ifdef DEBUG
ofstream debug("debug.txt");
#else
#define debug if(false) cerr
#endif

typedef long long ll;

const int MOD = 1e9 + 7;
ll ans = 0;
const int mxN = 2000;
ll dp[mxN][mxN]; // starting with i, sum j
ll dp_pref[mxN][mxN]; // starting with i, sum j

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int n;
    cin >> n;
    for (int i = 0; i <= n + 2; ++i) {
        for (int j = 0; j <= n; ++j) {
            dp[i][j] = 0;
            dp_pref[i][j] = 0;
        }
    }

    dp_pref[0][0] = 1;
    for (int i = 1; i <= n; ++i) {
        for (int sum = i; sum <= n; ++sum) {
            dp_pref[i][sum] = (dp_pref[i][sum] + dp_pref[i - 1][sum - i] + dp_pref[i][sum - i]) % MOD;
        }
    }

    dp[n + 2][0] = 1;
    for (int i = n + 1; i > 0; --i) {
        for (int sum = 0; sum <= n; ++sum) {
            dp[i][sum] = dp[i + 1][sum];
        }
        for (int sum = i; sum <= n; ++sum) {
            dp[i][sum] = (dp[i][sum] + dp[i][sum - i]) % MOD;
        }
    }
    for (int i = 1; i <= n + 1; ++i) {
        for (int pref = 0; pref <= n; ++pref) {
            ans =(ans + i * ((dp_pref[i - 1][pref] * dp[i + 1][n - pref]) % MOD)) % MOD;
        }
        debug << ans << endl;
    }
    cout << ans << endl;
    return 0;
}
