#include <bits/stdc++.h>

#define int int64_t
#define pb push_back
#define fi first
#define se second

using namespace std;

const int INF = 2e18, N = 4e5 + 50;
vector <int> g[N];
int h[N], tin[N], tout[N], calc[N], timer = 0;
int kol[N];

struct segtree {
    vector <int> t;
    int sz;
    void Resize (int n) {
        sz = n;
        t.resize(4 * n, 0);
    }
    void upd (int v, int vl, int vr, int pos, int x) {
        if (vl == vr) {
            t[v] = x;
            return;
        }
        int mid = (vl + vr) / 2;
        if (pos <= mid) {
            upd(v * 2, vl, mid, pos, x);
        } else {
            upd(v * 2 + 1, mid + 1, vr, pos, x);
        }
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }
    int get (int v, int vl, int vr, int l, int r) {
        if (vl > vr || l > r || vl > r || l > vr) {
            return 0;
        }
        if (vl >= l && vr <= r) {
            return t[v];
        }
        int mid = (vl + vr) / 2;
        return max(get(v * 2, vl, mid, l, r), get(v * 2 + 1, mid + 1, vr, l, r));
    }
    void upd (int pos, int x) {
        upd(1, 0, sz - 1, pos, x);
    }
    int get (int l, int r) {
        return get(1, 0, sz - 1, l, r);
    }
};

void DFS (int v) {
    kol[h[v]]++;
    tin[v] = timer++;
    for (auto to : g[v]) {
        h[to] = h[v] + 1;
        DFS(to);
    }
    tout[v] = timer++;
}

int dfs (int v) {
    if (g[v].size() == 0) {
        return calc[v] = 0;
    }
    for (auto to : g[v]) {
        calc[v] = min(calc[v], dfs(to) + 1);
    }
    return calc[v];
}

bool upper (int a, int b) {
    return (tin[a] <= tin[b] && tout[a] >= tout[b]);
}

vector <int> w[N];
segtree t[N];
int dp[N];

void go (int v) {
    if(calc[v] == 0) {
        w[h[v]].push_back(tin[v]);
        t[h[v]].upd(w[h[v]].size() - 1, 0);
        return;
    }
    for (auto to : g[v]) {
        go(to);
    }
    int nh = h[v] + calc[v];
    int l = 0, r = w[nh].size() - 1, res1 = -1;
    while (l <= r) {
        int mid = (l + r) / 2;
        if (tin[w[nh][mid]] >= tin[v]) {
            res1 = mid;
            r = mid - 1;
        } else {
            l = mid + 1;
        }
    }
    if (res1 != -1)
        dp[v] = 1 + t[nh].get(res1, w[nh].size() - 1);
    else
        dp[v] = 1;
    w[h[v]].push_back(tin[v]);
    t[h[v]].upd(w[h[v]].size() - 1, dp[v]);
}

int32_t main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n;
    cin >> n;
    for (int i = 2; i <= n; ++i) {
        int p;
        cin >> p;
        g[p].push_back(i);
    }
    DFS(1);
    fill(calc, calc + N, INF);
    dfs(1);
    for (int i = 0; i < n; ++i) {
        t[i].Resize(kol[i]);
    }
    go(1);
    cout << dp[1];
}
