#include <bits/stdc++.h>

#define pp pair<int,int>
#define all(x) x.begin(),x.end()
#define ll long long


using namespace std;

template<class T> istream& operator>>(istream& is,vector<T>& arr) { for(auto &i:arr) is>>i; return is;}
template<class T> ostream& operator<<(ostream& os,vector<T>& arr) { for(auto &i:arr) os<<i<<" "; return os;}

map<int, vector<int>> g;
int dp[200200]{};

int pre_calc(int v) {
    if (g[v].empty()) {
        dp[v] = 0;
        return 1;
    }
    int ans = 500200;
    for(auto x:g[v]) {
        ans = min(ans, pre_calc(x));
    }
    dp[v] = ans;
    return dp[v] + 1;
}

int result = 0;

void dfs(int v, int last, int cost) {
    if (g[v].empty()) return;
    if (last == 0) {
        cost++;
        last = dp[v];
    }
    for(auto x:g[v]) {
        dfs(x, last - 1, cost);
    }
    result = max(result, cost);
}

signed main() {

    int n;
    cin >> n;

    for(int i=2;i<=n;i++) {
        int p;
        cin >> p;
        g[p].emplace_back(i);
    }

    pre_calc(1);
    dfs(1, 0, 0);

    cout << result << endl;

    return 0;
}
