#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define int long long
const int MOD = 1e9 + 7;

int fastPow(int x, int p) {
    if (p == 0) return 1;
    if (p % 2 == 1) return fastPow(x, p - 1) * x % MOD;
    int q = fastPow(x, p / 2);
    return q * q % MOD;
}

vector<int> factorials;

void build() {
    factorials.resize(5e5 + 100, 1);
    for (int i = 2; i < factorials.size(); i++) {
        factorials[i] = factorials[i - 1] * i % MOD;
    }
}

int Cnk(int n, int k) {
    return (factorials[n] * fastPow(factorials[k], MOD - 2) % MOD * fastPow(factorials[n - k], MOD - 2)) % MOD;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    int cnt1 = 0, cnt2 = 0, cnt0 = 0;
    for (int i = 0; i < n; i++) {
        int a;
        cin >> a;
        if (a % 3 == 0) cnt0++;
        else if (a % 3 == 1) cnt1++;
        else cnt2++;
    }
    build();

    int ans = 0;
    if (cnt1 - cnt2 > 0 && cnt1 - cnt2 < 3) {
        ans = (ans + ((__int128_t) factorials[cnt1] * factorials[cnt2]) % MOD * Cnk(cnt0 + cnt1 + cnt2 - 1, cnt0)) % MOD * factorials[cnt0] % MOD;
    }
    if (cnt2 - cnt1 > 0 && cnt2 - cnt1 < 3) {
        ans = (ans + ((__int128_t) factorials[cnt1] * factorials[cnt2]) % MOD * Cnk(cnt0 + cnt1 + cnt2 - 1, cnt0)) % MOD * factorials[cnt0] % MOD;
    }
    cout << ans;
}
