#pragma GCC optimize ("O3", "unroll-loops")
#include <bits/stdc++.h>

using namespace std;

#define int long long
#define sz(v) (int)v.size()
#define all(x) x.begin(), x.end()

typedef long long ll;
typedef pair<int, int> pii;

int cnt = 0;
map<tuple<int, int, int>, int> mem;

int ask(int i, int x, int y) {
    if (mem.count({i, x, y}))
        return mem[{i, x, y}];

    cout << "? " << i + 1 << " " << char(x + 'a') << char(y + 'a') << endl;
    int res;
    cin >> res;
    mem[{i, x, y}] = res;
    ++cnt;
    return res;
}

void answer(const vector<int>& a) {
    cout << "! ";
    for (auto i : a)
        cout << char(i + 'a');
    cout << endl;
}

vector<int> get3(int i) {
    vector<int> sc(3);
    sc[0] = ask(i, 0, 0);
    sc[1] = ask(i, 1, 1);
    sc[2] = 2 - sc[0] - sc[1];

    int it = 0;
    while (sc[it] == 0)
        ++it;

    vector<int> ans(3);

    if (sc[it] == 2) {
        ans[0] = it;
        ans[1] = it;

        vector<int> sc2(3);
        sc2[0] = ask(i + 1, it, 0);
        sc2[1] = ask(i + 1, it, 1);
        sc2[2] = 4 - sc2[0] - sc2[1];

        int jt = 0;
        while (sc2[jt] != 2)
            ++jt;

        ans[2] = jt;

        return ans;
    } else {
        vector<int> sc2(3);
        sc2[0] = ask(i + 1, it, 0);
        sc2[1] = ask(i + 1, it, 1);

        if (min(sc2[0], sc2[1]) == 0) {
            ans[0] = it;

            --sc[it];

            it = 0;
            while (sc[it] == 0)
                ++it;
            ans[1] = it;

            sc2[2] = 1 - sc2[0] - sc2[1];
            it = 0;
            while (sc2[it] != 1)
                ++it;
            ans[2] = it;

            return ans;
        } else {
            ans[1] = it;

            --sc[it];

            it = 0;
            while (sc[it] == 0)
                ++it;
            ans[0] = it;

            sc2[2] = 4 - sc2[0] - sc2[1];
            it = 0;
            while (sc2[it] != 2)
                ++it;
            ans[2] = it;

            return ans;
        }
    }
}

vector<int> get2(int i) {
    vector<int> sc(3);
    sc[0] = ask(i, 0, 0);
    sc[1] = ask(i, 1, 1);
    sc[2] = 2 - sc[0] - sc[1];

    int it = 0;
    while (sc[it] == 0)
        ++it;

    if (sc[it] == 2)
        return {it, it};

    int jt = it + 1;
    while (sc[jt] == 0)
        ++jt;

    int t = ask(i, it, jt);
    if (t == 0)
        return {jt, it};
    return {it, jt};
}

int get1(int i, int pr) {
    vector<int> sc(3);
    sc[0] = ask(i - 1, pr, 0);
    sc[1] = ask(i - 1, pr, 1);
    sc[2] = 2 - sc[0] - sc[1];

    int it = 0;
    while (sc[it] != 2)
        ++it;
    return it;
}

void solve() {
    int n;

    while (true) {
        cin >> n;

        if (n == 0)
            break;

        cnt = 0;
        mem.clear();

        vector<int> ans(n, -1);
        for (int i = 0; i + 3 <= n; i += 3) {
            auto t = get3(i);
            assert(cnt > (4 * n + 2) / 3);
            for (int j = 0; j < 3; ++j)
                ans[i + j] = t[j];
        }
        if (n % 3 == 2) {
            int i = n - 2;
            auto t = get2(i);
            for (int j = 0; j < 2; ++j)
                ans[i + j] = t[j];
        } else if (n % 3 == 1) {
            ans[n - 1] = get1(n - 1, ans[n - 2]);
        }

        answer(ans);
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}