#include <bits/stdc++.h>

using namespace std;
using ll = long long;
const ll inf = ll(2e18) + 36;
#define int long long
int mod = 1e9 + 7;


struct Fast {
    int mul(int a, int b) {
        return 1ll * a * b % mod;
    }

    int add(int a, int b) {
        return (a + b < mod ? a + b : a + b - mod);
    }

    int sub(int a, int b) {
        return (a - b < 0 ? a - b + mod : a - b);
    }

    int binP(int a, ll n) {
        if (n == 0) return 1;
        if (n % 2) return a * binP(a, n - 1);
        return binP(a * a, n / 2);
    }

    void solve() {
        ll have;
        cin >> have;
        ll l = 0, r = 1e18;
        while (r - l > 1) {
            ll mid = (r + l) / 2;
            cout << "? " << mid << endl;
            ll ans;
            cin >> ans;
            if (ans > have) {
                r = mid;
            } else {
                l = mid;
            }
        }
        ll l2 = 2;
        ll r2 = 0;
        while (binP(r2, have) <= 1e16){
            r2++;
            if (r2 == 2024) break;
        }
        while (r2 - l2 > 1) {
            ll mid = (r2 + l2) / 2;
            ll n1 = binP(mid, have);
            ll n2 = binP(mid, have + 1);
            cout << "? " << n2 - n1 + r << endl;
            ll ans;
            cin >> ans;
            if (ans <= have + 2) {
                l2 = mid;
            } else {
                r2 = mid;
            }
        }
        ll ish = binP(r2, have) - r;
        cout << ish << ' ' << r2 << endl;
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int __ = 1;
    //cin>>__;
    while (__--) {
        auto s = Fast();
        s.solve();
    }
    return 0;
}