#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const int INF = 1e9;

#define int long long
#define pi pair<int, int>

int R = (1 << 17);

vector<int> db(R * 2);

void st(int v, int l, int r, int i) {
    if (l == i && l + 1 == r) {
        db[v] = (db[v] + 1) % 2;
        return;
    }
    if (i < l || i >= r) {
        return;
    }
    st(v * 2, l, (r + l) / 2, i);
    st(v * 2 + 1, (r + l) / 2, r, i);
    db[v] = db[v * 2] + db[v * 2 + 1];
}

int get(int v, int l, int r, int ql, int qr) {
    if (l >= ql && r <= qr) {
        return db[v];
    }
    if (r <= ql || l >= qr) {
        return 0;
    }
    return get(v * 2, l, (r + l) / 2, ql, qr) + get(v * 2 + 1, (r + l) / 2, r, ql, qr);
}

vector<bool> ds(R * 2);

bool get2(int v, int l, int r, int ql, int qr) {
    if (l >= ql && r <= qr) {
        return ds[v];
    }
    if (r <= ql || l >= qr) {
        return true;
    }
    return get2(v * 2, l, (r + l) / 2, ql, qr) && get2(v * 2 + 1, (r + l) / 2, r, ql, qr);
}

void st2(int v, int l, int r, int i, bool val) {
    if (l == i && l + 1 == r) {
        ds[v] = val;
        return;
    }
    if (i < l || i >= r) {
        return;
    }
    st2(v * 2, l, (r + l) / 2, i, val);
    st2(v * 2 + 1, (r + l) / 2, r, i, val);
    ds[v] = ds[v * 2] && ds[v * 2 + 1];
}


set<pair<pair<int, int>, bool>> sl, sr;

void add(int l, int r, bool ans) {
    sl.insert({{l, r}, ans});
    st2(1, 0, R, l, ans);
}

void del(int l, int r, bool ans) {
    sl.erase({{l, r}, ans});
    st2(1, 0, R, l, true);
}

void solveL() {
    int n;
    cin >> n;
    string s;
    cin >> s;
    for (int i = 0; i < n; i++) {
        if (s[i] == 'b') {
            st(1, 0, R, i);
        }
    }
//    vector<pair<int> aaa;
    int l = 0;
    for (int i = 1; i <= n; i++) {
        if (i == n) {
            int r = i - 1;
            int k = (r - l + 1);
            int kb = get(1, 0, R, l, r + 1);
            int ka = k - kb;
            add(l, r, ka >= kb);
            l = i;
        } else if (s[i] == 'b' && s[i - 1] == 'b') {
            int r = i - 1;
            int k = (r - l + 1);
            int kb = get(1, 0, R, l, r + 1);
            int ka = k - kb;
            add(l, r, ka >= kb);
            l = i;
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int t;
        cin >> t;
        if (t == 1) {
            int I;
            cin >> I;
            I--;
            auto x = sl.lower_bound({{I + 1, -1}, 0});
            x--;
            auto x1 = *x;
            int l = x1.first.first;
            int r = x1.first.second;
            vector<vector<int>> tod = {{x1.first.first, x1.first.second, x1.second}};
//            del(x1.first.first, x1.first.second, x1.second);
            if (x1.first.first == I && I > 0) {
                x--;
                auto x2 = *x;
                l = x2.first.first;
                tod.push_back({x2.first.first, x2.first.second, x2.second});
//                del();
                x++;
            }
            if (x1.first.second == I && I + 1 < n) {
                x++;
                auto x2 = *x;
                r = x2.first.second;
                tod.push_back({x2.first.first, x2.first.second, x2.second});
                x--;
            }
            for (auto xxx: tod) {
                del(xxx[0], xxx[1], xxx[2]);
            }
            set<int> aaa;
            if (I > 0) {
                aaa.insert(I);
            }
            if (I + 1 < n) {
                aaa.insert(I + 1);
            }
            aaa.insert(r + 1);
            st(1, 0, R, I);
            if (s[I] == 'a') {
                s[I] = 'b';
            } else {
                s[I] = 'a';
            }
            for (int i: aaa) {
                if (i == r + 1) {
                    int r1 = i - 1;
                    int k = (r1 - l + 1);
                    int kb = get(1, 0, R, l, r1 + 1);
                    int ka = k - kb;
                    add(l, r1, ka >= kb);
                    l = i;
                } else if (s[i] == 'b' && s[i - 1] == 'b') {
                    int r1 = i - 1;
                    int k = (r1 - l + 1);
                    int kb = get(1, 0, R, l, r1 + 1);
                    int ka = k - kb;
                    add(l, r1, ka >= kb);
                    l = i;
                }
            }


        } else {
            int l, r;
            cin >> l >> r;
            l--;
            r--;
            auto x1 = sl.lower_bound({{l + 1, -1}, 0});
            x1--;
            int l1, r1;
            if (x1->first.first == l) {
                l1 = l;
            } else {
                l1 = x1->first.second + 1;
            }
            l1 = min(l1, r + 1);
            auto x2 = sl.lower_bound({{r, -1}, 0});
            while (x2->first.first > r) {
                x2--;
            }
            if (x2->first.second > r) {
                if (x2 == sl.begin()) {
                    r1 = -1;
                } else {
                    r1 = x2->first.first - 1;
                }
            } else {
                r1 = x2->first.second;
            }
//            r1 = x2->first.second;
            bool ok = get2(1, 0, R, l1, r1 + 1);
            int k1 = l1 - l;
            int kb1 = get(1, 0, R, l, l1);
            if (kb1 > (k1 - kb1)) {
                ok = false;
            }
            k1 = r - r1;
            kb1 = get(1, 0, R, r1 + 1, r + 1);
            if (kb1 > (k1 - kb1)) {
                ok = false;
            }
            if (ok) {
                cout << "YES\n";
            } else {
                cout << "NO\n";
            }
        }
    }
}

#define pb push_back
#define fi first
#define se second
const int N = 1e6 + 9;
int x[N], y[N];
vector<int> vec[N];

bool cmp(pi a, pi b) {
    return a.fi * b.se - a.se * b.fi > 0;
}

int num[N];
pi gogo[N];

pi goplus(int o, int ps, vector<pi > &tv) {
    while (1) {
        //cout << ps << endl;
        if (ps == tv.size()) {
            ps = 0;
            continue;
        }
        if (tv[ps] == gogo[o]) {
            ps++;
            continue;
        }
        return tv[ps];
    }
}

pi gominus(int o, int ps, vector<pi > &tv) {
    while (1) {
        //cout << "2 " << ps << endl;
        if (ps == -1) {
            ps = (int) tv.size() - 1;
            continue;
        }
        if (tv[ps] == gogo[o]) {
            ps--;
            continue;
        }
        return tv[ps];
    }
}

vector<int> g[N];
bool used[N];
int global_ans = 0;

void dfs(int v, int p = -1, int sz = 1) {
    used[v] = 1;
    for (int u: vec[v]) {
        if (!used[u]) {
            dfs(u, v, sz + 1);
        } else {
            if (u == p) continue;
            global_ans += sz / 2;
        }
    }
}

int solve_v(int v) {
    if (vec[v].size() == 1) return 0;
    int global_ans = 0;
    vector<pi > tekvec;
    map<pi, int> go_back;
    int index = 0;
    for (int u: vec[v]) {
        cout << index << " " << u << endl;
        num[u] = index;
        int dx = x[u] - x[v], dy = y[u] - y[v];
        int G = gcd(abs(dx), abs(dy));
        dx /= G;
        dy /= G;
        gogo[index] = {dx, dy};
        tekvec.pb({dx, dy});
        go_back[{dx, dy}] = index;
        index++;
    }
    sort(tekvec.begin(), tekvec.end(), cmp);
    set<pi > st;
    for (int o = 0; o < index; o++) {
        pi tk = gogo[o];
        tk.fi *= -1;
        tk.se *= -1;
        int pos = lower_bound(tekvec.begin(), tekvec.end(), tk, cmp) - tekvec.begin();
        if (pos < tekvec.size() && tekvec[pos] == tk) {
            st.insert({o, go_back[tk]});
        } else {
            pi p = goplus(o, pos, tekvec);
            st.insert({o, go_back[p]});
            p = gominus(o, pos, tekvec);
            st.insert({o, go_back[p]});
        }
    }
    for (auto [u, v]: st) {
        cout << u << " " << v << endl;
    }
    int n = vec[v].size();
    for (int i = 0; i < n; i++) g[i].clear();
    for (auto [u, v]: st) {
        if (st.count({v, u})) {
            g[u].pb(v);
        }
    }
    for (int i = 0; i < n; i++) used[i] = 0;
    for (int i = 0; i < n; i++) {
        if (!used[i] && g[i].size() == 1) {
            dfs(i);
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) dfs(i);
    }
    return global_ans;
}

void solveJ() {
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> x[i] >> y[i];
    }
    for (int i = 1; i < n; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        vec[a].pb(b);
        vec[b].pb(a);
    }
    int ubr = 0;
    for (int v = 0; v < n; v++) {
        ubr += solve_v(v);
    }
    cout << n - 1 - ubr;
}

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
//    cin >> t;
    while (t--) {
        solveL();
    }


    return 0;
}
