#include <bits/stdc++.h>

using namespace std;
#define int long long
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
using pii = pair <int, int>;

template <typename t1, typename t2>
void mxr(t1& a, const t2& b) {
    if (b > a) {
        a = b;
    }
};
template <typename t1, typename t2>
void mnr(t1& a, const t2& b) {
    if (b < a) {
        a = b;
    }
};

signed main() {
#ifdef BUY
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    int n;
    cin >> n;
    set <pii> used;
    array <int, 2> rans{}, cans{};
    map <int, array <int, 2>> cntc, cntr;
    auto change = [&](int x, int y, int DIFF) {
        rans[x % 2] -= max(cntr[x][0], cntr[x][1]);
        cntr[x][y % 2] += DIFF;
        rans[x % 2] += max(cntr[x][0], cntr[x][1]);

        cans[y % 2] -= max(cntc[y][0], cntc[y][1]);
        cntc[y][x % 2] += DIFF;
        cans[y % 2] += max(cntc[y][0], cntc[y][1]);
    };
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        int diff = 1;
        if (used.count({x, y})) {
            diff = -1;
            used.erase({x, y});
        } else {
            used.insert({x, y});
        }
        change(x, y, diff);
        cout << max({rans[0], rans[1], cans[0], cans[1]}) << "\n";
    }
}