// solution.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include<vector>
#include <algorithm>
#include <cmath>

using namespace std;
using ll = long long;

void solve() {
	int n, add;
	cin >> n;
	vector<vector<int>> d(n), t(n, vector<int>(n, 0)), cop;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			cin >> add;
			d[i].push_back(add);
		}
	}
	cop = d;
	ll sm = n * (n * n + 1) / 2;
	for (int i = 0; i < n; ++i) {
		ll cur = 0;
		for (int j = 0; j < n; ++j) {
			cur += d[i][j];
		}
		if (cur == sm) {
			for (int j = 0; j < n; ++j) {
				t[i][j] = 1;
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		ll cur = 0;
		for (int j = 0; j < n; ++j) {
			cur += d[j][i];
		}
		if (cur == sm) {
			for (int j = 0; j < n; ++j) {
				t[j][i] = 1;
			}
		}
	}

	vector<pair<int, int>> q;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (!t[i][j]) {
				q.push_back({ i,j });
			}
		}
	}
	for (auto u : q) {
		for (auto v : q) {
			swap(cop[u.first][u.second], cop[v.first][v.second]);
			bool tt = 1;
			for (int i = 0; i < n && tt; ++i) {
				ll cur = 0;
				for (int j = 0; j < n; ++j) {
					cur += cop[i][j];
				}
				if (cur != sm) {
					tt = 0;
				}
			}
			for (int i = 0; i < n && tt; ++i) {
				ll cur = 0;
				for (int j = 0; j < n; ++j) {
					cur += cop[j][i];
				}
				if (cur != sm) {
					tt = 0;
				}
			}
			if (tt) {
				cout << u.first + 1 << " " << u.second + 1 << "\n" << v.first + 1 << " " << v.second + 1;
				return;
			}
			cop = d;
		}
	}
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(false);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}

}