#include <bits/stdc++.h>

#define fi first
#define se second

#define pb push_back
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

using namespace std;

template < typename T >
bool umn(T& a, T b) {
    return a > b ? a = b, 1 : 0;
}
template < typename T >
bool umx(T& a, T b) {
    return a < b ? a = b, 1 : 0;
}

using ll = long long;
using ld = long double;

const int N = 5e5 + 5;
const int inf = 1e9;
const ll INF = 1e18;

ll a[1005][1005];
int n;

ll sumi[1005];
ll sumj[1005];

bool check () {
    ll last = sumi[1];
    for (int i = 1; i <= n; ++ i) {
        if (last != sumi[i]) return false;
        if (last != sumj[i]) return false;
    }
    return true;
}

int main() {
#ifdef localy
    freopen ("input.txt", "r", stdin);
    freopen ("output.txt", "w", stdout);
#endif // localy
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> n;
    for (int i = 1; i <= n; ++ i) {
        for (int j = 1; j <= n; ++ j) {
            cin >> a[i][j];
        }
    }

    for (int i = 1; i <= n; ++ i) {
        for (int j = 1; j <= n; ++ j) {
            sumi[i] += a[i][j];
            sumj[i] += a[j][i];
        }
    }

    map < ll , ll > mp;

    for (int i = 1; i <= n; ++ i) {
        ++ mp[sumi[i]];
        ++ mp[sumj[i]];
    }

    ll s = 0;
    ll mx = 0;


    for (auto& it : mp) {
        umx (mx, it.se);
    }


    set < int > vsi;
    set < int > vsj;


    for (auto& it : mp) {
        if (n == 3 || it.se != mx) {
            s = it.fi;


            for (int i = 1; i <= n; ++ i) {
                if (sumi[i] == s) vsi.insert (i);
                if (sumj[i] == s) vsj.insert (i);
            }
        }
    }

    vector < int > vi;
    vector < int > vj;

    for (auto& it : vsi) vi.pb (it);
    for (auto& it : vsj) vj.pb (it);

    if (!sz(vi)) {
        for (int i = 1; i <= n; ++ i) {
            int x = i, x1 = i;
            int y = vj[0], y1 = vj[1];

            sumi[x] -= a[x][y];
            sumi[x] += a[x1][y1];
            sumi[x1] += a[x][y];
            sumi[x1] -= a[x1][y1];

            sumj[y] -= a[x][y];
            sumj[y] += a[x1][y1];
            sumj[y1] += a[x][y];
            sumj[y1] -= a[x1][y1];

            if (check ()) {
                cout << x << " " << y << "\n" << x1 << " " << y1 << "\n";
                return 0;
            }

            sumi[x] += a[x][y];
            sumi[x] -= a[x1][y1];
            sumi[x1] -= a[x][y];
            sumi[x1] += a[x1][y1];

            sumj[y] += a[x][y];
            sumj[y] -= a[x1][y1];
            sumj[y1] -= a[x][y];
            sumj[y1] += a[x1][y1];
        }
    }

    if (!sz(vj)) {
        for (int i = 1; i <= n; ++ i) {
            int x = vi[0], x1 = vi[1];
            int y = i, y1 = i;

            sumi[x] -= a[x][y];
            sumi[x] += a[x1][y1];
            sumi[x1] += a[x][y];
            sumi[x1] -= a[x1][y1];

            sumj[y] -= a[x][y];
            sumj[y] += a[x1][y1];
            sumj[y1] += a[x][y];
            sumj[y1] -= a[x1][y1];

            if (check ()) {
                cout << x << " " << y << "\n" << x1 << " " << y1 << "\n";
                return 0;
            }

            sumi[x] += a[x][y];
            sumi[x] -= a[x1][y1];
            sumi[x1] -= a[x][y];
            sumi[x1] += a[x1][y1];

            sumj[y] += a[x][y];
            sumj[y] -= a[x1][y1];
            sumj[y1] -= a[x][y];
            sumj[y1] += a[x1][y1];
        }
    }



    for (auto& x : vi) {
        for (auto& y : vj) {
            for (auto& x1 : vi) {
                for (auto& y1 : vj) {

                    sumi[x] -= a[x][y];
                    sumi[x] += a[x1][y1];
                    sumi[x1] += a[x][y];
                    sumi[x1] -= a[x1][y1];

                    sumj[y] -= a[x][y];
                    sumj[y] += a[x1][y1];
                    sumj[y1] += a[x][y];
                    sumj[y1] -= a[x1][y1];




                    if (check ()) {
                        cout << x << " " << y << "\n" << x1 << " " << y1 << "\n";
                        return 0;
                    }



                    sumi[x] += a[x][y];
                    sumi[x] -= a[x1][y1];
                    sumi[x1] -= a[x][y];
                    sumi[x1] += a[x1][y1];

                    sumj[y] += a[x][y];
                    sumj[y] -= a[x1][y1];
                    sumj[y1] -= a[x][y];
                    sumj[y1] += a[x1][y1];

                }
            }
        }
    }
    cout << 1 << " " << 1 << "\n" << 1 << " " << 1 << "\n";
    return 0;
}
