
#include <bits\stdc++.h>

using namespace std;
using ll = long long;
#define f(i, l, r) for (int i = (l); i < (r); i++)
#define pb push_back
#define int ll
#define sc second
#define ff first

const int mod = 1e9 + 7;

/*
vector<vector<int>> g;
vector<int> h, nl, siz;

void dfs(int v) {
    siz[v] = 1;
    if (g[v].empty()) {
        nl[v] = h[v];
        return;
    }
    for (auto &u : g[v]) {
            h[u] = h[v] + 1;
            dfs(u);
            nl[v] = min(nl[v], nl[u]);
            siz[v] += siz[u];
    }
}

vector<int> dp;
vector<unordered_map<int, int>> bdp;
void dfs2(int v) {
    if (g[v].empty()) {
        dp[v] = 1;
        bdp[v][h[v]] = 1;
        return;
    }

    int hg = -1;
    for (auto &u : g[v]) {
        dfs2(u);
        dp[v] = max(dp[v], dp[u]);

        if (hg == -1 || (siz[hg] < siz[u])) hg = u;
    }

    for (auto &u : g[v]) {
        if (u != hg) {
            for (auto &p : bdp[u]) {
                bdp[hg][p.first] = max(bdp[hg][p.first], p.second);
            }
            bdp[u].clear();
        }
    }
    swap(bdp[hg], bdp[v]);
    dp[v] = max(dp[v], bdp[v][nl[v]] + 1);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    int n; cin >> n;
    g.resize(n);
    h.assign(n, 0);
    nl.assign(n, n + 1);
    siz.assign(n, 0);
    for (int i = 0; i < n - 1; i++) {
        int p; cin >> p;
        g[p - 1].pb(i + 1);
    }

    dfs(0);
    //return 0;
    bdp.assign(n, {});
    dp.assign(n, 0);
    dfs2(0);
    cout << dp[0] << '\n';

    return 0;
}
*/
/*
int binpow(int a, int b) {
    int pw = a, ans = 1;
    while (b > 0) {
        if (b % 2) {
            ans *= pw;
            ans %= mod;
        }
        pw *= pw;
        pw %= mod;
        b /= 2;
    }
    return ans;
}

int rev(int a) {
    return binpow(a, mod - 2);
}

int divv(int a, int b) {
    return (a * rev(b)) % mod;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    vector<int> fact(100001, 1);
    for (int i = 2; i < 100001; i++) {
        fact[i] = (fact[i - 1] * i) % mod;
    }

    int n; cin >> n;
    vector<int> a(n);
    f (i, 0, n) cin >> a[i];

    map<int, int> cnt0, cnt1, cnt2;
    int c0=0,c1=0,c2=0;
    f (i, 0, n) {
        if (a[i] % 3 == 1) {c1++;cnt1[a[i]]++;}
        else if (a[i] % 3 == 0) {c0++; cnt0[a[i]]++;}
        else {c2++; cnt2[a[i]]++;}
    }
    if (c0 == n) {
        cout << "0\n";
        return 0;
    }

    int C0=fact[c0], C1=fact[c1], C2=fact[c2];
    for(auto&u:cnt0){
        C0 = divv(C0, fact[u.sc]);
    }
    for (auto &u : cnt1) {
        C1 = divv(C1, fact[u.sc]);
    }
    for (auto &u : cnt2) {
        C2 = divv(C2, fact[u.sc]);
    }

    int ans = ((C0 * C1) % mod * C2) % mod;

    int cntt1 = 1, cntt2 = 0;
    int cur = 1, vls = 0;
    for (int i = 1; i < c1 + c2; i++) {
        if (cur == 1) {
            cur = 2;
            cntt1++;
        } else {
            cur = 1;
            cntt2++;
        }
    }

    if (cntt1 == c1 && cntt2 == c2) {
        vls++;
    }
    cntt1 = 0; cntt2 = 1; cur = 2;
    for (int i = 1; i < c1 + c2; i++) {
        if (cur == 1) {
            cur = 2;
            cntt1++;
        } else {
            cur = 1;
            cntt2++;
        }
    }
    if (cntt1 == c1 && cntt2 == c2) {
        vls++;
    }
    ans *= vls;
    ans %= mod;

    ans *= divv(divv(fact[n - 1], fact[c0]), fact[n - 1 - c0]);
    ans %= mod;
    cout << ans << '\n';

    return 0;
}*/

signed main() {
    int n; cin >> n;
    if (n == 1) {
        cout << "2\n";
        return 0;
    }
    vector<vector<int>> dp(n + 1, vector<int>(n + 1, 0));
    dp[0][0] = 1;
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            if (j > i) continue;
            dp[i][j] = (dp[i - j][j] + dp[i - j][j - 1]) % mod;
        }
    }

    vector<vector<int>> dp2(n + 1, vector<int>(n + 3, 0));
    for (int j = 0; j <= n + 2; j++) dp2[0][j] = 1;

    for (int s = 1; s <= n; s++) {
        for (int fir = n; fir >= 1; fir--) {
            if (fir > s) {
                dp2[s][fir] = 0;
                continue;
            }
            dp2[s][fir] = ((fir == n ? 0 : dp2[s][fir + 1]) + dp2[s - fir][fir]) % mod;
        }
    }
    int ans = 0;
    for (int mex = 1; mex <= n; mex++) {
        for (int lsum = 0; lsum <= n; lsum++) {
            //cout << mex << ' ' << lsum << ' ' << (mex * (dp[lsum][mex - 1] * dp2[n - lsum][mex + 1]) % mod) % mod;
            ans += (mex * (dp[lsum][mex - 1] * dp2[n - lsum][mex + 1]) % mod) % mod;
            ans %= mod;
        }
    }

    cout << ans << '\n';
}