#include <bits/stdc++.h>

using namespace std;

const long long mod = 1e9 + 7;

int main()
{
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
    long long n;
    cin >> n;
    if(n == 1)
    {
        cout << 2;
        return 0;
    }
    vector<vector<long long>> dp(n + 1, vector<long long> (n + 1, 0));
    dp[0][0] = 1;
    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j <= i; j++)
        {
            dp[i][j] = (dp[i - j][j] + dp[i - j][j - 1]) % mod;
        }
    }
    vector<vector<long long>> dp2(n + 1, vector<long long> (n + 2, 0));
    for(int i = 0; i <= n + 1; i++)
    {
        dp2[0][i] = 1;
    }
    for(int i = 1; i <= n; i++)
    {
        for(int j = i; j >= 1; j--)
        {
            dp2[i][j] = (dp2[i][j + 1] + dp2[i - j][j]) % mod;
        }
    }
    long long ans = 0;
    for(long long mex = 1; mex <= n; mex++)
    {
        for(int j = 0; j <= n; j++)
        {
            ans += (mex * ((dp[j][mex - 1] * dp2[n - j][mex + 1]) % mod)) % mod;
            ans %= mod;
        }
    }
    cout << ans;
    return 0;
}
