#include <bits/stdc++.h>

#define int long long

using namespace std;

const int INF  = 1e9, MAXN = (1 << 18), mod = 1e9 + 7;

int bin_pow(int n, int p) {
    int ans = 1;
    while (p) {
        if (p & 1) {
            ans *= n;
            ans %= mod;
        }
        n *= n;
        n %= mod;
        p /= 2;
    }
    return ans;
}

signed main() {
    int n;
    cin >> n;
    vector<int> fact(1e5 + 1, 1);
    for (int i = 1; i < 1e5 + 1; i++) {
        fact[i] = fact[i - 1] * i;
        fact[i] %= mod;
    }
    vector<int> a(n);
    vector<int> cnt(3, 0);
    for (auto &el : a) {
        cin >> el;
        cnt[el % 3]++;
    }
    if (abs(cnt[1] - cnt[2]) > 2 || cnt[1] == cnt[2]) {
        cout << 0;
        return 0;
    }
    int ans = bin_pow((cnt[1] + cnt[2]), cnt[0]);
    ans *= fact[cnt[1]];
    ans %= mod;
    ans *= fact[cnt[2]];
    ans %= mod;
    ans *= fact[cnt[0]];
    ans %= mod;
    cout << ans;
}
// 1 2 0